/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case AND:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_QImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return pattern3 (x2); /* [-1, 1] */

    case PLUS:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_QImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!nonimmediate_operand (operands[2], E_QImode))
        return -1;
      res = pattern3 (x2);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case MINUS:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_QImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x4, 0);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_QImode))
        return -1;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      if (!nonimmediate_operand (operands[2], E_QImode))
        return -1;
      res = pattern2 (x2);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return 6;

    default:
      return -1;
    }
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32QImode:
      return pattern5 (x3, 
E_V32QImode); /* [-1, 0] */

    case E_V16HImode:
      if (pattern5 (x3, 
E_V16HImode) != 0)
        return -1;
      return 1;

    case E_V8SImode:
      if (pattern5 (x3, 
E_V8SImode) != 0)
        return -1;
      return 2;

    case E_V16SImode:
      if (pattern5 (x3, 
E_V16SImode) != 0)
        return -1;
      return 3;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      return 4;

    case E_V8DImode:
      if (pattern5 (x3, 
E_V8DImode) != 0)
        return -1;
      return 5;

    case E_V4DImode:
      if (pattern5 (x3, 
E_V4DImode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern5 (x3, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V64QImode:
      if (pattern5 (x3, 
E_V64QImode) != 0)
        return -1;
      return 8;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      return 9;

    case E_V32HImode:
      if (pattern5 (x3, 
E_V32HImode) != 0)
        return -1;
      return 10;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern42 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_TImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  return pattern41 (x2, 
E_DImode, 
E_TImode); /* [-1, 0] */
}

int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!flags_reg_operand (operands[0], E_VOIDmode))
    return -1;
  operands[1] = x2;
  if (!compare_operator (operands[1], E_VOIDmode))
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
    return -1;
  x7 = XEXP (x5, 1);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  x8 = XEXP (x5, 2);
  operands[4] = x8;
  if (!const_int_operand (operands[4], E_QImode))
    return -1;
  switch (GET_MODE (x5))
    {
    case E_HImode:
      return 0;

    case E_SImode:
      return 1;

    case E_DImode:
      return 2;

    default:
      return -1;
    }
}

int
pattern56 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern57 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern62 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      return pattern61 (x3, 
E_HFmode); /* [-1, 0] */

    case E_SFmode:
      if (pattern61 (x3, 
E_SFmode) != 0)
        return -1;
      return 1;

    case E_DFmode:
      if (pattern61 (x3, 
E_DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern70 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  return pattern69 (x1); /* [-1, 2] */
}

int
pattern76 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  switch (GET_CODE (x4))
    {
    case STRICT_LOW_PART:
      return pattern72 (x1, pnum_clobbers); /* [-1, 1] */

    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (pattern73 (x2, pnum_clobbers) != 0)
            return -1;
          return 2;

        case E_HImode:
          if (pattern74 (x2, 
E_HImode) != 0)
            return -1;
          return 3;

        case E_V2SFmode:
          if (pattern7 (x2, 
E_V2SFmode) != 0)
            return -1;
          return 4;

        case E_V2BFmode:
          if (pattern7 (x2, 
E_V2BFmode) != 0)
            return -1;
          return 5;

        case E_V4BFmode:
          if (pattern7 (x2, 
E_V4BFmode) != 0)
            return -1;
          return 6;

        case E_V2HFmode:
          if (pattern7 (x2, 
E_V2HFmode) != 0)
            return -1;
          return 7;

        case E_V4HFmode:
          if (pattern7 (x2, 
E_V4HFmode) != 0)
            return -1;
          return 8;

        case E_V8QImode:
          if (pattern8 (x2, 
E_V8QImode) != 0)
            return -1;
          return 9;

        case E_V4HImode:
          if (pattern8 (x2, 
E_V4HImode) != 0)
            return -1;
          return 10;

        case E_V2SImode:
          if (pattern8 (x2, 
E_V2SImode) != 0)
            return -1;
          return 11;

        case E_V4QImode:
          if (pattern75 (x2, pnum_clobbers, 
E_V4QImode) != 0)
            return -1;
          return 12;

        case E_V2QImode:
          if (pattern75 (x2, pnum_clobbers, 
E_V2QImode) != 0)
            return -1;
          return 13;

        case E_V2HImode:
          if (pattern75 (x2, pnum_clobbers, 
E_V2HImode) != 0)
            return -1;
          return 14;

        case E_BFmode:
          if (pattern7 (x2, 
E_BFmode) != 0)
            return -1;
          return 15;

        case E_HFmode:
          if (pattern7 (x2, 
E_HFmode) != 0)
            return -1;
          return 16;

        case E_SFmode:
          if (pattern7 (x2, 
E_SFmode) != 0)
            return -1;
          return 17;

        case E_DFmode:
          if (pattern7 (x2, 
E_DFmode) != 0)
            return -1;
          return 18;

        case E_TFmode:
          if (pattern25 (x2, 
E_TFmode) != 0)
            return -1;
          return 19;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern109 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          return 0;

        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode)
              || !nonmemory_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode)
              || !nonmemory_operand (operands[2], E_QImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nonmemory_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (x2))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern128 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern140 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!nonimmediate_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || GET_MODE (x2) != E_V16QImode
          || !nonimm_or_0_operand (operands[2], E_V16QImode)
          || !register_operand (operands[3], E_HImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16SImode:
          if (!register_operand (operands[1], E_V16SImode))
            return -1;
          return 0;

        case E_V16HImode:
          if (!register_operand (operands[1], E_V16HImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V16HImode:
      if (pattern139 (x1, 
E_V16HImode, 
E_HImode, 
E_V16SImode) != 0)
        return -1;
      return 2;

    case E_V8SImode:
      if (pattern139 (x1, 
E_V8SImode, 
E_QImode, 
E_V8DImode) != 0)
        return -1;
      return 3;

    case E_V8HImode:
      if (!nonimmediate_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || GET_MODE (x2) != E_V8HImode
          || !nonimm_or_0_operand (operands[2], E_V8HImode)
          || !register_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DImode:
          if (!register_operand (operands[1], E_V8DImode))
            return -1;
          return 4;

        case E_V8SImode:
          if (!register_operand (operands[1], E_V8SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_V32QImode:
      if (pattern139 (x1, 
E_V32QImode, 
E_SImode, 
E_V32HImode) != 0)
        return -1;
      return 6;

    case E_V4SImode:
      if (pattern139 (x1, 
E_V4SImode, 
E_QImode, 
E_V4DImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern158 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i2))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern163 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i2))
    return -1;
  return 0;
}

int
pattern166 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32QImode:
      return pattern165 (x3, 
E_V32HFmode, 
E_V64QImode, 
E_V32QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern165 (x3, 
E_V16HFmode, 
E_V32QImode, 
E_V16QImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern176 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HImode:
      return pattern172 (x3, 
E_V32HImode); /* [-1, 0] */

    case E_V16SImode:
      if (pattern172 (x3, 
E_V16SImode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (pattern172 (x3, 
E_V8DImode) != 0)
        return -1;
      return 2;

    case E_V16HImode:
      if (pattern172 (x3, 
E_V16HImode) != 0)
        return -1;
      return 3;

    case E_V8SImode:
      if (pattern172 (x3, 
E_V8SImode) != 0)
        return -1;
      return 4;

    case E_V4DImode:
      if (pattern172 (x3, 
E_V4DImode) != 0)
        return -1;
      return 5;

    case E_V8HImode:
      if (pattern172 (x3, 
E_V8HImode) != 0)
        return -1;
      return 6;

    case E_V4SImode:
      if (pattern172 (x3, 
E_V4SImode) != 0)
        return -1;
      return 7;

    case E_V2DImode:
      if (pattern172 (x3, 
E_V2DImode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern190 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_CONCAT)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != VEC_SELECT)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_CONCAT)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != PARALLEL)
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  x9 = XEXP (x3, 1);
  operands[2] = x9;
  x10 = XEXP (x6, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x6, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  switch (XVECLEN (x4, 0))
    {
    case 16:
      return pattern188 (x1); /* [-1, 0] */

    case 8:
      x12 = XVECEXP (x4, 0, 0);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XVECEXP (x4, 0, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x14 = XVECEXP (x4, 0, 2);
      if (GET_CODE (x14) != CONST_INT)
        return -1;
      x15 = XVECEXP (x4, 0, 3);
      if (GET_CODE (x15) != CONST_INT)
        return -1;
      x16 = XVECEXP (x4, 0, 4);
      if (GET_CODE (x16) != CONST_INT)
        return -1;
      x17 = XVECEXP (x4, 0, 5);
      if (GET_CODE (x17) != CONST_INT)
        return -1;
      x18 = XVECEXP (x4, 0, 6);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x19 = XVECEXP (x4, 0, 7);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || XVECLEN (x7, 0) != 8)
        return -1;
      x20 = XVECEXP (x7, 0, 0);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x21 = XVECEXP (x7, 0, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x22 = XVECEXP (x7, 0, 2);
      if (GET_CODE (x22) != CONST_INT)
        return -1;
      x23 = XVECEXP (x7, 0, 3);
      if (GET_CODE (x23) != CONST_INT)
        return -1;
      x24 = XVECEXP (x7, 0, 4);
      if (GET_CODE (x24) != CONST_INT)
        return -1;
      x25 = XVECEXP (x7, 0, 5);
      if (GET_CODE (x25) != CONST_INT)
        return -1;
      x26 = XVECEXP (x7, 0, 6);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x27 = XVECEXP (x7, 0, 7);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
        return -1;
      switch (XWINT (x14, 0))
        {
        case 4L:
          if (XWINT (x15, 0) != 6L
              || XWINT (x16, 0) != 8L
              || XWINT (x17, 0) != 10L
              || XWINT (x22, 0) != 5L
              || XWINT (x23, 0) != 7L
              || XWINT (x24, 0) != 9L
              || XWINT (x25, 0) != 11L
              || pattern189 (x1, 
E_V16HImode, 
E_V8HImode) != 0)
            return -1;
          return 1;

        case 8L:
          if (XWINT (x15, 0) != 10L
              || XWINT (x16, 0) != 4L
              || XWINT (x17, 0) != 6L
              || XWINT (x22, 0) != 9L
              || XWINT (x23, 0) != 11L
              || XWINT (x24, 0) != 5L
              || XWINT (x25, 0) != 7L
              || pattern187 (x1, 
E_V16SImode, 
E_V8SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case 4:
      x12 = XVECEXP (x4, 0, 0);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XVECEXP (x4, 0, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x14 = XVECEXP (x4, 0, 2);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x15 = XVECEXP (x4, 0, 3);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || XVECLEN (x7, 0) != 4)
        return -1;
      x20 = XVECEXP (x7, 0, 0);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x21 = XVECEXP (x7, 0, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x22 = XVECEXP (x7, 0, 2);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x23 = XVECEXP (x7, 0, 3);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || pattern189 (x1, 
E_V8SImode, 
E_V4SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern220 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UMOD)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  x9 = XEXP (x2, 0);
  operands[1] = x9;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  x11 = XEXP (x3, 1);
  if (!rtx_equal_p (x11, operands[3]))
    return -1;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
    case MEM:
      return 0;

    case CONST_INT:
      return 1;

    default:
      return -1;
    }
}

int
pattern230 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  return 0;
}

int
pattern238 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern237 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern237 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern237 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern237 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern249 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != VEC_SELECT)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern253 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[2] = x5;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x7 = XEXP (x5, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != ZERO_EXTRACT)
        return -1;
      x9 = XEXP (x8, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x10 = XEXP (x8, 2);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x11 = XEXP (x8, 0);
      operands[0] = x11;
      if (!int248_register_operand (operands[0], E_VOIDmode))
        return -1;
      x12 = XEXP (x5, 0);
      operands[1] = x12;
      if (!int248_register_operand (operands[1], E_VOIDmode))
        return -1;
      switch (GET_MODE (x8))
        {
        case E_HImode:
          if (GET_MODE (x2) != E_HImode
              || !extract_operator (operands[2], E_HImode))
            return -1;
          return 0;

        case E_SImode:
          if (GET_MODE (x2) != E_SImode
              || !extract_operator (operands[2], E_SImode))
            return -1;
          return 1;

        case E_DImode:
          if (GET_MODE (x2) != E_DImode
              || !extract_operator (operands[2], E_DImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern283 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern282 (x1); /* [-1, 1] */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 2;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 3;

        case E_SImode:
          if (pnum_clobbers == NULL
              || !nonimmediate_operand (operands[1], E_SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern296 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_V8QImode:
      return pattern99 (); /* [-1, 2] */

    case E_V4HImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode))
            return -1;
          return 3;

        case E_V4DImode:
          if (!register_operand (operands[1], E_V4DImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern308 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern316 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_all_ones_operand (operands[1], i1)
      || !const0_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1)
      || !const_0_to_7_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern322 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x1) != E_V16SFmode
          || !nonimmediate_operand (operands[1], E_V16SFmode))
        return -1;
      return 0;

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x1) != E_V8SFmode
          || !nonimmediate_operand (operands[1], E_V8SFmode))
        return -1;
      return 1;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x1) != E_V8DFmode
          || !nonimmediate_operand (operands[1], E_V8DFmode))
        return -1;
      return 3;

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x1) != E_V4DFmode
          || !nonimmediate_operand (operands[1], E_V4DFmode))
        return -1;
      return 4;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !nonimmediate_operand (operands[1], E_V2DFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern333 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern336 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !bcst_vector_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !bcst_vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern340 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  return 0;
}

int
pattern342 (rtx x1, int *pnum_clobbers, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern346 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  return pattern345 (x6); /* [-1, 5] */
}

int
pattern350 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  return pattern349 (x1); /* [-1, 5] */
}

int
pattern354 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[4], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern358 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17)
    return -1;
  x6 = XEXP (x4, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17
      || GET_MODE (x8) != E_CCmode)
    return -1;
  x9 = XEXP (x2, 0);
  operands[0] = x9;
  x10 = XEXP (x3, 1);
  operands[1] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return 0;

    case E_HImode:
      return 1;

    case E_SImode:
      return 2;

    case E_DImode:
      return 3;

    default:
      return -1;
    }
}

int
pattern367 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x9))
    {
    case SET:
      x10 = XEXP (x9, 0);
      operands[0] = x10;
      return 0;

    case CLOBBER:
      x10 = XEXP (x9, 0);
      operands[0] = x10;
      switch (GET_MODE (x6))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode)
              || !const_1_to_31_operand (operands[2], E_QImode)
              || !scratch_operand (operands[0], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode)
              || !const_1_to_31_operand (operands[2], E_QImode)
              || !scratch_operand (operands[0], E_HImode))
            return -1;
          return 2;

        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !const_1_to_31_operand (operands[2], E_QImode)
              || !scratch_operand (operands[0], E_SImode))
            return -1;
          return 3;

        case E_DImode:
          if (!nonimmediate_operand (operands[1], E_DImode)
              || !const_1_to_63_operand (operands[2], E_QImode)
              || !scratch_operand (operands[0], E_DImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern392 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern400 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern407 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern414 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!general_reg_operand (operands[0], i1)
      || GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (!commutative_operator (x3, i1))
    return -1;
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!memory_operand (operands[2], i1))
    return -1;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = XEXP (x2, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  return 0;
}

int
pattern425 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!nonimmediate_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nonimmediate_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern432 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  operands[3] = x5;
  if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  x7 = XEXP (x1, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return 0;

    case E_HImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern445 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !x86_64_general_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern450 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      return pattern449 (x1); /* [-1, 1] */

    case PLUS:
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
        return -1;
      res = pattern448 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case MINUS:
      x4 = XEXP (x3, 0);
      operands[3] = x4;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
        return -1;
      res = pattern16 (x1);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern466 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i4)
      || !nonimmediate_operand (operands[2], i3)
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern472 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[3] = x5;
  x6 = XEXP (x1, 1);
  switch (GET_CODE (x6))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x6;
      x7 = XEXP (x1, 2);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 1
          || XINT (x7, 1) != 224)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      operands[5] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (!register_operand (operands[0], E_V32HFmode)
              || GET_MODE (x1) != E_V32HFmode
              || GET_MODE (x2) != E_V32HFmode
              || !vector_operand (operands[1], E_V32HFmode)
              || !vector_operand (operands[2], E_V32HFmode)
              || !vector_operand (operands[3], E_V32HFmode)
              || !const0_operand (operands[4], E_V32HFmode)
              || GET_MODE (x7) != E_SImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          return 0;

        case E_V16HFmode:
          if (pattern470 (x1, 
E_HImode, 
E_V16HFmode) != 0)
            return -1;
          return 1;

        case E_V8HFmode:
          if (pattern470 (x1, 
E_QImode, 
E_V8HFmode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      x7 = XEXP (x1, 2);
      switch (GET_CODE (x7))
        {
        case UNSPEC:
          if (XVECLEN (x7, 0) != 1
              || XINT (x7, 1) != 224)
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          operands[4] = x8;
          if (!rtx_equal_p (x6, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (!register_operand (operands[0], E_V32HFmode)
                  || GET_MODE (x1) != E_V32HFmode
                  || GET_MODE (x2) != E_V32HFmode
                  || !vector_operand (operands[1], E_V32HFmode)
                  || !vector_operand (operands[2], E_V32HFmode)
                  || !vector_operand (operands[3], E_V32HFmode)
                  || GET_MODE (x7) != E_SImode
                  || !register_operand (operands[4], E_HImode))
                return -1;
              return 3;

            case E_V16HFmode:
              if (pattern471 (x1, 
E_HImode, 
E_V16HFmode) != 0)
                return -1;
              return 4;

            case E_V8HFmode:
              if (pattern471 (x1, 
E_QImode, 
E_V8HFmode) != 0)
                return -1;
              return 5;

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x7, 0) != 3L
              || !register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x1) != E_V8HFmode
              || GET_MODE (x2) != E_V8HFmode
              || !vector_operand (operands[1], E_V8HFmode)
              || !vector_operand (operands[2], E_V8HFmode)
              || !vector_operand (operands[3], E_V8HFmode)
              || !rtx_equal_p (x6, operands[2]))
            return -1;
          return 6;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern505 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !nonimm_or_0_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern512 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_V4QImode:
          return pattern511 (
E_V12QImode); /* [-1, 1] */

        case E_V2QImode:
          if (!register_operand (operands[1], E_V2DImode)
              || !const0_operand (operands[2], E_V14QImode))
            return -1;
          return 2;

        case E_V8QImode:
          if (!const0_operand (operands[2], E_V8QImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8SImode:
              if (!register_operand (operands[1], E_V8SImode))
                return -1;
              return 3;

            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode))
                return -1;
              return 4;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_V4HImode:
          res = pattern511 (
E_V4HImode);
          if (res >= 0)
            return res + 5; /* [5, 6] */
          return -1;

        case E_V2HImode:
          if (!register_operand (operands[1], E_V2DImode)
              || !const0_operand (operands[2], E_V6HImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V2DImode)
          || !const0_operand (operands[2], E_V2SImode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern534 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  x7 = XEXP (x1, 1);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern530 (x1, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern530 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern530 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V32BFmode:
      if (pattern530 (x1, 
E_V32BFmode) != 0)
        return -1;
      return 3;

    case E_V16BFmode:
      if (pattern530 (x1, 
E_V16BFmode) != 0)
        return -1;
      return 4;

    case E_V8BFmode:
      if (pattern530 (x1, 
E_V8BFmode) != 0)
        return -1;
      return 5;

    case E_V16SFmode:
      if (pattern530 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 6;

    case E_V8SFmode:
      if (pattern530 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 7;

    case E_V4SFmode:
      if (pattern530 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 8;

    case E_V8DFmode:
      if (pattern530 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 9;

    case E_V4DFmode:
      if (pattern530 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 10;

    case E_V2DFmode:
      if (pattern530 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern543 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_XFmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_XFmode))
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_XFmode))
    return -1;
  return 0;
}

int
pattern548 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V2SFmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 111)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_V2SFmode))
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_V2SFmode))
    return -1;
  x8 = XVECEXP (x3, 0, 1);
  operands[2] = x8;
  if (!nonimmediate_operand (operands[2], E_V2SFmode))
    return -1;
  return 0;
}

int
pattern558 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || pattern557 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern561 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern567 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_QImode)
    return -1;
  return 0;
}

int
pattern571 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || !register_operand (operands[1], E_SImode)
      || !register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern576 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  return pattern574 (x1); /* [-1, 3] */
}

int
pattern582 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  return 0;
}

int
pattern586 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 33)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 17
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XVECEXP (x1, 0, 0);
  x9 = XEXP (x8, 0);
  operands[0] = x9;
  return pattern585 (x1); /* [-1, 1] */
}

int
pattern593 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_V2DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 120
      || GET_MODE (x3) != E_V16QImode)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_V2DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 120
      || GET_MODE (x5) != E_V16QImode)
    return -1;
  return 0;
}

int
pattern602 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i2)
      || !const_int_operand (operands[2], E_QImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[3] = x4;
  if (!nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern609 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern615 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern620 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern626 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  operands[3] = x2;
  x3 = XEXP (x1, 0);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          return 0;

        case E_V16SImode:
          return 1;

        case E_V8DImode:
          return 2;

        case E_V16HImode:
          return 3;

        case E_V8SImode:
          return 4;

        case E_V4DImode:
          return 5;

        case E_V8HImode:
          return 6;

        case E_V4SImode:
          return 7;

        case E_V2DImode:
          return 8;

        default:
          return -1;
        }

    case VEC_SELECT:
      if (GET_MODE (x4) != E_V2SFmode)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 2)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x3) != E_V2DImode)
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      if (!nonimmediate_operand (operands[1], E_V4SFmode)
          || !nonimm_or_0_operand (operands[2], E_V2DImode)
          || !register_operand (operands[3], E_QImode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern642 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern650 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern654 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern659 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !vector_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !vector_all_ones_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern664 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != CONST_VECTOR
      || XVECLEN (x3, 0) != 2
      || GET_MODE (x3) != E_V2SImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode
      || !nonimmediate_operand (operands[1], E_V2DFmode))
    return -1;
  return 0;
}

int
pattern672 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
      || GET_MODE (x2) != i2)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return pattern27 (x1); /* [-1, 1] */
}

int
pattern681 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != SIGN_EXTEND)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != i1
      || pattern680 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern685 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !x86_64_general_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern689 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != ASHIFT
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x1, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  return 0;
}

int
pattern697 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case SUBREG:
      if (maybe_ne (SUBREG_BYTE (x4), 0)
          || GET_MODE (x4) != E_QImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != AND)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 17
          || GET_MODE (x7) != E_CCmode)
        return -1;
      return pattern695 (x3); /* [-1, 1] */

    case CONST_INT:
      operands[2] = x4;
      if (!const_0_to_255_operand (operands[2], E_VOIDmode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != UNSPEC
          || XVECLEN (x6, 0) != 1
          || XINT (x6, 1) != 175)
        return -1;
      x8 = XVECEXP (x6, 0, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      res = pattern696 (x3);
      if (res >= 0)
        return res + 2; /* [2, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern709 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern719 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XINT (x3, 1) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != i2
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_V16QImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != UNSPEC
      || XVECLEN (x7, 0) != i2
      || XINT (x7, 1) != i1
      || pattern718 (x6, 
E_CCmode, 
17) != 0)
    return -1;
  return 0;
}

int
pattern726 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[3] = x3;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[4] = x4;
  if (!register_operand (operands[4], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  x6 = PATTERN (peep2_next_insn (2));
  return pattern725 (x6, 
i1); /* [-1, 0] */
}

int
pattern737 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode)
          || !nonimmediate_operand (operands[2], E_V8HImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode)
          || !nonimmediate_operand (operands[2], E_V8SImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode)
          || !nonimmediate_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    case E_V8DImode:
      if (!register_operand (operands[1], E_V8DImode)
          || !nonimmediate_operand (operands[2], E_V8DImode))
        return -1;
      return 3;

    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode)
          || !nonimmediate_operand (operands[2], E_V4DImode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode)
          || !nonimmediate_operand (operands[2], E_V2DImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern757 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!int248_register_operand (operands[1], E_VOIDmode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  return pattern286 (x1); /* [-1, 1] */
}

int
pattern766 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern773 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 2);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XEXP (x4, 1);
  operands[3] = x8;
  x9 = XEXP (x4, 2);
  operands[4] = x9;
  if (!register_operand (operands[4], E_QImode))
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  operands[5] = x10;
  if (!const_4_or_8_to_11_operand (operands[5], E_SImode))
    return -1;
  return pattern772 (x1); /* [-1, 2] */
}

int
pattern784 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (!rtx_equal_p (x2, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern783 (x1, 
E_V64QImode, 
E_DImode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern783 (x1, 
E_V32QImode, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern783 (x1, 
E_V16QImode, 
E_HImode) != 0)
        return -1;
      return 2;

    case E_V32HImode:
      if (pattern783 (x1, 
E_V32HImode, 
E_SImode) != 0)
        return -1;
      return 3;

    case E_V16HImode:
      if (pattern783 (x1, 
E_V16HImode, 
E_HImode) != 0)
        return -1;
      return 4;

    case E_V8HImode:
      if (pattern783 (x1, 
E_V8HImode, 
E_QImode) != 0)
        return -1;
      return 5;

    case E_V16SImode:
      if (pattern783 (x1, 
E_V16SImode, 
E_HImode) != 0)
        return -1;
      return 6;

    case E_V8SImode:
      if (pattern783 (x1, 
E_V8SImode, 
E_QImode) != 0)
        return -1;
      return 7;

    case E_V4SImode:
      if (pattern783 (x1, 
E_V4SImode, 
E_QImode) != 0)
        return -1;
      return 8;

    case E_V8DImode:
      if (pattern783 (x1, 
E_V8DImode, 
E_QImode) != 0)
        return -1;
      return 9;

    case E_V4DImode:
      if (pattern783 (x1, 
E_V4DImode, 
E_QImode) != 0)
        return -1;
      return 10;

    case E_V2DImode:
      if (pattern783 (x1, 
E_V2DImode, 
E_QImode) != 0)
        return -1;
      return 11;

    case E_V32HFmode:
      if (pattern783 (x1, 
E_V32HFmode, 
E_SImode) != 0)
        return -1;
      return 12;

    case E_V16HFmode:
      if (pattern783 (x1, 
E_V16HFmode, 
E_HImode) != 0)
        return -1;
      return 13;

    case E_V8HFmode:
      if (pattern783 (x1, 
E_V8HFmode, 
E_QImode) != 0)
        return -1;
      return 14;

    case E_V32BFmode:
      if (pattern783 (x1, 
E_V32BFmode, 
E_SImode) != 0)
        return -1;
      return 15;

    case E_V16BFmode:
      if (pattern783 (x1, 
E_V16BFmode, 
E_HImode) != 0)
        return -1;
      return 16;

    case E_V8BFmode:
      if (pattern783 (x1, 
E_V8BFmode, 
E_QImode) != 0)
        return -1;
      return 17;

    case E_V16SFmode:
      if (pattern783 (x1, 
E_V16SFmode, 
E_HImode) != 0)
        return -1;
      return 18;

    case E_V8SFmode:
      if (pattern783 (x1, 
E_V8SFmode, 
E_QImode) != 0)
        return -1;
      return 19;

    case E_V4SFmode:
      if (pattern783 (x1, 
E_V4SFmode, 
E_QImode) != 0)
        return -1;
      return 20;

    case E_V8DFmode:
      if (pattern783 (x1, 
E_V8DFmode, 
E_QImode) != 0)
        return -1;
      return 21;

    case E_V4DFmode:
      if (pattern783 (x1, 
E_V4DFmode, 
E_QImode) != 0)
        return -1;
      return 22;

    case E_V2DFmode:
      if (pattern783 (x1, 
E_V2DFmode, 
E_QImode) != 0)
        return -1;
      return 23;

    default:
      return -1;
    }
}

int
pattern827 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_TFmode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_TFmode
      || !vector_operand (operands[1], E_TFmode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!vector_operand (operands[2], E_TFmode))
    return -1;
  return 0;
}

int
pattern834 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 3
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern837 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 4
      || peep2_current_count < 5)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  if (!register_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (!rtx_equal_p (x3, operands[0]))
    return -1;
  x4 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 2)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != XOR
      || GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x4, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17
      || GET_MODE (x8) != E_CCmode)
    return -1;
  x9 = XEXP (x5, 0);
  operands[4] = x9;
  if (!register_operand (operands[4], i1))
    return -1;
  x10 = XEXP (x6, 1);
  operands[2] = x10;
  if (!x86_64_nonmemory_operand (operands[2], i1))
    return -1;
  x11 = XEXP (x6, 0);
  if (!rtx_equal_p (x11, operands[4]))
    return -1;
  x12 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x12) != SET)
    return -1;
  x13 = XEXP (x12, 1);
  if (!rtx_equal_p (x13, operands[4]))
    return -1;
  x14 = XEXP (x12, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = PATTERN (peep2_next_insn (4));
  if (GET_CODE (x15) != SET)
    return -1;
  x16 = XEXP (x15, 1);
  if (GET_CODE (x16) != COMPARE
      || GET_MODE (x16) != E_CCZmode)
    return -1;
  x17 = XEXP (x15, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 17
      || GET_MODE (x17) != E_CCZmode)
    return -1;
  x18 = XEXP (x16, 0);
  operands[5] = x18;
  if (!register_operand (operands[5], i1))
    return -1;
  x19 = XEXP (x16, 1);
  operands[6] = x19;
  if (!x86_64_nonmemory_operand (operands[6], i1))
    return -1;
  return 0;
}

int
pattern859 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !bcst_vector_operand (operands[1], i1)
      || !bcst_vector_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !bcst_vector_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern868 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_DFmode:
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern876 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  if (XWINT (x2, 0) != 1L)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      return pattern624 (x1, 
E_V4SFmode); /* [-1, 0] */

    case E_V8HFmode:
      if (pattern624 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern886 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16HFmode)
      || GET_MODE (x1) != E_V16HFmode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V16HFmode
      || !nonimm_or_0_operand (operands[2], E_V16HFmode)
      || !register_operand (operands[3], E_HImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HImode:
      if (!vector_operand (operands[1], E_V16HImode))
        return -1;
      return 0;

    case E_V16SImode:
      if (!vector_operand (operands[1], E_V16SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern896 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (maybe_ne (SUBREG_BYTE (x4), 0)
      || !register_operand (operands[3], E_QImode))
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case VEC_CONCAT:
      if (GET_MODE (x5) != E_V2DImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!memory_operand (operands[1], E_DImode))
        return -1;
      x8 = XEXP (x3, 1);
      switch (XVECLEN (x8, 0))
        {
        case 8:
          x9 = XVECEXP (x8, 0, 0);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XVECEXP (x8, 0, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x11 = XVECEXP (x8, 0, 2);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x12 = XVECEXP (x8, 0, 3);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x13 = XVECEXP (x8, 0, 4);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
            return -1;
          x14 = XVECEXP (x8, 0, 5);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
            return -1;
          x15 = XVECEXP (x8, 0, 6);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
            return -1;
          x16 = XVECEXP (x8, 0, 7);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
              || GET_MODE (x3) != E_V8QImode
              || GET_MODE (x4) != E_V16QImode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              return pattern137 (x1, 
E_V8HImode); /* [-1, 0] */

            case E_V8SImode:
              if (pattern137 (x1, 
E_V8SImode) != 0)
                return -1;
              return 1;

            case E_V8DImode:
              if (pattern137 (x1, 
E_V8DImode) != 0)
                return -1;
              return 2;

            default:
              return -1;
            }

        case 4:
          res = pattern894 (x1, 
E_V8HImode, 
E_V4HImode);
          if (res >= 0)
            return res + 3; /* [3, 4] */
          return -1;

        case 2:
          if (pattern895 (x1, 
E_V4SImode, 
E_V2SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    case VEC_MERGE:
      if (GET_MODE (x5) != E_V4SImode)
        return -1;
      x7 = XEXP (x5, 0);
      if (GET_CODE (x7) != VEC_DUPLICATE
          || GET_MODE (x7) != E_V4SImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != CONST_VECTOR
          || XVECLEN (x6, 0) != 4
          || GET_MODE (x6) != E_V4SImode)
        return -1;
      x17 = XVECEXP (x6, 0, 0);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x18 = XVECEXP (x6, 0, 1);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XVECEXP (x6, 0, 2);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x20 = XVECEXP (x6, 0, 3);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x21 = XEXP (x5, 2);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x22 = XEXP (x7, 0);
      operands[1] = x22;
      if (!memory_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x3, 1);
      switch (XVECLEN (x8, 0))
        {
        case 4:
          res = pattern894 (x1, 
E_V16QImode, 
E_V4QImode);
          if (res >= 0)
            return res + 6; /* [6, 7] */
          return -1;

        case 2:
          if (pattern895 (x1, 
E_V8HImode, 
E_V2HImode) != 0)
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern947 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!immediate_operand (operands[1], i1)
      || GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!mask_reg_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (!rtx_equal_p (x3, operands[0]))
    return -1;
  return 0;
}

int
pattern954 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern960 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_HImode
          || !register_operand (operands[3], E_HImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!nonimm_or_0_operand (operands[1], E_V16QImode)
              || !nonimm_or_0_operand (operands[2], E_V16QImode))
            return -1;
          return 0;

        case E_V16HImode:
          if (!nonimm_or_0_operand (operands[1], E_V16HImode)
              || !nonimm_or_0_operand (operands[2], E_V16HImode))
            return -1;
          return 1;

        case E_V16SImode:
          if (!nonimm_or_0_operand (operands[1], E_V16SImode)
              || !nonimm_or_0_operand (operands[2], E_V16SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_QImode
          || !register_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!nonimm_or_0_operand (operands[1], E_V8HImode)
              || !nonimm_or_0_operand (operands[2], E_V8HImode))
            return -1;
          return 3;

        case E_V8SImode:
          if (!nonimm_or_0_operand (operands[1], E_V8SImode)
              || !nonimm_or_0_operand (operands[2], E_V8SImode))
            return -1;
          return 4;

        case E_V4SImode:
          if (!nonimm_or_0_operand (operands[1], E_V4SImode)
              || !nonimm_or_0_operand (operands[2], E_V4SImode))
            return -1;
          return 5;

        case E_V8DImode:
          if (!nonimm_or_0_operand (operands[1], E_V8DImode)
              || !nonimm_or_0_operand (operands[2], E_V8DImode))
            return -1;
          return 6;

        case E_V4DImode:
          if (!nonimm_or_0_operand (operands[1], E_V4DImode)
              || !nonimm_or_0_operand (operands[2], E_V4DImode))
            return -1;
          return 7;

        case E_V2DImode:
          if (!nonimm_or_0_operand (operands[1], E_V2DImode)
              || !nonimm_or_0_operand (operands[2], E_V2DImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern981 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !nonimm_or_0_operand (operands[1], E_V64QImode)
          || !nonimm_or_0_operand (operands[2], E_V64QImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V32QImode:
          if (!nonimm_or_0_operand (operands[1], E_V32QImode)
              || !nonimm_or_0_operand (operands[2], E_V32QImode))
            return -1;
          return 1;

        case E_V32HImode:
          if (!nonimm_or_0_operand (operands[1], E_V32HImode)
              || !nonimm_or_0_operand (operands[2], E_V32HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern991 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !register_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 2);
  if (!register_operand (x3, i1))
    return -1;
  return 0;
}

int
pattern1000 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern999 (x1, 
E_V8HImode, 
E_HImode); /* [-1, 0] */

    case E_V8HFmode:
      if (pattern999 (x1, 
E_V8HFmode, 
E_HFmode) != 0)
        return -1;
      return 1;

    case E_V8BFmode:
      if (pattern999 (x1, 
E_V8BFmode, 
E_BFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1009 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1016 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!const48_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern1010 (x1, 
E_V16SFmode, 
E_V16SImode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern1010 (x1, 
E_V8DFmode, 
E_V8SImode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_V8DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DFmode:
          if (!register_operand (operands[1], E_V8DFmode))
            return -1;
          return 2;

        case E_V8SFmode:
          if (!register_operand (operands[1], E_V8SFmode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1033 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_HImode:
      if (!register_operand (operands[4], E_HImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16SImode:
          if (!nonimmediate_operand (operands[1], E_V16SImode)
              || !nonimmediate_operand (operands[2], E_V16SImode)
              || !const_0_to_7_operand (operands[3], E_SImode))
            return -1;
          return 0;

        case E_V16HFmode:
          if (!nonimmediate_operand (operands[1], E_V16HFmode)
              || !nonimmediate_operand (operands[2], E_V16HFmode)
              || !const_0_to_31_operand (operands[3], E_SImode))
            return -1;
          return 1;

        case E_V16SFmode:
          if (!nonimmediate_operand (operands[1], E_V16SFmode)
              || !nonimmediate_operand (operands[2], E_V16SFmode)
              || !const_0_to_31_operand (operands[3], E_SImode))
            return -1;
          return 2;

        case E_V16QImode:
          if (!nonimmediate_operand (operands[1], E_V16QImode)
              || !nonimmediate_operand (operands[2], E_V16QImode)
              || !const_0_to_7_operand (operands[3], E_SImode))
            return -1;
          return 3;

        case E_V16HImode:
          if (!nonimmediate_operand (operands[1], E_V16HImode)
              || !nonimmediate_operand (operands[2], E_V16HImode)
              || !const_0_to_7_operand (operands[3], E_SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_QImode:
      if (!register_operand (operands[4], E_QImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8SImode:
          if (!nonimmediate_operand (operands[1], E_V8SImode)
              || !nonimmediate_operand (operands[2], E_V8SImode)
              || !const_0_to_7_operand (operands[3], E_SImode))
            return -1;
          return 5;

        case E_V4SImode:
          if (!nonimmediate_operand (operands[1], E_V4SImode)
              || !nonimmediate_operand (operands[2], E_V4SImode)
              || !const_0_to_7_operand (operands[3], E_SImode))
            return -1;
          return 6;

        case E_V8DImode:
          if (!nonimmediate_operand (operands[1], E_V8DImode)
              || !nonimmediate_operand (operands[2], E_V8DImode)
              || !const_0_to_7_operand (operands[3], E_SImode))
            return -1;
          return 7;

        case E_V4DImode:
          if (!nonimmediate_operand (operands[1], E_V4DImode)
              || !nonimmediate_operand (operands[2], E_V4DImode)
              || !const_0_to_7_operand (operands[3], E_SImode))
            return -1;
          return 8;

        case E_V2DImode:
          if (!nonimmediate_operand (operands[1], E_V2DImode)
              || !nonimmediate_operand (operands[2], E_V2DImode)
              || !const_0_to_7_operand (operands[3], E_SImode))
            return -1;
          return 9;

        case E_V8HFmode:
          if (!nonimmediate_operand (operands[1], E_V8HFmode)
              || !nonimmediate_operand (operands[2], E_V8HFmode)
              || !const_0_to_31_operand (operands[3], E_SImode))
            return -1;
          return 10;

        case E_V8SFmode:
          if (!nonimmediate_operand (operands[1], E_V8SFmode)
              || !nonimmediate_operand (operands[2], E_V8SFmode)
              || !const_0_to_31_operand (operands[3], E_SImode))
            return -1;
          return 11;

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !nonimmediate_operand (operands[2], E_V4SFmode)
              || !const_0_to_31_operand (operands[3], E_SImode))
            return -1;
          return 12;

        case E_V8DFmode:
          if (!nonimmediate_operand (operands[1], E_V8DFmode)
              || !nonimmediate_operand (operands[2], E_V8DFmode)
              || !const_0_to_31_operand (operands[3], E_SImode))
            return -1;
          return 13;

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !nonimmediate_operand (operands[2], E_V4DFmode)
              || !const_0_to_31_operand (operands[3], E_SImode))
            return -1;
          return 14;

        case E_V2DFmode:
          if (!nonimmediate_operand (operands[1], E_V2DFmode)
              || !nonimmediate_operand (operands[2], E_V2DFmode)
              || !const_0_to_31_operand (operands[3], E_SImode))
            return -1;
          return 15;

        case E_V8HImode:
          if (!nonimmediate_operand (operands[1], E_V8HImode)
              || !nonimmediate_operand (operands[2], E_V8HImode)
              || !const_0_to_7_operand (operands[3], E_SImode))
            return -1;
          return 16;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[4], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V32HFmode:
          if (!nonimmediate_operand (operands[1], E_V32HFmode)
              || !nonimmediate_operand (operands[2], E_V32HFmode)
              || !const_0_to_31_operand (operands[3], E_SImode))
            return -1;
          return 17;

        case E_V32QImode:
          if (!nonimmediate_operand (operands[1], E_V32QImode)
              || !nonimmediate_operand (operands[2], E_V32QImode)
              || !const_0_to_7_operand (operands[3], E_SImode))
            return -1;
          return 18;

        case E_V32HImode:
          if (!nonimmediate_operand (operands[1], E_V32HImode)
              || !nonimmediate_operand (operands[2], E_V32HImode)
              || !const_0_to_7_operand (operands[3], E_SImode))
            return -1;
          return 19;

        default:
          return -1;
        }

    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_V64QImode)
          || !nonimmediate_operand (operands[2], E_V64QImode)
          || !const_0_to_7_operand (operands[3], E_SImode)
          || !register_operand (operands[4], E_DImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_DImode)
        return -1;
      return 20;

    default:
      return -1;
    }
}

int
pattern1112 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i4
      || !register_operand (operands[1], i3)
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1117 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V8HFmode)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 224
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x2, 2);
  if (XWINT (x6, 0) != 3L
      || !register_operand (operands[0], E_V8HFmode)
      || GET_MODE (x1) != E_V8HFmode
      || GET_MODE (x2) != E_V8HFmode
      || GET_MODE (x3) != E_V8HFmode)
    return -1;
  x7 = XVECEXP (x4, 0, 0);
  operands[1] = x7;
  if (!nonimmediate_operand (operands[1], E_V8HFmode))
    return -1;
  x8 = XVECEXP (x4, 0, 1);
  operands[2] = x8;
  if (!register_operand (operands[2], E_V8HFmode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[3] = x9;
  if (!nonimm_or_0_operand (operands[3], E_V8HFmode))
    return -1;
  x10 = XVECEXP (x5, 0, 0);
  operands[4] = x10;
  if (!register_operand (operands[4], E_QImode))
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  operands[5] = x11;
  if (!const_4_or_8_to_11_operand (operands[5], E_SImode))
    return -1;
  x12 = XEXP (x2, 1);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  return 0;
}

int
pattern1138 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_QImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_QImode:
          return 1;

        case E_HImode:
          return 2;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_QImode:
          return 3;

        case E_HImode:
          return 4;

        case E_SImode:
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1155 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!int248_register_operand (operands[2], E_VOIDmode))
        return -1;
      return pattern1154 (x1); /* [-1, 3] */

    case PLUS:
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
        return -1;
      res = pattern1154 (x1);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case MINUS:
      x4 = XEXP (x3, 0);
      operands[3] = x4;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
        return -1;
      res = pattern205 (x1);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1172 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !const0_operand (operands[2], i2)
      || !vector_all_ones_operand (operands[3], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1179 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (!ix86_carry_flag_operator (x5, i1))
    return -1;
  operands[4] = x5;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17
      || GET_MODE (x8) != E_CCmode)
    return -1;
  x9 = XEXP (x5, 0);
  operands[3] = x9;
  if (!flags_reg_operand (operands[3], E_VOIDmode))
    return -1;
  x10 = XEXP (x3, 1);
  operands[2] = x10;
  if (!memory_operand (operands[2], i1))
    return -1;
  x11 = XEXP (x4, 1);
  if (!rtx_equal_p (x11, operands[0]))
    return -1;
  x12 = XEXP (x2, 0);
  return pattern1178 (x12, 
i1); /* [-1, 1] */
}

int
pattern1190 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_operator (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1195 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1203 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1209 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !vector_operand (operands[1], E_V16QImode)
          || !register_operand (operands[2], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V4SImode:
          if (!register_operand (operands[3], E_V4SImode)
              || !vector_all_ones_operand (operands[4], E_V4SImode))
            return -1;
          return 0;

        case E_V2DImode:
          if (!register_operand (operands[3], E_V2DImode)
              || !vector_all_ones_operand (operands[4], E_V2DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !vector_operand (operands[1], E_V32QImode)
          || !register_operand (operands[2], E_V32QImode)
          || GET_MODE (x2) != E_V32QImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V8SImode:
          if (!register_operand (operands[3], E_V8SImode)
              || !vector_all_ones_operand (operands[4], E_V8SImode))
            return -1;
          return 2;

        case E_V4DImode:
          if (!register_operand (operands[3], E_V4DImode)
              || !vector_all_ones_operand (operands[4], E_V4DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1225 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern1224 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern1224 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1234 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!mask_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !mask_reg_operand (operands[1], i1)
      || !mask_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1240 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 4
      || GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XEXP (x1, 0);
  operands[3] = x3;
  if (!memory_operand (operands[3], i1))
    return -1;
  x4 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x4, 0);
  operands[4] = x6;
  if (!memory_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1248 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!int248_register_operand (operands[1], E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!int248_register_operand (operands[2], E_VOIDmode))
    return -1;
  x9 = XEXP (x1, 0);
  switch (GET_CODE (x9))
    {
    case STRICT_LOW_PART:
      x10 = XEXP (x9, 0);
      operands[0] = x10;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      return pattern1247 (); /* [-1, 2] */

    case REG:
    case SUBREG:
      operands[0] = x9;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      res = pattern1247 ();
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1265 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[2], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1274 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1283 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1291 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!const48_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern1285 (x1, 
E_HImode, 
E_V16SImode, 
E_V16SFmode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern1285 (x1, 
E_QImode, 
E_V8SImode, 
E_V8DFmode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_V8DImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V8DImode
          || !nonimm_or_0_operand (operands[2], E_V8DImode)
          || !register_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DFmode:
          if (!register_operand (operands[1], E_V8DFmode))
            return -1;
          return 2;

        case E_V8SFmode:
          if (!register_operand (operands[1], E_V8SFmode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1305 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !const_1_to_31_operand (operands[2], E_QImode)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern1309 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      x4 = XEXP (x1, 1);
      return pattern1308 (x4, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x4 = XEXP (x1, 1);
      if (pattern1308 (x4, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1318 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || pattern557 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1324 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!mask_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !mask_reg_operand (operands[1], i1)
      || !const_int_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1330 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  x7 = XEXP (x2, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = PATTERN (peep2_next_insn (2));
  return pattern1329 (x8); /* [-1, 0] */
}

int
pattern1341 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !ix86_carry_flag_operator (operands[4], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1349 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return pattern1348 (); /* [-1, 3] */
}

int
pattern1352 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i2)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1361 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1369 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !bcst_vector_operand (operands[1], i1)
      || pattern1356 (
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1377 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1388 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern1395 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1403 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1408 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern1415 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern1414 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern1414 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1428 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !addsub_vm_operator (operands[6], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_operand (operands[3], i1)
      || !vector_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1435 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern1444 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1450 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], E_VOIDmode)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1459 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DFmode)
      || GET_MODE (x1) != E_V2DFmode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V2DFmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V2DFmode)
    return -1;
  return 0;
}

int
pattern1464 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SFmode)
      || GET_MODE (x1) != E_V4SFmode)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_V4HFmode:
      if (!memory_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V4BFmode:
      if (!memory_operand (operands[1], E_V8BFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1475 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode
      || !nonimmediate_operand (operands[3], E_SImode)
      || !register_operand (operands[1], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern1481 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[2]))
    return -1;
  x5 = XEXP (x3, 1);
  if (!rtx_equal_p (x5, operands[3]))
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x6))
    {
    case UNSPEC:
      if (XVECLEN (x6, 0) != 1
          || XINT (x6, 1) != 33)
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 0;

    case USE:
      x8 = XEXP (x6, 0);
      operands[4] = x8;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1496 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1506 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1518 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !ix86_carry_flag_operator (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1524 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1535 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const0_operand (operands[4], E_V4HFmode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4DFmode:
      if (!vector_operand (operands[1], E_V4DFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!vector_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1541 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !const_int_operand (operands[3], i2))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !x86_64_immediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern1555 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1559 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !x86_64_dwzext_immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1566 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1575 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x3, 2);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  x5 = XEXP (x2, 1);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  return 0;
}

int
pattern1586 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!vsib_mem_operator (operands[5], i1)
      || !register_operand (operands[6], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      return pattern1585 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1585 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1597 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[2], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1606 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !ix86_carry_flag_operator (operands[4], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1613 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[2]))
    return -1;
  x5 = XEXP (x3, 1);
  if (!rtx_equal_p (x5, operands[3]))
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  return pattern1550 (x6, pnum_clobbers); /* [-1, 2] */
}

int
pattern1623 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i3)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i3
      || !vector_operand (operands[1], i2))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i3
      || !vector_operand (operands[2], i2)
      || !const1_operand (operands[3], i2)
      || !nonimm_or_0_operand (operands[4], i2)
      || !register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1637 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[7], E_QImode)
      || !vsib_mem_operator (operands[6], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1636 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1636 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1651 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1660 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  if (!const_0_to_63_operand (operands[3], E_QImode))
    return -1;
  x7 = XEXP (x1, 0);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  return 0;
}

int
pattern1673 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  operands[4] = x4;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  x6 = XEXP (x2, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  return 0;
}

int
pattern1679 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1)
      || !register_operand (operands[5], i3))
    return -1;
  return 0;
}

int
pattern1689 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_7_operand (operands[2], E_VOIDmode)
      || !const_0_to_7_operand (operands[3], E_VOIDmode)
      || !const_0_to_7_operand (operands[4], E_VOIDmode)
      || !const_0_to_7_operand (operands[5], E_VOIDmode)
      || !const_0_to_7_operand (operands[6], E_VOIDmode)
      || !const_0_to_7_operand (operands[7], E_VOIDmode)
      || !const_0_to_7_operand (operands[8], E_VOIDmode)
      || !const_0_to_7_operand (operands[9], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1700 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V8SImode:
      if (!register_operand (operands[2], E_V8SImode))
        return -1;
      return 0;

    case E_V8DImode:
      if (!register_operand (operands[2], E_V8DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1708 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[4] = x6;
  if (!nonimmediate_operand (operands[4], E_V16QImode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[5] = x7;
  if (!register_operand (operands[5], E_SImode))
    return -1;
  x8 = XVECEXP (x3, 0, 4);
  operands[6] = x8;
  if (!const_0_to_255_operand (operands[6], E_SImode))
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_V16QImode))
    return -1;
  x11 = XEXP (x9, 1);
  x12 = XVECEXP (x11, 0, 0);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  x13 = XVECEXP (x11, 0, 1);
  if (!rtx_equal_p (x13, operands[3]))
    return -1;
  x14 = XVECEXP (x11, 0, 2);
  if (!rtx_equal_p (x14, operands[4]))
    return -1;
  x15 = XVECEXP (x11, 0, 3);
  if (!rtx_equal_p (x15, operands[5]))
    return -1;
  x16 = XVECEXP (x11, 0, 4);
  if (!rtx_equal_p (x16, operands[6]))
    return -1;
  x17 = XVECEXP (x1, 0, 2);
  x18 = XEXP (x17, 1);
  x19 = XVECEXP (x18, 0, 0);
  if (!rtx_equal_p (x19, operands[2]))
    return -1;
  x20 = XVECEXP (x18, 0, 1);
  if (!rtx_equal_p (x20, operands[3]))
    return -1;
  x21 = XVECEXP (x18, 0, 2);
  if (!rtx_equal_p (x21, operands[4]))
    return -1;
  x22 = XVECEXP (x18, 0, 3);
  if (!rtx_equal_p (x22, operands[5]))
    return -1;
  x23 = XVECEXP (x18, 0, 4);
  if (!rtx_equal_p (x23, operands[6]))
    return -1;
  return 0;
}

int
pattern1736 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !const_0_to_7_operand (operands[3], E_VOIDmode)
      || !const_0_to_7_operand (operands[4], E_VOIDmode)
      || !const_0_to_7_operand (operands[5], E_VOIDmode)
      || !const_0_to_7_operand (operands[6], E_VOIDmode)
      || !const_8_to_15_operand (operands[7], E_VOIDmode)
      || !const_8_to_15_operand (operands[8], E_VOIDmode)
      || !const_8_to_15_operand (operands[9], E_VOIDmode)
      || !const_8_to_15_operand (operands[10], E_VOIDmode)
      || !nonimm_or_0_operand (operands[11], i1))
    return -1;
  return 0;
}

int
pattern1751 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V16SImode:
      return pattern1749 (
E_HImode, 
E_V16SFmode, 
E_V16SImode); /* [-1, 0] */

    case E_V8DImode:
      if (pattern1749 (
E_QImode, 
E_V8SFmode, 
E_V8DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1759 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1765 (rtx x1, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 12);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 13);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 14);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 15);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x6 = XVECEXP (x1, 0, 16);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x7 = XVECEXP (x1, 0, 17);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
    return -1;
  x8 = XVECEXP (x1, 0, 18);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
    return -1;
  x9 = XVECEXP (x1, 0, 19);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
    return -1;
  return 0;
}

int
pattern1780 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1794 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[5], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!vsib_address_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!vsib_address_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1801 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[4], i1)
      || !register_operand (operands[5], i1)
      || !register_operand (operands[6], i1)
      || !register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1805 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonmemory_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern1811 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_15_operand (operands[2], E_VOIDmode)
      || !const_0_to_15_operand (operands[3], E_VOIDmode)
      || !const_0_to_15_operand (operands[4], E_VOIDmode)
      || !const_0_to_15_operand (operands[5], E_VOIDmode)
      || !const_0_to_15_operand (operands[6], E_VOIDmode)
      || !const_0_to_15_operand (operands[7], E_VOIDmode)
      || !const_0_to_15_operand (operands[8], E_VOIDmode)
      || !const_0_to_15_operand (operands[9], E_VOIDmode)
      || !const_0_to_15_operand (operands[10], E_VOIDmode)
      || !const_0_to_15_operand (operands[11], E_VOIDmode)
      || !const_0_to_15_operand (operands[12], E_VOIDmode)
      || !const_0_to_15_operand (operands[13], E_VOIDmode)
      || !const_0_to_15_operand (operands[14], E_VOIDmode)
      || !const_0_to_15_operand (operands[15], E_VOIDmode)
      || !const_0_to_15_operand (operands[16], E_VOIDmode)
      || !const_0_to_15_operand (operands[17], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1824 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SIGN_EXTEND
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != VEC_SELECT
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  return 0;
}

int
pattern1828 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[6], i1)
      || !register_operand (operands[4], i1)
      || !register_operand (operands[5], i1)
      || !register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1834 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_15_operand (operands[4], E_VOIDmode)
      || !const_0_to_15_operand (operands[5], E_VOIDmode)
      || !const_0_to_15_operand (operands[6], E_VOIDmode)
      || !const_0_to_15_operand (operands[7], E_VOIDmode)
      || !const_0_to_15_operand (operands[8], E_VOIDmode)
      || !const_0_to_15_operand (operands[9], E_VOIDmode)
      || !const_0_to_15_operand (operands[10], E_VOIDmode)
      || !const_16_to_31_operand (operands[11], E_VOIDmode)
      || !const_16_to_31_operand (operands[12], E_VOIDmode)
      || !const_16_to_31_operand (operands[13], E_VOIDmode)
      || !const_16_to_31_operand (operands[14], E_VOIDmode)
      || !const_16_to_31_operand (operands[15], E_VOIDmode)
      || !const_16_to_31_operand (operands[16], E_VOIDmode)
      || !const_16_to_31_operand (operands[17], E_VOIDmode)
      || !const_16_to_31_operand (operands[18], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1844 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
    return -1;
  return 0;
}

int
pattern1854 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!x86_64_immediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern1858 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_operator (operands[4], i2))
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_MODE (x7) != i2
      || !x86_64_sext_operand (operands[2], i1)
      || pattern1856 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1866 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 24);
  if (XWINT (x2, 0) != 24L)
    return -1;
  x3 = XVECEXP (x1, 0, 25);
  if (XWINT (x3, 0) != 25L)
    return -1;
  x4 = XVECEXP (x1, 0, 26);
  if (XWINT (x4, 0) != 26L)
    return -1;
  x5 = XVECEXP (x1, 0, 27);
  if (XWINT (x5, 0) != 27L)
    return -1;
  return 0;
}

int
pattern1868 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3
      || !register_operand (operands[1], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i3
      || !vector_operand (operands[2], i2)
      || !nonimm_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  if (pattern56 (x1, 
E_CCFPmode) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x3) != E_CCFPmode)
    return -1;
  switch (GET_CODE (x3))
    {
    case COMPARE:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[0] = x4;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_XFmode:
              if (!register_operand (operands[0], E_XFmode)
                  || !register_operand (operands[1], E_XFmode)
                  || !
#line 2031 "../../gcc/config/i386/i386.md"
(TARGET_80387 && TARGET_CMOVE))
                return -1;
              return 49; /* *cmpiuxf_i387 */

            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || !register_ssemem_operand (operands[1], E_SFmode)
                  || !
#line 2071 "../../gcc/config/i386/i386.md"
((SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)
   || (TARGET_80387 && TARGET_CMOVE)))
                return -1;
              return 57; /* *cmpiusf */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || !register_ssemem_operand (operands[1], E_DFmode)
                  || !
#line 2071 "../../gcc/config/i386/i386.md"
((SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)
   || (TARGET_80387 && TARGET_CMOVE)))
                return -1;
              return 59; /* *cmpiudf */

            case E_HFmode:
              if (!register_operand (operands[0], E_HFmode)
                  || !nonimmediate_operand (operands[1], E_HFmode)
                  || !
#line 2108 "../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
                return -1;
              return 61; /* *cmpiuhf */

            default:
              return -1;
            }

        case VEC_SELECT:
          if (pattern598 (x3) != 0)
            return -1;
          x6 = XEXP (x4, 0);
          operands[0] = x6;
          x5 = XEXP (x3, 1);
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          switch (GET_MODE (x4))
            {
            case E_HFmode:
              if (!register_operand (operands[0], E_V8HFmode)
                  || GET_MODE (x5) != E_HFmode
                  || !nonimmediate_operand (operands[1], E_V8HFmode)
                  || !(
#line 4948 "../../gcc/config/i386/sse.md"
(SSE_FLOAT_MODE_P (HFmode) || HFmode == E_HFmode) && 
#line 1357 "../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3653; /* avx512fp16_ucomi */

            case E_SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x5) != E_SFmode
                  || !nonimmediate_operand (operands[1], E_V4SFmode)
                  || !
#line 4948 "../../gcc/config/i386/sse.md"
(SSE_FLOAT_MODE_P (SFmode) || SFmode == E_HFmode))
                return -1;
              return 3657; /* sse_ucomi */

            case E_DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x5) != E_DFmode
                  || !nonimmediate_operand (operands[1], E_V2DFmode)
                  || !
#line 4948 "../../gcc/config/i386/sse.md"
(SSE_FLOAT_MODE_P (DFmode) || DFmode == E_HFmode))
                return -1;
              return 3661; /* sse2_ucomi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x3, 0))
        {
        case 1:
          if (XINT (x3, 1) != 45)
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x8) != COMPARE
              || GET_MODE (x8) != E_CCFPmode)
            return -1;
          x9 = XEXP (x8, 0);
          operands[0] = x9;
          x10 = XEXP (x8, 1);
          operands[1] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || !nonimmediate_operand (operands[1], E_SFmode)
                  || !
#line 2047 "../../gcc/config/i386/i386.md"
(TARGET_AVX10_2))
                return -1;
              return 51; /* *cmpxusf */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || !nonimmediate_operand (operands[1], E_DFmode)
                  || !
#line 2047 "../../gcc/config/i386/i386.md"
(TARGET_AVX10_2))
                return -1;
              return 53; /* *cmpxudf */

            case E_HFmode:
              if (!register_operand (operands[0], E_HFmode)
                  || !nonimmediate_operand (operands[1], E_HFmode)
                  || !
#line 2060 "../../gcc/config/i386/i386.md"
(TARGET_AVX10_2))
                return -1;
              return 55; /* *cmpxuhf */

            default:
              return -1;
            }

        case 2:
          if (XINT (x3, 1) != 62
              || pattern840 (x3) != 0)
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          x9 = XEXP (x8, 0);
          operands[0] = x9;
          x11 = XVECEXP (x3, 0, 1);
          x12 = XEXP (x11, 0);
          operands[1] = x12;
          switch (GET_MODE (x8))
            {
            case E_HFmode:
              if (!register_operand (operands[0], E_V8HFmode)
                  || GET_MODE (x11) != E_HFmode
                  || !nonimmediate_operand (operands[1], E_V8HFmode)
                  || !(
#line 4933 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 1357 "../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3641; /* avx10_2_ucomxhf */

            case E_SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x11) != E_SFmode
                  || !nonimmediate_operand (operands[1], E_V4SFmode)
                  || !
#line 4933 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 3645; /* avx10_2_ucomxsf */

            case E_DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x11) != E_DFmode
                  || !nonimmediate_operand (operands[1], E_V2DFmode)
                  || !
#line 4933 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 3649; /* avx10_2_ucomxdf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode))
        return -1;
      if (general_operand (operands[1], E_QImode)
          && 
#line 3443 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
        return 111; /* *movstrictqi_1 */
      if (pnum_clobbers == NULL
          || !const0_operand (operands[1], E_QImode)
          || !
#line 3452 "../../gcc/config/i386/i386.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 113; /* *movstrictqi_xor */

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      if (general_operand (operands[1], E_HImode)
          && 
#line 3443 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
        return 112; /* *movstricthi_1 */
      if (pnum_clobbers == NULL
          || !const0_operand (operands[1], E_HImode)
          || !
#line 3452 "../../gcc/config/i386/i386.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 114; /* *movstricthi_xor */

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_CODE (x2))
    {
    case SIGN_EXTRACT:
      x4 = XEXP (x2, 1);
      switch (XWINT (x4, 0))
        {
        case 8L:
          x5 = XEXP (x2, 2);
          if (XWINT (x5, 0) != 8L
              || !int248_register_operand (operands[1], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode)
                return -1;
              return 118; /* *extvhi */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode)
                return -1;
              return 119; /* *extvsi */

            default:
              return -1;
            }

        case 1L:
          if (pnum_clobbers == NULL)
            return -1;
          x5 = XEXP (x2, 2);
          if (XWINT (x5, 0) != 0L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !register_operand (operands[1], E_SImode))
                return -1;
              *pnum_clobbers = 1;
              return 120; /* *extvsi_1_0 */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 121; /* *extvdi_1_0 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x4 = XEXP (x2, 1);
      if (XWINT (x4, 0) != 8L)
        return -1;
      x5 = XEXP (x2, 2);
      if (XWINT (x5, 0) != 8L
          || !int248_register_operand (operands[1], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode)
            return -1;
          return 122; /* *extzvhi */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          return 123; /* *extzvsi */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !
#line 1166 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 124; /* *extzvdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  res = recog_19 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (XWINT (x4, 0) != 8L
      || XWINT (x3, 0) != 8L
      || pattern421 (x5) != 0)
    return -1;
  x6 = XEXP (x2, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      if (!int248_register_operand (operands[1], E_VOIDmode))
        return -1;
      operands[2] = x2;
      switch (GET_MODE (x5))
        {
        case E_HImode:
          if (!extract_operator (operands[2], E_HImode))
            return -1;
          return 134; /* *insvqi_2 */

        case E_SImode:
          if (!extract_operator (operands[2], E_SImode))
            return -1;
          return 135; /* *insvqi_2 */

        case E_DImode:
          if (!extract_operator (operands[2], E_DImode)
              || !
#line 1166 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 136; /* *insvqi_2 */

        default:
          return -1;
        }

    case AND:
      switch (pattern1186 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 13232 "../../gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
            return -1;
          *pnum_clobbers = 1;
          return 800; /* *andqi_exthi_3 */

        case 1:
          if (!
#line 13232 "../../gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
            return -1;
          *pnum_clobbers = 1;
          return 803; /* *andqi_extsi_3 */

        case 2:
          if (!(
#line 13232 "../../gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])) && 
#line 1166 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 806; /* *andqi_extdi_3 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern1186 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 13232 "../../gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
            return -1;
          *pnum_clobbers = 1;
          return 801; /* *iorqi_exthi_3 */

        case 1:
          if (!
#line 13232 "../../gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
            return -1;
          *pnum_clobbers = 1;
          return 804; /* *iorqi_extsi_3 */

        case 2:
          if (!(
#line 13232 "../../gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])) && 
#line 1166 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 807; /* *iorqi_extdi_3 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern1186 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 13232 "../../gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
            return -1;
          *pnum_clobbers = 1;
          return 802; /* *xorqi_exthi_3 */

        case 1:
          if (!
#line 13232 "../../gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
            return -1;
          *pnum_clobbers = 1;
          return 805; /* *xorqi_extsi_3 */

        case 2:
          if (!(
#line 13232 "../../gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])) && 
#line 1166 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 808; /* *xorqi_extdi_3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern1 (x1, pnum_clobbers))
    {
    case 0:
      if (!(
#line 16647 "../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1238 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1128; /* *lshrti3_doubleword_mask_1 */

    case 1:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
          switch (pattern257 (x1))
            {
            case 0:
              return 137; /* *insvqi_3 */

            case 1:
              return 139; /* *insvqi_3 */

            case 2:
              if (
#line 1166 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return 141; /* *insvqi_3 */
              break;

            default:
              break;
            }
          break;

        case SUBREG:
          if (pnum_clobbers != NULL
              && pattern423 (x1, 
E_TImode) == 0
              && (
#line 16586 "../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1238 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1124; /* *lshrti3_doubleword_mask */
            }
          break;

        default:
          break;
        }
      operands[2] = x3;
      switch (pattern258 (x1, pnum_clobbers))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (pnum_clobbers == NULL
                  || pattern734 (x2, 
E_TImode, 
E_QImode) != 0
                  || !
#line 1198 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 1132; /* lshrti3_doubleword */

            case E_QImode:
              if (pattern620 (x2, 
E_QImode) != 0)
                return -1;
              if (
#line 17565 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, QImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
                return 1212; /* *lshrqi3_1_nf */
              if (pnum_clobbers == NULL
                  || !
#line 17565 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, QImode, operands, TARGET_APX_NDD)
   && true))
                return -1;
              *pnum_clobbers = 1;
              return 1213; /* *lshrqi3_1 */

            case E_HImode:
              if (pattern620 (x2, 
E_HImode) != 0)
                return -1;
              if (
#line 17603 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, HImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
                return 1214; /* *lshrhi3_1_nf */
              if (pnum_clobbers == NULL
                  || !
#line 17603 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, HImode, operands, TARGET_APX_NDD)
   && true))
                return -1;
              *pnum_clobbers = 1;
              return 1215; /* *lshrhi3_1 */

            case E_V4HImode:
              if (pattern734 (x2, 
E_V4HImode, 
E_DImode) != 0
                  || !
#line 3891 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
                return -1;
              return 2203; /* mmx_lshrv4hi3 */

            case E_V2SImode:
              if (pattern734 (x2, 
E_V2SImode, 
E_DImode) != 0
                  || !
#line 3891 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
                return -1;
              return 2205; /* mmx_lshrv2si3 */

            case E_V1DImode:
              if (pattern734 (x2, 
E_V1DImode, 
E_DImode) != 0
                  || !
#line 3891 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
                return -1;
              return 2207; /* mmx_lshrv1di3 */

            case E_V1SImode:
              if (pattern734 (x2, 
E_V1SImode, 
E_DImode) != 0
                  || !
#line 3928 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return -1;
              return 2209; /* mmx_lshrv1si3 */

            case E_V2HImode:
              if (pattern734 (x2, 
E_V2HImode, 
E_DImode) != 0
                  || !
#line 3945 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return -1;
              return 2211; /* lshrv2hi3 */

            case E_V2QImode:
              if (pnum_clobbers == NULL
                  || pattern734 (x2, 
E_V2QImode, 
E_QImode) != 0
                  || !
#line 4007 "../../gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size))
                return -1;
              *pnum_clobbers = 1;
              return 2215; /* lshrv2qi3 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 17642 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          *pnum_clobbers = 1;
          return 1216; /* *lshrqi3_1_slp */

        case 2:
          if (!
#line 17642 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          *pnum_clobbers = 1;
          return 1218; /* *lshrhi3_1_slp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x6;
          switch (pattern69 (x2))
            {
            case 0:
              if (!
#line 3706 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && CONST_WIDE_INT_P (operands[3])
   && CONST_WIDE_INT_NUNITS (operands[3]) == 2
   && CONST_WIDE_INT_ELT (operands[3], 0) == -1
   && CONST_WIDE_INT_ELT (operands[3], 1) == 0))
                return -1;
              return 145; /* *insvti_highpart_1 */

            case 1:
              if (!
#line 3728 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && CONST_WIDE_INT_P (operands[3])
   && CONST_WIDE_INT_NUNITS (operands[3]) == 2
   && CONST_WIDE_INT_ELT (operands[3], 0) == 0
   && CONST_WIDE_INT_ELT (operands[3], 1) == -1))
                return -1;
              return 148; /* *insvti_lowpart_1 */

            case 2:
              if (!
#line 3750 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT
   && CONST_INT_P (operands[3])
   && UINTVAL (operands[3]) == 0xffffffff00000000ll))
                return -1;
              return 151; /* *insvdi_lowpart_1 */

            default:
              return -1;
            }

        case XOR:
          if (pnum_clobbers == NULL
              || GET_MODE (x6) != E_HImode
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          if (!nonimmediate_operand (operands[2], E_HImode)
              || !nonimmediate_operand (operands[3], E_HImode))
            return -1;
          x9 = XEXP (x2, 1);
          if (!rtx_equal_p (x9, operands[1])
              || !
#line 13688 "../../gcc/config/i386/i386.md"
(TARGET_BMI && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 840; /* *xor2andn */

        default:
          return -1;
        }

    case ASHIFT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          switch (pattern603 (x2))
            {
            case 0:
              if (!
#line 8017 "../../gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && ((unsigned HOST_WIDE_INT) INTVAL (operands[3])
       < (HOST_WIDE_INT_1U << INTVAL (operands[2])))))
                return -1;
              return 373; /* *leaqi_general_4 */

            case 1:
              if (!
#line 8017 "../../gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && ((unsigned HOST_WIDE_INT) INTVAL (operands[3])
       < (HOST_WIDE_INT_1U << INTVAL (operands[2])))))
                return -1;
              return 375; /* *leahi_general_4 */

            case 2:
              if (!(
#line 14141 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 16 * BITS_PER_UNIT / 2
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1198 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 933; /* *concatditi3_5 */

            case 3:
              if (!(
#line 14064 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT) && 
#line 1238 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 897; /* *concatditi3_1 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern424 (x2))
            {
            case 0:
              if (!(
#line 14100 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT) && 
#line 1238 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 912; /* *concatditi3_3 */

            case 1:
              if (!(
#line 14173 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1238 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 942; /* *concatditi3_6 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern424 (x2))
            {
            case 0:
              if (!(
#line 14100 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT) && 
#line 1238 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 915; /* *concatditi3_3 */

            case 1:
              if (!(
#line 14173 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1238 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 945; /* *concatditi3_6 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x3;
      switch (pattern76 (x1, pnum_clobbers))
        {
        case 0:
          if (
#line 12745 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            {
              *pnum_clobbers = 1;
              return 727; /* *xorqi_1_slp */
            }
          break;

        case 1:
          if (
#line 12745 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            {
              *pnum_clobbers = 1;
              return 730; /* *xorhi_1_slp */
            }
          break;

        case 2:
          if ((
#line 13531 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, TImode, operands, TARGET_APX_NDD)) && 
#line 1238 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 822; /* *xorti3_doubleword */
            }
          break;

        case 3:
          if (
#line 13589 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, HImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 825; /* *xorhi_1_nf */
          if (pnum_clobbers != NULL
              && 
#line 13589 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, HImode, operands, TARGET_APX_NDD)
   && true))
            {
              *pnum_clobbers = 1;
              return 826; /* *xorhi_1 */
            }
          break;

        case 4:
          if (
#line 1357 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
            return 2079; /* xorv2sf3 */
          break;

        case 5:
          if (
#line 2582 "../../gcc/config/i386/mmx.md"
(TARGET_SSE))
            return 2113; /* xorv2bf3 */
          break;

        case 6:
          if ((
#line 2582 "../../gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2224 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE)))
            return 2116; /* xorv4bf3 */
          break;

        case 7:
          if (
#line 2582 "../../gcc/config/i386/mmx.md"
(TARGET_SSE))
            return 2119; /* xorv2hf3 */
          break;

        case 8:
          if ((
#line 2582 "../../gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2225 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE)))
            return 2122; /* xorv4hf3 */
          break;

        case 9:
          if (
#line 4687 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (XOR, V8QImode, operands)))
            return 2276; /* *mmx_xorv8qi3 */
          break;

        case 10:
          if (
#line 4687 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (XOR, V4HImode, operands)))
            return 2279; /* *mmx_xorv4hi3 */
          break;

        case 11:
          if (
#line 4687 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (XOR, V2SImode, operands)))
            return 2282; /* *mmx_xorv2si3 */
          break;

        case 12:
          if (
#line 4713 "../../gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (XOR, V4QImode, operands)))
            {
              *pnum_clobbers = 1;
              return 2285; /* *xorv4qi3 */
            }
          break;

        case 13:
          if (
#line 4713 "../../gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (XOR, V2QImode, operands)))
            {
              *pnum_clobbers = 1;
              return 2288; /* *xorv2qi3 */
            }
          break;

        case 14:
          if (
#line 4713 "../../gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (XOR, V2HImode, operands)))
            {
              *pnum_clobbers = 1;
              return 2291; /* *xorv2hi3 */
            }
          break;

        case 15:
          if (
#line 5742 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 3756; /* xorbf3 */
          break;

        case 16:
          if (
#line 5742 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 3759; /* xorhf3 */
          break;

        case 17:
          if (
#line 5742 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 3762; /* xorsf3 */
          break;

        case 18:
          if ((
#line 5742 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1354 "../../gcc/config/i386/i386.md"
(TARGET_SSE2)))
            return 3765; /* xordf3 */
          break;

        case 19:
          if (
#line 5816 "../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return 3768; /* *xortf3 */
          break;

        default:
          break;
        }
      if (pnum_clobbers != NULL
          && pattern77 (x2) == 0)
        {
          x6 = XEXP (x3, 0);
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          switch (pattern1246 (x1))
            {
            case 0:
              if (
#line 12772 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                {
                  *pnum_clobbers = 1;
                  return 733; /* *xorqi_exthi_1_slp */
                }
              break;

            case 1:
              if (
#line 12772 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                {
                  *pnum_clobbers = 1;
                  return 736; /* *xorqi_extsi_1_slp */
                }
              break;

            case 2:
              if ((
#line 12772 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1166 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 739; /* *xorqi_extdi_1_slp */
                }
              break;

            case 3:
              *pnum_clobbers = 1;
              return 757; /* *xorqi_exthi_0 */

            case 4:
              *pnum_clobbers = 1;
              return 760; /* *xorqi_extsi_0 */

            case 5:
              if (
#line 1166 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                {
                  *pnum_clobbers = 1;
                  return 763; /* *xorqi_extdi_0 */
                }
              break;

            default:
              break;
            }
          x9 = XEXP (x2, 1);
          if (GET_CODE (x9) == SUBREG)
            {
              switch (pattern1249 (x1))
                {
                case 0:
                  if (
#line 12805 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    {
                      *pnum_clobbers = 1;
                      return 742; /* *xorqi_exthi_2_slp */
                    }
                  break;

                case 1:
                  if (
#line 12805 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    {
                      *pnum_clobbers = 1;
                      return 745; /* *xorqi_extsi_2_slp */
                    }
                  break;

                case 2:
                  if ((
#line 12805 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1166 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 748; /* *xorqi_extdi_2_slp */
                    }
                  break;

                case 3:
                  *pnum_clobbers = 1;
                  return 766; /* *xorqi_ext2hi_0 */

                case 4:
                  *pnum_clobbers = 1;
                  return 769; /* *xorqi_ext2si_0 */

                case 5:
                  if (
#line 1166 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    {
                      *pnum_clobbers = 1;
                      return 772; /* *xorqi_ext2di_0 */
                    }
                  break;

                default:
                  break;
                }
            }
        }
      operands[1] = x3;
      if (pattern78 (x1) != 0)
        return -1;
      if (
#line 13779 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, QImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
        return 869; /* *xorqi_1_nf */
      if (pnum_clobbers == NULL
          || !
#line 13779 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, QImode, operands, TARGET_APX_NDD)
   && true))
        return -1;
      *pnum_clobbers = 1;
      return 870; /* *xorqi_1 */

    case ZERO_EXTEND:
      switch (pattern38 (x1))
        {
        case 0:
          if (!(
#line 14081 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1238 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 903; /* *concatditi3_2 */

        case 1:
          if (!(
#line 14125 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1238 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 924; /* *concatditi3_4 */

        case 2:
          if (!(
#line 14125 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1238 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 927; /* *concatditi3_4 */

        case 3:
          if (!(
#line 14202 "../../gcc/config/i386/i386.md"
(TImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1238 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 951; /* *concatditi3_7 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (pattern4 (x1, pnum_clobbers))
    {
    case 0:
      if (!
#line 18194 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode)-1))
      == GET_MODE_BITSIZE (QImode)-1
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1292; /* *rotlqi3_mask_1 */

    case 1:
      if (!
#line 18194 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode)-1))
      == GET_MODE_BITSIZE (HImode)-1
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1294; /* *rotlhi3_mask_1 */

    case 2:
      if (!
#line 18275 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1308; /* *rotlqi3_add_1 */

    case 3:
      if (!
#line 18275 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1310; /* *rotlhi3_add_1 */

    case 4:
      if (!
#line 18344 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1324; /* *rotlqi3_sub_1 */

    case 5:
      if (!
#line 18344 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1326; /* *rotlhi3_sub_1 */

    case 6:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (pattern269 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 18146 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode)-1))
      == GET_MODE_BITSIZE (QImode)-1
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1284; /* *rotlqi3_mask */
            }
          break;

        case 1:
          if (
#line 18146 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode)-1))
      == GET_MODE_BITSIZE (HImode)-1
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1286; /* *rotlhi3_mask */
            }
          break;

        case 2:
          if (
#line 18239 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1300; /* *rotlqi3_add */
            }
          break;

        case 3:
          if (
#line 18239 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1302; /* *rotlhi3_add */
            }
          break;

        case 4:
          if (
#line 18308 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1316; /* *rotlqi3_sub */
            }
          break;

        case 5:
          if (
#line 18308 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1318; /* *rotlhi3_sub */
            }
          break;

        case 6:
          if (pnum_clobbers != NULL
              && pattern612 (x3) == 0
              && 
#line 1238 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            {
              *pnum_clobbers = 2;
              return 1333; /* ix86_rotlti3_doubleword */
            }
          x4 = XEXP (x3, 1);
          if (XWINT (x4, 0) == 64L
              && register_operand (operands[0], E_TImode)
              && GET_MODE (x3) == E_TImode
              && register_operand (operands[1], E_TImode)
              && 
#line 18467 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return 1338; /* rotl64ti2_doubleword */
          break;

        default:
          break;
        }
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      switch (pattern270 (x1, pnum_clobbers))
        {
        case 0:
          if (
#line 18681 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 1373; /* *rotlqi3_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 18681 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          *pnum_clobbers = 1;
          return 1374; /* *rotlqi3_1 */

        case 1:
          if (
#line 18681 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 1377; /* *rotlhi3_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 18681 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          *pnum_clobbers = 1;
          return 1378; /* *rotlhi3_1 */

        case 2:
          if (!
#line 18712 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          *pnum_clobbers = 1;
          return 1381; /* *rotlqi3_1_slp */

        case 3:
          if (!
#line 18712 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          *pnum_clobbers = 1;
          return 1383; /* *rotlhi3_1_slp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern82 (x1, pnum_clobbers))
    {
    case 0:
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          x2 = XEXP (x1, 1);
          if (pattern73 (x2, pnum_clobbers) != 0
              || !(
#line 6467 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, TImode, operands, TARGET_APX_NDD)) && 
#line 1238 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 267; /* *addti3_doubleword */

        case E_HImode:
          x2 = XEXP (x1, 1);
          if (pattern74 (x2, 
E_HImode) != 0)
            return -1;
          if (
#line 6815 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, HImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF))
            return 297; /* *addhi_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 6815 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, HImode, operands, TARGET_APX_NDD)
  && true))
            return -1;
          *pnum_clobbers = 1;
          return 298; /* *addhi_1 */

        case E_QImode:
          x2 = XEXP (x1, 1);
          if (pattern74 (x2, 
E_QImode) != 0)
            return -1;
          if (
#line 6872 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, QImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF))
            return 299; /* *addqi_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 6872 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, QImode, operands, TARGET_APX_NDD)
  && true))
            return -1;
          *pnum_clobbers = 1;
          return 300; /* *addqi_1 */

        case E_HFmode:
          x2 = XEXP (x1, 1);
          if (pattern5 (x2, 
E_HFmode) != 0
              || !
#line 23467 "../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 1676; /* *addhf */

        case E_V8QImode:
          x2 = XEXP (x1, 1);
          if (pattern8 (x2, 
E_V8QImode) != 0
              || !
#line 3211 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (PLUS, V8QImode, operands)))
            return -1;
          return 2124; /* *mmx_addv8qi3 */

        case E_V4HImode:
          x2 = XEXP (x1, 1);
          if (pattern8 (x2, 
E_V4HImode) != 0
              || !
#line 3211 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (PLUS, V4HImode, operands)))
            return -1;
          return 2126; /* *mmx_addv4hi3 */

        case E_V2SImode:
          x2 = XEXP (x1, 1);
          if (pattern8 (x2, 
E_V2SImode) != 0
              || !
#line 3211 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (PLUS, V2SImode, operands)))
            return -1;
          return 2128; /* *mmx_addv2si3 */

        case E_V1DImode:
          x2 = XEXP (x1, 1);
          if (pattern8 (x2, 
E_V1DImode) != 0
              || !(
#line 3211 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (PLUS, V1DImode, operands)) && 
#line 50 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2)))
            return -1;
          return 2130; /* *mmx_addv1di3 */

        case E_V4QImode:
          x2 = XEXP (x1, 1);
          if (pattern7 (x2, 
E_V4QImode) != 0
              || !
#line 3227 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2132; /* addv4qi3 */

        case E_V2HImode:
          x2 = XEXP (x1, 1);
          if (pattern7 (x2, 
E_V2HImode) != 0
              || !
#line 3227 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2134; /* addv2hi3 */

        case E_V2QImode:
          if (pnum_clobbers == NULL)
            return -1;
          x2 = XEXP (x1, 1);
          if (pattern7 (x2, 
E_V2QImode) != 0
              || !
#line 3241 "../../gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size || TARGET_SSE2))
            return -1;
          *pnum_clobbers = 1;
          return 2136; /* addv2qi3 */

        default:
          return -1;
        }

    case 1:
      if (!
#line 6948 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
        return -1;
      *pnum_clobbers = 1;
      return 301; /* *addqi_1_slp */

    case 2:
      if (!
#line 6948 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
        return -1;
      *pnum_clobbers = 1;
      return 302; /* *addhi_1_slp */

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (pattern95 (x3, 
E_V2SFmode, 
E_SFmode) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      x6 = XEXP (x5, 0);
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!nonimmediate_operand (operands[2], E_V2SFmode)
          || pattern1829 (x3) != 0
          || !
#line 995 "../../gcc/config/i386/mmx.md"
(TARGET_3DNOW
   && INTVAL (operands[3]) != INTVAL (operands[4])
   && INTVAL (operands[5]) != INTVAL (operands[6])))
        return -1;
      return 2064; /* *mmx_haddv2sf3 */

    case MINUS:
      if (pattern96 (x4, 
E_SFmode) != 0
          || !register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode)
        return -1;
      x8 = XEXP (x4, 0);
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_SFmode)
        return -1;
      x10 = XEXP (x4, 1);
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      switch (GET_CODE (x5))
        {
        case MINUS:
          if (pattern1534 (x5, 
E_SFmode) != 0)
            return -1;
          x6 = XEXP (x5, 0);
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!nonimmediate_operand (operands[2], E_V2SFmode))
            return -1;
          x12 = XEXP (x5, 1);
          x13 = XEXP (x12, 0);
          if (!rtx_equal_p (x13, operands[2])
              || !
#line 1043 "../../gcc/config/i386/mmx.md"
(TARGET_3DNOW_A))
            return -1;
          return 2066; /* mmx_hsubv2sf3 */

        case PLUS:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != VEC_SELECT
              || GET_MODE (x6) != E_SFmode)
            return -1;
          x14 = XEXP (x6, 1);
          if (GET_CODE (x14) != PARALLEL
              || XVECLEN (x14, 0) != 1)
            return -1;
          x12 = XEXP (x5, 1);
          if (GET_CODE (x12) != VEC_SELECT
              || GET_MODE (x12) != E_SFmode)
            return -1;
          x15 = XEXP (x12, 1);
          if (GET_CODE (x15) != PARALLEL
              || XVECLEN (x15, 0) != 1)
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!nonimmediate_operand (operands[2], E_V2SFmode))
            return -1;
          x16 = XVECEXP (x14, 0, 0);
          operands[3] = x16;
          if (!const_0_to_1_operand (operands[3], E_SImode))
            return -1;
          x17 = XVECEXP (x15, 0, 0);
          operands[4] = x17;
          if (!const_0_to_1_operand (operands[4], E_SImode))
            return -1;
          x13 = XEXP (x12, 0);
          if (!rtx_equal_p (x13, operands[2])
              || !
#line 1105 "../../gcc/config/i386/mmx.md"
(TARGET_3DNOW_A
   && INTVAL (operands[3]) != INTVAL (operands[4])))
            return -1;
          return 2068; /* *mmx_haddsubv2sf3 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !nonimmediate_operand (operands[1], E_SFmode))
            return -1;
          if (nonimm_or_0_operand (operands[2], E_SFmode))
            {
              if (
#line 1755 "../../gcc/config/i386/mmx.md"
(TARGET_MMX && !TARGET_SSE))
                return 2092; /* *mmx_concatv2sf */
              if (
#line 11815 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 5199; /* *vec_concatv2sf_sse4_1 */
            }
          if (!reg_or_0_operand (operands[2], E_SFmode)
              || !
#line 11879 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 5200; /* *vec_concatv2sf_sse */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !nonimmediate_operand (operands[1], E_SImode))
            return -1;
          if (nonimm_or_0_operand (operands[2], E_SImode))
            {
              if (
#line 5701 "../../gcc/config/i386/mmx.md"
(TARGET_MMX && !TARGET_SSE))
                return 2348; /* *mmx_concatv2si */
              if (
#line 21569 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 8415; /* *vec_concatv2si_sse4_1 */
            }
          if (!reg_or_0_operand (operands[2], E_SImode)
              || !
#line 21618 "../../gcc/config/i386/sse.md"
(TARGET_SSE && !TARGET_SSE4_1))
            return -1;
          return 8416; /* *vec_concatv2si */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SS_TRUNCATE)
        return -1;
      switch (pattern272 (x3))
        {
        case 0:
          if (!
#line 4771 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2292; /* mmx_packsswb */

        case 1:
          if (!
#line 4812 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2294; /* mmx_packssdw */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case LSHIFTRT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case MULT:
          if (XWINT (x5, 0) != 16L)
            return -1;
          x7 = XEXP (x6, 0);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              switch (pattern744 (x3, 
SIGN_EXTEND))
                {
                case 0:
                  if (!
#line 3447 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (MULT, V4HImode, operands)))
                    return -1;
                  return 2161; /* *mmx_smulv4hi3_highpart */

                case 1:
                  if (!
#line 3516 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
                    return -1;
                  return 2163; /* smulv2hi3_highpart */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern744 (x3, 
ZERO_EXTEND))
                {
                case 0:
                  if (!
#line 3482 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)
   && ix86_binary_operator_ok (MULT, V4HImode, operands)))
                    return -1;
                  return 2162; /* *mmx_umulv4hi3_highpart */

                case 1:
                  if (!
#line 3516 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
                    return -1;
                  return 2164; /* umulv2hi3_highpart */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          x7 = XEXP (x6, 0);
          switch (GET_CODE (x7))
            {
            case MULT:
              if (GET_MODE (x7) != E_V4SImode)
                return -1;
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != SIGN_EXTEND
                  || GET_MODE (x8) != E_V4SImode)
                return -1;
              x9 = XEXP (x7, 1);
              if (GET_CODE (x9) != SIGN_EXTEND
                  || GET_MODE (x9) != E_V4SImode)
                return -1;
              x10 = XEXP (x6, 1);
              if (GET_CODE (x10) != CONST_VECTOR
                  || XVECLEN (x10, 0) != 4
                  || GET_MODE (x10) != E_V4SImode)
                return -1;
              x11 = XVECEXP (x10, 0, 0);
              if (GET_CODE (x11) != CONST_INT
                  || XWINT (x11, 0) != 32768L)
                return -1;
              x12 = XVECEXP (x10, 0, 1);
              if (GET_CODE (x12) != CONST_INT
                  || XWINT (x12, 0) != 32768L)
                return -1;
              x13 = XVECEXP (x10, 0, 2);
              if (GET_CODE (x13) != CONST_INT
                  || XWINT (x13, 0) != 32768L)
                return -1;
              x14 = XVECEXP (x10, 0, 3);
              if (GET_CODE (x14) != CONST_INT
                  || XWINT (x14, 0) != 32768L
                  || XWINT (x5, 0) != 16L
                  || !register_operand (operands[0], E_V4HImode)
                  || GET_MODE (x3) != E_V4HImode
                  || GET_MODE (x4) != E_V4SImode
                  || GET_MODE (x6) != E_V4SImode)
                return -1;
              x15 = XEXP (x8, 0);
              operands[1] = x15;
              if (!nonimmediate_operand (operands[1], E_V4HImode))
                return -1;
              x16 = XEXP (x9, 0);
              operands[2] = x16;
              if (!nonimmediate_operand (operands[2], E_V4HImode)
                  || !
#line 3605 "../../gcc/config/i386/mmx.md"
(TARGET_3DNOW && ix86_binary_operator_ok (MULT, V4HImode, operands)))
                return -1;
              return 2166; /* *mmx_pmulhrwv4hi3 */

            case PLUS:
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != ZERO_EXTEND)
                return -1;
              x9 = XEXP (x7, 1);
              if (GET_CODE (x9) != ZERO_EXTEND)
                return -1;
              x10 = XEXP (x6, 1);
              if (GET_CODE (x10) != CONST_VECTOR
                  || XWINT (x5, 0) != 1L)
                return -1;
              x15 = XEXP (x8, 0);
              operands[1] = x15;
              x16 = XEXP (x9, 0);
              operands[2] = x16;
              switch (XVECLEN (x10, 0))
                {
                case 8:
                  if (pattern1343 (x10, 
E_V8HImode) != 0
                      || pattern1615 (x3, 
E_V8QImode, 
E_V8HImode) != 0
                      || !
#line 6332 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 2378; /* *mmx_uavgv8qi3 */

                case 4:
                  x11 = XVECEXP (x10, 0, 0);
                  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  x12 = XVECEXP (x10, 0, 1);
                  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  x13 = XVECEXP (x10, 0, 2);
                  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  x14 = XVECEXP (x10, 0, 3);
                  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4HImode:
                      if (pattern1615 (x3, 
E_V4HImode, 
E_V4SImode) != 0
                          || GET_MODE (x10) != E_V4SImode
                          || !
#line 6376 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                        return -1;
                      return 2379; /* *mmx_uavgv4hi3 */

                    case E_V4QImode:
                      if (pattern1517 (x3, 
E_V4HImode, 
E_V4QImode) != 0
                          || !
#line 6416 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
                        return -1;
                      return 2380; /* uavgv4qi3_ceil */

                    default:
                      return -1;
                    }

                case 2:
                  x11 = XVECEXP (x10, 0, 0);
                  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  x12 = XVECEXP (x10, 0, 1);
                  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V2QImode:
                      if (pattern1517 (x3, 
E_V2HImode, 
E_V2QImode) != 0
                          || !
#line 6436 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
                        return -1;
                      return 2381; /* uavgv2qi3_ceil */

                    case E_V2HImode:
                      if (pattern1517 (x3, 
E_V2SImode, 
E_V2HImode) != 0
                          || !
#line 6456 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
                        return -1;
                      return 2382; /* uavgv2hi3_ceil */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case LSHIFTRT:
              if (pattern613 (x7) != 0
                  || XWINT (x5, 0) != 1L)
                return -1;
              x8 = XEXP (x7, 0);
              x15 = XEXP (x8, 0);
              x17 = XEXP (x15, 0);
              operands[1] = x17;
              x18 = XEXP (x8, 1);
              x19 = XEXP (x18, 0);
              operands[2] = x19;
              x10 = XEXP (x6, 1);
              operands[3] = x10;
              switch (GET_MODE (operands[0]))
                {
                case E_V4HImode:
                  if (pattern1493 (x3, 
E_V4SImode, 
E_V4HImode) != 0
                      || !register_mmxmem_operand (operands[1], E_V4HImode)
                      || GET_MODE (x18) != E_V4SImode
                      || !register_mmxmem_operand (operands[2], E_V4HImode)
                      || !const1_operand (operands[3], E_V4HImode)
                      || !
#line 23121 "../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && TARGET_SSSE3
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8558; /* *ssse3_pmulhrswv4hi3 */

                case E_V2HImode:
                  if (pattern1493 (x3, 
E_V2SImode, 
E_V2HImode) != 0
                      || !register_operand (operands[1], E_V2HImode)
                      || GET_MODE (x18) != E_V2SImode
                      || !register_operand (operands[2], E_V2HImode)
                      || !const1_operand (operands[3], E_V2HImode)
                      || !
#line 23166 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8559; /* *smulhrsv2hi3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V4QImode:
          if (GET_MODE (x3) != E_V4QImode)
            return -1;
          if (register_operand (operands[0], E_V4QImode)
              && register_operand (operands[1], E_V4HImode)
              && (
#line 5144 "../../gcc/config/i386/mmx.md"
(TARGET_AVX512VL && TARGET_AVX512BW) && 
#line 73 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE)))
            return 2312; /* avx512vl_truncv4hiv4qi2 */
          if (!memory_operand (operands[0], E_V4QImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !
#line 15557 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return -1;
              return 7247; /* *avx512vl_truncatev4siv4qi2_store_1 */

            case E_V4DImode:
              if (!register_operand (operands[1], E_V4DImode)
                  || !
#line 15557 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return -1;
              return 7250; /* *avx512vl_truncatev4div4qi2_store_1 */

            default:
              return -1;
            }

        case E_V2QImode:
          if (GET_MODE (x3) != E_V2QImode)
            return -1;
          if (register_operand (operands[0], E_V2QImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V2HImode:
                  if (register_operand (operands[1], E_V2HImode)
                      && 
#line 5144 "../../gcc/config/i386/mmx.md"
(TARGET_AVX512VL && TARGET_AVX512BW))
                    return 2313; /* avx512vl_truncv2hiv2qi2 */
                  break;

                case E_V2SImode:
                  if (register_operand (operands[1], E_V2SImode)
                      && 
#line 5170 "../../gcc/config/i386/mmx.md"
(TARGET_AVX512VL && TARGET_MMX_WITH_SSE))
                    return 2314; /* avx512vl_truncv2siv2qi2 */
                  break;

                default:
                  break;
                }
            }
          if (!memory_operand (operands[0], E_V2QImode)
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 15462 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7232; /* *avx512vl_truncatev2div2qi2_store_1 */

        case E_V2HImode:
          if (GET_MODE (x3) != E_V2HImode)
            return -1;
          if (register_operand (operands[0], E_V2HImode)
              && register_operand (operands[1], E_V2SImode)
              && 
#line 5170 "../../gcc/config/i386/mmx.md"
(TARGET_AVX512VL && TARGET_MMX_WITH_SSE))
            return 2315; /* avx512vl_truncv2siv2hi2 */
          if (!memory_operand (operands[0], E_V2HImode)
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 15908 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7347; /* *avx512vl_truncatev2div2hi2_store_1 */

        case E_V8QImode:
          switch (pattern12 (x3))
            {
            case 0:
              if (!(
#line 15655 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15649 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return -1;
              return 7277; /* *avx512vl_truncatev8hiv8qi2_store_1 */

            case 1:
              if (!
#line 15655 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return -1;
              return 7280; /* *avx512vl_truncatev8siv8qi2_store_1 */

            case 2:
              if (!
#line 16171 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
                return -1;
              return 7384; /* *avx512f_truncatev8div16qi2_store_1 */

            default:
              return -1;
            }

        case E_V4HImode:
          switch (pattern11 (x3, 
E_V4HImode))
            {
            case 0:
              if (!
#line 15817 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return -1;
              return 7317; /* *avx512vl_truncatev4siv4hi2_store_1 */

            case 1:
              if (!
#line 15817 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return -1;
              return 7320; /* *avx512vl_truncatev4div4hi2_store_1 */

            default:
              return -1;
            }

        case E_V2SImode:
          if (!memory_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 16058 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7366; /* *avx512vl_truncatev2div2si2_store_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      return recog_71 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_73 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_75 (x1, insn, pnum_clobbers);

    case SMUL_HIGHPART:
      if (pattern106 (x3, pnum_clobbers) != 0
          || !
#line 11152 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
        return -1;
      *pnum_clobbers = 2;
      return 631; /* *smulsi3_highpart_zext */

    case UMUL_HIGHPART:
      if (pattern106 (x3, pnum_clobbers) != 0
          || !
#line 11152 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
        return -1;
      *pnum_clobbers = 2;
      return 632; /* *umulsi3_highpart_zext */

    case TRUNCATE:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != LSHIFTRT
          || GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != MULT
          || GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x5, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 32]
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x8 = XEXP (x6, 0);
      if (GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XEXP (x6, 1);
      if (GET_MODE (x9) != E_DImode)
        return -1;
      switch (GET_CODE (x8))
        {
        case SIGN_EXTEND:
          if (GET_CODE (x9) != SIGN_EXTEND)
            return -1;
          x10 = XEXP (x8, 0);
          operands[1] = x10;
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          x11 = XEXP (x9, 0);
          operands[2] = x11;
          if (!nonimmediate_operand (operands[2], E_SImode)
              || !
#line 11200 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 2;
          return 635; /* *smulsi3_highpart_zext */

        case ZERO_EXTEND:
          if (GET_CODE (x9) != ZERO_EXTEND)
            return -1;
          x10 = XEXP (x8, 0);
          operands[1] = x10;
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          x11 = XEXP (x9, 0);
          operands[2] = x11;
          if (!nonimmediate_operand (operands[2], E_SImode)
              || !
#line 11200 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 2;
          return 636; /* *umulsi3_highpart_zext */

        default:
          return -1;
        }

    case AND:
      return recog_72 (x1, insn, pnum_clobbers);

    case IOR:
      switch (pattern108 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 13719 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return 847; /* *iorqi_1_zextsi_nf */
          if (pnum_clobbers == NULL
              || !
#line 13719 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 848; /* *iorqi_1_zextsi */

        case 1:
          if (
#line 13733 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return 855; /* *iorhi_1_zextsi_nf */
          if (pnum_clobbers == NULL
              || !
#line 13733 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 856; /* *iorhi_1_zextsi */

        case 2:
          if (
#line 13719 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return 851; /* *iorqi_1_zextdi_nf */
          if (pnum_clobbers == NULL
              || !
#line 13719 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 852; /* *iorqi_1_zextdi */

        case 3:
          if (
#line 13733 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return 859; /* *iorhi_1_zextdi_nf */
          if (pnum_clobbers == NULL
              || !
#line 13733 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 860; /* *iorhi_1_zextdi */

        case 4:
          if (!
#line 13749 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (IOR, SImode, operands, TARGET_APX_NDD)))
            return -1;
          *pnum_clobbers = 1;
          return 863; /* *iorsi_1_zext */

        default:
          return -1;
        }

    case XOR:
      switch (pattern108 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 13719 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return 849; /* *xorqi_1_zextsi_nf */
          if (pnum_clobbers == NULL
              || !
#line 13719 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 850; /* *xorqi_1_zextsi */

        case 1:
          if (
#line 13733 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return 857; /* *xorhi_1_zextsi_nf */
          if (pnum_clobbers == NULL
              || !
#line 13733 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 858; /* *xorhi_1_zextsi */

        case 2:
          if (
#line 13719 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return 853; /* *xorqi_1_zextdi_nf */
          if (pnum_clobbers == NULL
              || !
#line 13719 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 854; /* *xorqi_1_zextdi */

        case 3:
          if (
#line 13733 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return 861; /* *xorhi_1_zextdi_nf */
          if (pnum_clobbers == NULL
              || !
#line 13733 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 862; /* *xorhi_1_zextdi */

        case 4:
          if (!
#line 13749 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (XOR, SImode, operands, TARGET_APX_NDD)))
            return -1;
          *pnum_clobbers = 1;
          return 864; /* *xorsi_1_zext */

        default:
          return -1;
        }

    case NEG:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (pattern283 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 14364 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
            return 964; /* *negqi_1_zextsi_nf */
          if (pnum_clobbers == NULL
              || !
#line 14364 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          *pnum_clobbers = 1;
          return 965; /* *negqi_1_zextsi */

        case 1:
          if (
#line 14374 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
            return 968; /* *neghi_1_zextsi_nf */
          if (pnum_clobbers == NULL
              || !
#line 14374 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          *pnum_clobbers = 1;
          return 969; /* *neghi_1_zextsi */

        case 2:
          if (
#line 14364 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
            return 966; /* *negqi_1_zextdi_nf */
          if (pnum_clobbers == NULL
              || !
#line 14364 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          *pnum_clobbers = 1;
          return 967; /* *negqi_1_zextdi */

        case 3:
          if (
#line 14374 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
            return 970; /* *neghi_1_zextdi_nf */
          if (pnum_clobbers == NULL
              || !
#line 14374 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          *pnum_clobbers = 1;
          return 971; /* *neghi_1_zextdi */

        case 4:
          if (!
#line 14385 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_unary_operator_ok (NEG, SImode, operands, TARGET_APX_NDD)))
            return -1;
          *pnum_clobbers = 1;
          return 972; /* *negsi_1_zext */

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern282 (x3))
            {
            case 0:
              if (!
#line 15006 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              return 1036; /* *one_cmplqi2_1_zextsi */

            case 1:
              if (!
#line 15015 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              return 1038; /* *one_cmplhi2_1_zextsi */

            default:
              return -1;
            }

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!nonimmediate_operand (operands[1], E_QImode)
                  || !
#line 15006 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              return 1037; /* *one_cmplqi2_1_zextdi */

            case E_HImode:
              if (!nonimmediate_operand (operands[1], E_HImode)
                  || !
#line 15015 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              return 1039; /* *one_cmplhi2_1_zextdi */

            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !
#line 15024 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_unary_operator_ok (NOT, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 1040; /* *one_cmplsi2_1_zext */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern109 (x3))
        {
        case 0:
          if (register_operand (operands[2], E_SImode)
              && 
#line 16002 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_BMI2))
            return 1092; /* *bmi2_ashlsi3_1_zext */
          if (pnum_clobbers == NULL
              || !nonmemory_operand (operands[2], E_QImode)
              || !
#line 16035 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (ASHIFT, SImode, operands, TARGET_APX_NDD)))
            return -1;
          *pnum_clobbers = 1;
          return 1103; /* *ashlsi3_1_zext */

        case 1:
          if (
#line 16012 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
            return 1097; /* *ashlqi3_1_zextdi_nf */
          if (pnum_clobbers == NULL
              || !
#line 16012 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          *pnum_clobbers = 1;
          return 1098; /* *ashlqi3_1_zextdi */

        case 2:
          if (
#line 16023 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
            return 1101; /* *ashlhi3_1_zextdi_nf */
          if (pnum_clobbers == NULL
              || !
#line 16023 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          *pnum_clobbers = 1;
          return 1102; /* *ashlhi3_1_zextdi */

        case 3:
          if (
#line 16012 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
            return 1095; /* *ashlqi3_1_zextsi_nf */
          if (pnum_clobbers == NULL
              || !
#line 16012 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          *pnum_clobbers = 1;
          return 1096; /* *ashlqi3_1_zextsi */

        case 4:
          if (
#line 16023 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
            return 1099; /* *ashlhi3_1_zextsi_nf */
          if (pnum_clobbers == NULL
              || !
#line 16023 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          *pnum_clobbers = 1;
          return 1100; /* *ashlhi3_1_zextsi */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (GET_MODE (x4) == E_SImode
          && register_operand (operands[0], E_DImode))
        {
          res = recog_69 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (pattern284 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 17459 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
            return 1192; /* *ashrqi3_1_zextsi_nf */
          if (pnum_clobbers == NULL
              || !
#line 17459 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          *pnum_clobbers = 1;
          return 1193; /* *ashrqi3_1_zextsi */

        case 1:
          if (
#line 17470 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
            return 1200; /* *ashrhi3_1_zextsi_nf */
          if (pnum_clobbers == NULL
              || !
#line 17470 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          *pnum_clobbers = 1;
          return 1201; /* *ashrhi3_1_zextsi */

        case 2:
          if (
#line 17459 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
            return 1196; /* *ashrqi3_1_zextdi_nf */
          if (pnum_clobbers == NULL
              || !
#line 17459 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          *pnum_clobbers = 1;
          return 1197; /* *ashrqi3_1_zextdi */

        case 3:
          if (
#line 17470 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
            return 1204; /* *ashrhi3_1_zextdi_nf */
          if (pnum_clobbers == NULL
              || !
#line 17470 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          *pnum_clobbers = 1;
          return 1205; /* *ashrhi3_1_zextdi */

        case 4:
          if (!
#line 17482 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)))
            return -1;
          *pnum_clobbers = 1;
          return 1207; /* *ashrsi3_1_zext */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern109 (x3))
        {
        case 0:
          if (register_operand (operands[2], E_SImode)
              && 
#line 17449 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_BMI2))
            return 1184; /* *bmi2_lshrsi3_1_zext */
          if (pnum_clobbers == NULL
              || !nonmemory_operand (operands[2], E_QImode)
              || !
#line 17482 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (LSHIFTRT, SImode, operands, TARGET_APX_NDD)))
            return -1;
          *pnum_clobbers = 1;
          return 1206; /* *lshrsi3_1_zext */

        case 1:
          if (
#line 17459 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
            return 1194; /* *lshrqi3_1_zextdi_nf */
          if (pnum_clobbers == NULL
              || !
#line 17459 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          *pnum_clobbers = 1;
          return 1195; /* *lshrqi3_1_zextdi */

        case 2:
          if (
#line 17470 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
            return 1202; /* *lshrhi3_1_zextdi_nf */
          if (pnum_clobbers == NULL
              || !
#line 17470 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          *pnum_clobbers = 1;
          return 1203; /* *lshrhi3_1_zextdi */

        case 3:
          if (
#line 17459 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
            return 1190; /* *lshrqi3_1_zextsi_nf */
          if (pnum_clobbers == NULL
              || !
#line 17459 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          *pnum_clobbers = 1;
          return 1191; /* *lshrqi3_1_zextsi */

        case 4:
          if (
#line 17470 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
            return 1198; /* *lshrhi3_1_zextsi_nf */
          if (pnum_clobbers == NULL
              || !
#line 17470 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          *pnum_clobbers = 1;
          return 1199; /* *lshrhi3_1_zextsi */

        default:
          return -1;
        }

    case ROTATERT:
      switch (pattern109 (x3))
        {
        case 0:
          if (const_0_to_31_operand (operands[2], E_QImode)
              && 
#line 18582 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_BMI2 && !optimize_function_for_size_p (cfun)))
            return 1350; /* *bmi2_rorxsi3_1_zext */
          if (pnum_clobbers == NULL
              || !nonmemory_operand (operands[2], E_QImode)
              || !
#line 18615 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_binary_operator_ok (ROTATERT, SImode, operands)))
            return -1;
          *pnum_clobbers = 1;
          return 1372; /* *rotrsi3_1_zext */

        case 1:
          if (
#line 18592 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
            return 1361; /* *rotrqi3_1_zextdi_nf */
          if (pnum_clobbers == NULL
              || !
#line 18592 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          *pnum_clobbers = 1;
          return 1362; /* *rotrqi3_1_zextdi */

        case 2:
          if (
#line 18603 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
            return 1369; /* *rotrhi3_1_zextdi_nf */
          if (pnum_clobbers == NULL
              || !
#line 18603 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          *pnum_clobbers = 1;
          return 1370; /* *rotrhi3_1_zextdi */

        case 3:
          if (
#line 18592 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
            return 1357; /* *rotrqi3_1_zextsi_nf */
          if (pnum_clobbers == NULL
              || !
#line 18592 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          *pnum_clobbers = 1;
          return 1358; /* *rotrqi3_1_zextsi */

        case 4:
          if (
#line 18603 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
            return 1365; /* *rotrhi3_1_zextsi_nf */
          if (pnum_clobbers == NULL
              || !
#line 18603 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          *pnum_clobbers = 1;
          return 1366; /* *rotrhi3_1_zextsi */

        default:
          return -1;
        }

    case ROTATE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (pattern284 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 18592 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
            return 1355; /* *rotlqi3_1_zextsi_nf */
          if (pnum_clobbers == NULL
              || !
#line 18592 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          *pnum_clobbers = 1;
          return 1356; /* *rotlqi3_1_zextsi */

        case 1:
          if (
#line 18603 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
            return 1363; /* *rotlhi3_1_zextsi_nf */
          if (pnum_clobbers == NULL
              || !
#line 18603 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          *pnum_clobbers = 1;
          return 1364; /* *rotlhi3_1_zextsi */

        case 2:
          if (
#line 18592 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
            return 1359; /* *rotlqi3_1_zextdi_nf */
          if (pnum_clobbers == NULL
              || !
#line 18592 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          *pnum_clobbers = 1;
          return 1360; /* *rotlqi3_1_zextdi */

        case 3:
          if (
#line 18603 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
            return 1367; /* *rotlhi3_1_zextdi_nf */
          if (pnum_clobbers == NULL
              || !
#line 18603 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          *pnum_clobbers = 1;
          return 1368; /* *rotlhi3_1_zextdi */

        case 4:
          if (!
#line 18615 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_binary_operator_ok (ROTATE, SImode, operands)))
            return -1;
          *pnum_clobbers = 1;
          return 1371; /* *rotlsi3_1_zext */

        default:
          return -1;
        }

    case CTZ:
      if (pattern110 (x3, pnum_clobbers, 
E_SImode, 
E_DImode) != 0
          || !
#line 21183 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1521; /* *ctzsidi2_uext */

    case CLZ:
      if (pattern110 (x3, pnum_clobbers, 
E_SImode, 
E_DImode) != 0
          || !
#line 21618 "../../gcc/config/i386/i386.md"
(TARGET_LZCNT && TARGET_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1543; /* *clzsi2_lzcnt_zext_2 */

    case POPCOUNT:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern614 (x3, 
E_DImode, 
E_SImode) != 0
              || !
#line 22455 "../../gcc/config/i386/i386.md"
(TARGET_POPCNT && TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1634; /* *popcountsi2_zext_2 */

        case E_SImode:
          if (pattern614 (x3, 
E_SImode, 
E_HImode) != 0
              || !
#line 22521 "../../gcc/config/i386/i386.md"
(TARGET_POPCNT
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1637; /* *popcounthi2_2 */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_70 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (!ix86_comparison_operator (x5, E_VOIDmode))
        return -1;
      operands[1] = x5;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 17)
        return -1;
      x7 = XEXP (x5, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x12 = XEXP (x4, 1);
      operands[2] = x12;
      if (!nonimmediate_operand (operands[2], E_SImode))
        return -1;
      x13 = XEXP (x4, 2);
      operands[3] = x13;
      if (!nonimmediate_operand (operands[3], E_SImode)
          || !
#line 26434 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && TARGET_CMOVE && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
        return -1;
      return 1807; /* *movsicc_noc_zext_1 */

    case VEC_SELECT:
      return recog_74 (x1, insn, pnum_clobbers);

    case SUBREG:
      if (pattern111 (x3) != 0
          || !
#line 22202 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
        return -1;
      return 8497; /* *sse2_pmovskb_zexthisi */

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern20 (x1, pnum_clobbers))
    {
    case 0:
      if (!
#line 18194 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1297; /* *rotrsi3_mask_1 */

    case 1:
      if (!(
#line 18194 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1163 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1299; /* *rotrdi3_mask_1 */

    case 2:
      if (!
#line 18275 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1313; /* *rotrsi3_add_1 */

    case 3:
      if (!(
#line 18275 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1163 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1315; /* *rotrdi3_add_1 */

    case 4:
      if (!
#line 18344 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1329; /* *rotrsi3_sub_1 */

    case 5:
      if (!(
#line 18344 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1163 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1331; /* *rotrdi3_sub_1 */

    case 6:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case SUBREG:
          switch (pattern450 (x2, pnum_clobbers))
            {
            case 0:
              if (
#line 18146 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                {
                  *pnum_clobbers = 1;
                  return 1289; /* *rotrsi3_mask */
                }
              break;

            case 1:
              if ((
#line 18146 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1163 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1291; /* *rotrdi3_mask */
                }
              break;

            case 2:
              if (
#line 18239 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                {
                  *pnum_clobbers = 1;
                  return 1305; /* *rotrsi3_add */
                }
              break;

            case 3:
              if ((
#line 18239 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1163 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1307; /* *rotrdi3_add */
                }
              break;

            case 4:
              if (
#line 18308 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                {
                  *pnum_clobbers = 1;
                  return 1321; /* *rotrsi3_sub */
                }
              break;

            case 5:
              if ((
#line 18308 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1163 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1323; /* *rotrdi3_sub */
                }
              break;

            default:
              break;
            }
          break;

        case CONST_INT:
          operands[2] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern610 (x2, pnum_clobbers, 
E_DImode) == 0
                  && const_1_to_31_operand (operands[2], E_QImode)
                  && 
#line 1237 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
                {
                  *pnum_clobbers = 2;
                  return 1334; /* ix86_rotrdi3_doubleword */
                }
              break;

            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && GET_MODE (x2) == E_SImode
                  && nonimmediate_operand (operands[1], E_SImode)
                  && const_0_to_31_operand (operands[2], E_QImode)
                  && 
#line 18490 "../../gcc/config/i386/i386.md"
(TARGET_BMI2 && !optimize_function_for_size_p (cfun)))
                return 1340; /* *bmi2_rorxsi3_1 */
              break;

            default:
              break;
            }
          if (register_operand (operands[0], E_DImode)
              && GET_MODE (x2) == E_DImode)
            {
              if (XWINT (x3, 0) == 32L
                  && register_operand (operands[1], E_DImode)
                  && 
#line 18449 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
                return 1337; /* rotr32di2_doubleword */
              if (nonimmediate_operand (operands[1], E_DImode))
                {
                  operands[2] = x3;
                  if (const_0_to_63_operand (operands[2], E_QImode)
                      && (
#line 18490 "../../gcc/config/i386/i386.md"
(TARGET_BMI2 && !optimize_function_for_size_p (cfun)) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 1341; /* *bmi2_rorxdi3_1 */
                }
            }
          break;

        default:
          break;
        }
      operands[2] = x3;
      if (!nonmemory_operand (operands[2], E_QImode))
        return -1;
      switch (pattern16 (x2))
        {
        case 0:
          if (
#line 18500 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 1344; /* *rotrsi3_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 18500 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          *pnum_clobbers = 1;
          return 1345; /* *rotrsi3_1 */

        case 1:
          if ((
#line 18500 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 1348; /* *rotrdi3_1_nf */
          if (pnum_clobbers == NULL
              || !(
#line 18500 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1349; /* *rotrdi3_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (pattern126 (x3))
        {
        case 0:
          if (
#line 22308 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF && TARGET_POPCNT))
            return 1624; /* popcountsi2_nf */
          if (pnum_clobbers == NULL
              || !
#line 22333 "../../gcc/config/i386/i386.md"
(TARGET_POPCNT))
            return -1;
          *pnum_clobbers = 1;
          return 1626; /* popcountsi2 */

        case 1:
          if ((
#line 22308 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF && TARGET_POPCNT) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 1625; /* popcountdi2_nf */
          if (pnum_clobbers == NULL
              || !(
#line 22333 "../../gcc/config/i386/i386.md"
(TARGET_POPCNT) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1627; /* popcountdi2 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pattern110 (x3, pnum_clobbers, 
E_HImode, 
E_SImode) != 0
          || !
#line 22503 "../../gcc/config/i386/i386.md"
(TARGET_POPCNT
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1636; /* *popcounthi2_1 */

    default:
      return -1;
    }
}

 int
recog_118 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (XWINT (x4, 0))
    {
    case 0L:
      if (nonimmediate_operand (operands[0], E_SImode)
          && GET_MODE (x2) == E_SImode)
        {
          switch (GET_MODE (operands[1]))
            {
            case E_V2SImode:
              if (nonimmediate_operand (operands[1], E_V2SImode)
                  && 
#line 5729 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                return 2349; /* *vec_extractv2si_0 */
              break;

            case E_V4SImode:
              if (nonimmediate_operand (operands[1], E_V4SImode)
                  && 
#line 21221 "../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                return 8403; /* *vec_extractv4si_0 */
              break;

            default:
              break;
            }
        }
      break;

    case 1L:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (nonimmediate_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode
              && nonimmediate_operand (operands[1], E_V2SImode)
              && 
#line 5786 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
            return 2352; /* *vec_extractv2si_1 */
          break;

        case E_DImode:
          if (nonimmediate_operand (operands[0], E_DImode)
              && GET_MODE (x2) == E_DImode
              && nonimmediate_operand (operands[1], E_V2DImode)
              && 
#line 21390 "../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
            return 8412; /* *vec_extractv2di_1 */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      if (register_operand (operands[0], E_SImode))
        {
          switch (GET_MODE (operands[1]))
            {
            case E_V16SImode:
              if (register_operand (operands[1], E_V16SImode)
                  && const_0_to_15_operand (operands[2], E_VOIDmode)
                  && (
#line 14134 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && INTVAL(operands[2]) * GET_MODE_SIZE (SImode) >= 16) && 
#line 300 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 7015; /* *vec_extractv16sisi_valign */
              break;

            case E_V8SImode:
              if (register_operand (operands[1], E_V8SImode)
                  && const_0_to_7_operand (operands[2], E_VOIDmode)
                  && (
#line 14134 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && INTVAL(operands[2]) * GET_MODE_SIZE (SImode) >= 16) && 
#line 300 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 7016; /* *vec_extractv8sisi_valign */
              break;

            default:
              break;
            }
        }
      if (nonimmediate_operand (operands[0], E_SImode)
          && register_operand (operands[1], E_V4SImode)
          && const_0_to_3_operand (operands[2], E_SImode)
          && 
#line 21311 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
        return 8408; /* *vec_extractv4si */
      if (!register_operand (operands[0], E_SImode)
          || !memory_operand (operands[1], E_V4SImode)
          || !const_0_to_3_operand (operands[2], E_VOIDmode)
          || !
#line 21368 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 8410; /* *vec_extractv4si_mem */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DImode:
          if (!register_operand (operands[1], E_V8DImode)
              || !const_0_to_7_operand (operands[2], E_VOIDmode)
              || !(
#line 14134 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && INTVAL(operands[2]) * GET_MODE_SIZE (DImode) >= 16) && 
#line 301 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7017; /* *vec_extractv8didi_valign */

        case E_V4DImode:
          if (!register_operand (operands[1], E_V4DImode)
              || !const_0_to_3_operand (operands[2], E_VOIDmode)
              || !(
#line 14134 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && INTVAL(operands[2]) * GET_MODE_SIZE (DImode) >= 16) && 
#line 301 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7018; /* *vec_extractv4didi_valign */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_123 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (pattern629 (x2, 
E_V8HImode, 
E_QImode, 
E_V8HFmode) != 0
          || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7935 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 703 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 4509; /* unspec_avx512fp16_fixuns_truncv8hi2_mask */

    case E_V16HImode:
      if (pattern629 (x2, 
E_V16HImode, 
E_HImode, 
E_V16HFmode) != 0
          || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7935 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 703 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 4517; /* unspec_avx512fp16_fixuns_truncv16hi2_mask */

    case E_V32HImode:
      if (pattern629 (x2, 
E_V32HImode, 
E_SImode, 
E_V32HFmode) != 0
          || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7935 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 703 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 4525; /* unspec_avx512fp16_fixuns_truncv32hi2_mask */

    case E_V8SImode:
      if (pattern136 (x2, 
E_V8SImode, 
E_QImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7935 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 704 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4533; /* unspec_avx512fp16_fixuns_truncv8si2_mask */

        case E_V8DFmode:
          if (!vector_operand (operands[1], E_V8DFmode)
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9623 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4964; /* unspec_fixuns_truncv8dfv8si2_mask */

        case E_V8SFmode:
          if (!nonimmediate_operand (operands[1], E_V8SFmode)
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9966 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 440 "../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 5068; /* unspec_fixuns_truncv8sfv8si2_mask */

        default:
          return -1;
        }

    case E_V16SImode:
      switch (pattern985 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7935 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 704 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4541; /* unspec_avx512fp16_fixuns_truncv16si2_mask */

        case 1:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8830 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4815; /* unspec_fixuns_truncv16sfv16si2_mask */

        default:
          return -1;
        }

    case E_V8DImode:
      switch (pattern986 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7935 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 705 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4549; /* unspec_avx512fp16_fixuns_truncv8di2_mask */

        case 1:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9752 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 546 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4993; /* unspec_fixuns_truncv8dfv8di2_mask */

        case 2:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9795 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 636 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 5041; /* unspec_fixuns_truncv8sfv8di2_mask */

        default:
          return -1;
        }

    case E_V4SImode:
      if (pattern136 (x2, 
E_V4SImode, 
E_QImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode)
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7973 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4602; /* unspec_avx512fp16_fixuns_truncv4si2_mask */

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9732 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512F)))
            return -1;
          return 4984; /* unspec_fixuns_truncv4dfv4si2_mask */

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9966 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5070; /* unspec_fixuns_truncv4sfv4si2_mask */

        default:
          return -1;
        }

    case E_V4DImode:
      switch (pattern987 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7973 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4606; /* unspec_avx512fp16_fixuns_truncv4di2_mask */

        case 1:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9752 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 546 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4998; /* unspec_fixuns_truncv4dfv4di2_mask */

        case 2:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9795 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 636 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 5046; /* unspec_fixuns_truncv4sfv4di2_mask */

        default:
          return -1;
        }

    case E_V2DImode:
      switch (pattern988 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8023 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4626; /* unspec_avx512fp16_fixuns_truncv2di2_mask */

        case 1:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9752 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 546 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 5002; /* unspec_fixuns_truncv2dfv2di2_mask */

        case 2:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9816 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL)))
            return -1;
          return 5062; /* unspec_avx512dq_fixuns_truncv2sfv2di2_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_130 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 2);
  switch (GET_CODE (x6))
    {
    case CONST_INT:
      if (XWINT (x6, 0) != 1L)
        return -1;
      switch (pattern458 (x2))
        {
        case 0:
          if (!(
#line 13674 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 5329; /* avx512f_vmscalefv8hf */

        case 1:
          if (!
#line 13674 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 5333; /* avx512f_vmscalefv4sf */

        case 2:
          if (!(
#line 13674 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 5337; /* avx512f_vmscalefv2df */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[4] = x6;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern1096 (x2, 
E_V32HFmode, 
E_SImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13685 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 5343; /* avx512bw_scalefv32hf_mask */

        case E_V16HFmode:
          if (pattern1096 (x2, 
E_V16HFmode, 
E_HImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13685 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 5347; /* avx512vl_scalefv16hf_mask */

        case E_V8HFmode:
          if (pattern1096 (x2, 
E_V8HFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13685 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 5351; /* avx512fp16_scalefv8hf_mask */

        case E_V16SFmode:
          if (pattern1096 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13685 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 5355; /* avx512f_scalefv16sf_mask */

        case E_V8SFmode:
          if (pattern1096 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13685 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 5359; /* avx512vl_scalefv8sf_mask */

        case E_V4SFmode:
          if (pattern1096 (x2, 
E_V4SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13685 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 5363; /* avx512vl_scalefv4sf_mask */

        case E_V8DFmode:
          if (pattern1096 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13685 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 5367; /* avx512f_scalefv8df_mask */

        case E_V4DFmode:
          if (pattern1096 (x2, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13685 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 5371; /* avx512vl_scalefv4df_mask */

        case E_V2DFmode:
          if (pattern1096 (x2, 
E_V2DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13685 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 5375; /* avx512vl_scalefv2df_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_137 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_15_operand (operands[3], E_SImode))
    return -1;
  x7 = XEXP (x2, 2);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[5] = x7;
      x8 = XEXP (x2, 1);
      operands[4] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern473 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29878 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9895; /* avx512dq_rangepv16sf_mask */

        case E_V8SFmode:
          if (pattern473 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29878 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9898; /* avx512dq_rangepv8sf_mask */

        case E_V4SFmode:
          if (pattern473 (x2, 
E_V4SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29878 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9900; /* avx512dq_rangepv4sf_mask */

        case E_V8DFmode:
          if (pattern473 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29878 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9903; /* avx512dq_rangepv8df_mask */

        case E_V4DFmode:
          if (pattern473 (x2, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29878 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9906; /* avx512dq_rangepv4df_mask */

        case E_V2DFmode:
          if (pattern473 (x2, 
E_V2DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29878 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9908; /* avx512dq_rangepv2df_mask */

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x7, 0) != 1L)
        return -1;
      switch (pattern1097 (x2))
        {
        case 0:
          if (!
#line 29901 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ))
            return -1;
          return 9909; /* avx512dq_rangesv4sf */

        case 1:
          if (!(
#line 29901 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 474 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 9913; /* avx512dq_rangesv2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_143 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (XINT (x3, 1))
    {
    case 193:
      x4 = XEXP (x2, 2);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x3, 0, 2);
      operands[3] = x7;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      switch (pattern458 (x2))
        {
        case 0:
          if (!(
#line 4054 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8HFmode))) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 3195; /* reducesv8hf */

        case 1:
          if (!
#line 4054 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V4SFmode))))
            return -1;
          return 3199; /* reducesv4sf */

        case 2:
          if (!(
#line 4054 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V2DFmode))) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 3203; /* reducesv2df */

        default:
          return -1;
        }

    case 60:
      x4 = XEXP (x2, 2);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x3, 0, 2);
      operands[3] = x7;
      if (!cmpps_imm_operand (operands[3], E_SImode))
        return -1;
      switch (pattern1097 (x2))
        {
        case 0:
          if (!
#line 4327 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 3239; /* avx_vmcmpv4sf3 */

        case 1:
          if (!(
#line 4327 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 474 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 3240; /* avx_vmcmpv2df3 */

        default:
          return -1;
        }

    case 134:
      return recog_133 (x1, insn, pnum_clobbers);

    case 218:
      switch (pattern472 (x2))
        {
        case 0:
          if (!(
#line 7240 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 564 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4263; /* fma_fmaddc_v32hf_maskz_1 */

        case 1:
          if (!(
#line 7240 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 564 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4270; /* fma_fmaddc_v16hf_maskz_1 */

        case 2:
          if (!(
#line 7240 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 564 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4274; /* fma_fmaddc_v8hf_maskz_1 */

        case 3:
          if (!(
#line 7378 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 564 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4301; /* avx512bw_fmaddc_v32hf_mask */

        case 4:
          if (!(
#line 7378 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 564 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4305; /* avx512vl_fmaddc_v16hf_mask */

        case 5:
          if (!(
#line 7378 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 564 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4307; /* avx512fp16_fmaddc_v8hf_mask */

        case 6:
          if (!
#line 7567 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
            return -1;
          return 4325; /* avx512fp16_fma_fmaddcsh_v8hf */

        default:
          return -1;
        }

    case 220:
      switch (pattern472 (x2))
        {
        case 0:
          if (!(
#line 7240 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 564 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4267; /* fma_fcmaddc_v32hf_maskz_1 */

        case 1:
          if (!(
#line 7240 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 564 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4272; /* fma_fcmaddc_v16hf_maskz_1 */

        case 2:
          if (!(
#line 7240 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 564 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4276; /* fma_fcmaddc_v8hf_maskz_1 */

        case 3:
          if (!(
#line 7378 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 564 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4303; /* avx512bw_fcmaddc_v32hf_mask */

        case 4:
          if (!(
#line 7378 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 564 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4306; /* avx512vl_fcmaddc_v16hf_mask */

        case 5:
          if (!(
#line 7378 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 564 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4308; /* avx512fp16_fcmaddc_v8hf_mask */

        case 6:
          if (!
#line 7567 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
            return -1;
          return 4329; /* avx512fp16_fma_fcmaddcsh_v8hf */

        default:
          return -1;
        }

    case 168:
      return recog_140 (x1, insn, pnum_clobbers);

    case 122:
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x3, 0, 2);
      operands[3] = x7;
      if (!const_0_to_255_mul_8_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[4] = x8;
      x4 = XEXP (x2, 2);
      operands[5] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V64QImode:
          if (pattern478 (x2, 
E_V64QImode, 
E_DImode) != 0
              || !(
#line 23289 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && (64 == 64 || TARGET_AVX512VL)) && 
#line 642 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8576; /* avx512bw_palignrv64qi_mask */

        case E_V32QImode:
          if (pattern478 (x2, 
E_V32QImode, 
E_SImode) != 0
              || !(
#line 23289 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && (32 == 64 || TARGET_AVX512VL)) && 
#line 642 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 8577; /* avx2_palignrv32qi_mask */

        case E_V16QImode:
          if (pattern478 (x2, 
E_V16QImode, 
E_HImode) != 0
              || !
#line 23289 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && (16 == 64 || TARGET_AVX512VL)))
            return -1;
          return 8578; /* ssse3_palignrv16qi_mask */

        default:
          return -1;
        }

    case 129:
      switch (pattern474 (x2, 
E_SImode))
        {
        case 0:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 23883 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 8659; /* avx10_2_mpsadbw_mask */

        case 1:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 23895 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 610 "../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 8661; /* avx2_mpsadbw_mask */

        case 2:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 23895 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 8663; /* sse4_1_mpsadbw_mask */

        default:
          return -1;
        }

    case 156:
      return recog_132 (x1, insn, pnum_clobbers);

    case 195:
      return recog_137 (x1, insn, pnum_clobbers);

    case 167:
      x4 = XEXP (x2, 2);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x3, 0, 2);
      operands[3] = x7;
      if (!const_0_to_15_operand (operands[3], E_SImode))
        return -1;
      switch (pattern458 (x2))
        {
        case 0:
          if (!(
#line 29969 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 9977; /* avx512f_vgetmantv8hf */

        case 1:
          if (!
#line 29969 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 9981; /* avx512f_vgetmantv4sf */

        case 2:
          if (!(
#line 29969 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 9985; /* avx512f_vgetmantv2df */

        default:
          return -1;
        }

    case 187:
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x3, 0, 2);
      operands[3] = x7;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[4] = x8;
      x4 = XEXP (x2, 2);
      operands[5] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern1261 (x2, 
E_QImode, 
E_V8HImode, 
E_V16QImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29990 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 695 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9990; /* avx512bw_dbpsadbwv8hi_mask */

        case E_V16HImode:
          if (pattern1261 (x2, 
E_HImode, 
E_V16HImode, 
E_V32QImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29990 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 695 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9992; /* avx512bw_dbpsadbwv16hi_mask */

        case E_V32HImode:
          if (pattern1261 (x2, 
E_SImode, 
E_V32HImode, 
E_V64QImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29990 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 695 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9994; /* avx512bw_dbpsadbwv32hi_mask */

        default:
          return -1;
        }

    case 196:
      switch (pattern477 (x2))
        {
        case 0:
          if (!(
#line 30308 "../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 633 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 10050; /* vpmadd52luqv8di_maskz_1 */

        case 1:
          if (!(
#line 30308 "../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 633 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10052; /* vpmadd52luqv4di_maskz_1 */

        case 2:
          if (!(
#line 30308 "../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 633 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10054; /* vpmadd52luqv2di_maskz_1 */

        case 3:
          if (!(
#line 30324 "../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 633 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 10056; /* vpmadd52luqv8di_mask */

        case 4:
          if (!(
#line 30324 "../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 633 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10058; /* vpmadd52luqv4di_mask */

        case 5:
          if (!(
#line 30324 "../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 633 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10060; /* vpmadd52luqv2di_mask */

        default:
          return -1;
        }

    case 197:
      switch (pattern477 (x2))
        {
        case 0:
          if (!(
#line 30308 "../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 633 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 10051; /* vpmadd52huqv8di_maskz_1 */

        case 1:
          if (!(
#line 30308 "../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 633 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10053; /* vpmadd52huqv4di_maskz_1 */

        case 2:
          if (!(
#line 30308 "../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 633 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10055; /* vpmadd52huqv2di_maskz_1 */

        case 3:
          if (!(
#line 30324 "../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 633 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 10057; /* vpmadd52huqv8di_mask */

        case 4:
          if (!(
#line 30324 "../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 633 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10059; /* vpmadd52huqv4di_mask */

        case 5:
          if (!(
#line 30324 "../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 633 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10061; /* vpmadd52huqv2di_mask */

        default:
          return -1;
        }

    case 199:
      switch (pattern474 (x2, 
E_VOIDmode))
        {
        case 0:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30412 "../../gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 645 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 10101; /* vgf2p8affineinvqb_v64qi_mask */

        case 1:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30412 "../../gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 645 "../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 10103; /* vgf2p8affineinvqb_v32qi_mask */

        case 2:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 30412 "../../gcc/config/i386/sse.md"
(TARGET_GFNI)))
            return -1;
          return 10105; /* vgf2p8affineinvqb_v16qi_mask */

        default:
          return -1;
        }

    case 200:
      switch (pattern474 (x2, 
E_VOIDmode))
        {
        case 0:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30429 "../../gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 645 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 10107; /* vgf2p8affineqb_v64qi_mask */

        case 1:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30429 "../../gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 645 "../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 10109; /* vgf2p8affineqb_v32qi_mask */

        case 2:
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 30429 "../../gcc/config/i386/sse.md"
(TARGET_GFNI)))
            return -1;
          return 10111; /* vgf2p8affineqb_v16qi_mask */

        default:
          return -1;
        }

    case 203:
      return recog_141 (x1, insn, pnum_clobbers);

    case 202:
      return recog_142 (x1, insn, pnum_clobbers);

    case 204:
      return recog_136 (x1, insn, pnum_clobbers);

    case 205:
      return recog_135 (x1, insn, pnum_clobbers);

    case 206:
      switch (pattern484 (x2))
        {
        case 0:
          if (!(
#line 30675 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 10211; /* vpdpbusd_v16si_mask */

        case 1:
          if (!(
#line 30675 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10212; /* vpdpbusd_v8si_mask */

        case 2:
          if (!(
#line 30675 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10213; /* vpdpbusd_v4si_mask */

        case 3:
          if (!(
#line 30704 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 10214; /* vpdpbusd_v16si_maskz_1 */

        case 4:
          if (!(
#line 30704 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10215; /* vpdpbusd_v8si_maskz_1 */

        case 5:
          if (!(
#line 30704 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10216; /* vpdpbusd_v4si_maskz_1 */

        default:
          return -1;
        }

    case 207:
      switch (pattern484 (x2))
        {
        case 0:
          if (!(
#line 30744 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 10220; /* vpdpbusds_v16si_mask */

        case 1:
          if (!(
#line 30744 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10221; /* vpdpbusds_v8si_mask */

        case 2:
          if (!(
#line 30744 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10222; /* vpdpbusds_v4si_mask */

        case 3:
          if (!(
#line 30773 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 10223; /* vpdpbusds_v16si_maskz_1 */

        case 4:
          if (!(
#line 30773 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10224; /* vpdpbusds_v8si_maskz_1 */

        case 5:
          if (!(
#line 30773 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10225; /* vpdpbusds_v4si_maskz_1 */

        default:
          return -1;
        }

    case 208:
      switch (pattern484 (x2))
        {
        case 0:
          if (!(
#line 30813 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 10229; /* vpdpwssd_v16si_mask */

        case 1:
          if (!(
#line 30813 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10230; /* vpdpwssd_v8si_mask */

        case 2:
          if (!(
#line 30813 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10231; /* vpdpwssd_v4si_mask */

        case 3:
          if (!(
#line 30842 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 10232; /* vpdpwssd_v16si_maskz_1 */

        case 4:
          if (!(
#line 30842 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10233; /* vpdpwssd_v8si_maskz_1 */

        case 5:
          if (!(
#line 30842 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10234; /* vpdpwssd_v4si_maskz_1 */

        default:
          return -1;
        }

    case 209:
      switch (pattern484 (x2))
        {
        case 0:
          if (!(
#line 30882 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 10238; /* vpdpwssds_v16si_mask */

        case 1:
          if (!(
#line 30882 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10239; /* vpdpwssds_v8si_mask */

        case 2:
          if (!(
#line 30882 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10240; /* vpdpwssds_v4si_mask */

        case 3:
          if (!(
#line 30911 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 10241; /* vpdpwssds_v16si_maskz_1 */

        case 4:
          if (!(
#line 30911 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10242; /* vpdpwssds_v8si_maskz_1 */

        case 5:
          if (!(
#line 30911 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10243; /* vpdpwssds_v4si_maskz_1 */

        default:
          return -1;
        }

    case 217:
      return recog_138 (x1, insn, pnum_clobbers);

    case 228:
      switch (pattern486 (x2))
        {
        case 0:
          if (!
#line 31670 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10324; /* vpdpbssd_v16si_mask */

        case 1:
          if (!
#line 31670 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10330; /* vpdpbssd_v8si_mask */

        case 2:
          if (!
#line 31670 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10336; /* vpdpbssd_v4si_mask */

        case 3:
          if (!
#line 31697 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10342; /* *vpdpbssd_v16si_maskz */

        case 4:
          if (!
#line 31697 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10348; /* *vpdpbssd_v8si_maskz */

        case 5:
          if (!
#line 31697 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10354; /* *vpdpbssd_v4si_maskz */

        default:
          return -1;
        }

    case 229:
      switch (pattern486 (x2))
        {
        case 0:
          if (!
#line 31670 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10325; /* vpdpbssds_v16si_mask */

        case 1:
          if (!
#line 31670 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10331; /* vpdpbssds_v8si_mask */

        case 2:
          if (!
#line 31670 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10337; /* vpdpbssds_v4si_mask */

        case 3:
          if (!
#line 31697 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10343; /* *vpdpbssds_v16si_maskz */

        case 4:
          if (!
#line 31697 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10349; /* *vpdpbssds_v8si_maskz */

        case 5:
          if (!
#line 31697 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10355; /* *vpdpbssds_v4si_maskz */

        default:
          return -1;
        }

    case 230:
      switch (pattern486 (x2))
        {
        case 0:
          if (!
#line 31670 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10326; /* vpdpbsud_v16si_mask */

        case 1:
          if (!
#line 31670 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10332; /* vpdpbsud_v8si_mask */

        case 2:
          if (!
#line 31670 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10338; /* vpdpbsud_v4si_mask */

        case 3:
          if (!
#line 31697 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10344; /* *vpdpbsud_v16si_maskz */

        case 4:
          if (!
#line 31697 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10350; /* *vpdpbsud_v8si_maskz */

        case 5:
          if (!
#line 31697 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10356; /* *vpdpbsud_v4si_maskz */

        default:
          return -1;
        }

    case 231:
      switch (pattern486 (x2))
        {
        case 0:
          if (!
#line 31670 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10327; /* vpdpbsuds_v16si_mask */

        case 1:
          if (!
#line 31670 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10333; /* vpdpbsuds_v8si_mask */

        case 2:
          if (!
#line 31670 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10339; /* vpdpbsuds_v4si_mask */

        case 3:
          if (!
#line 31697 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10345; /* *vpdpbsuds_v16si_maskz */

        case 4:
          if (!
#line 31697 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10351; /* *vpdpbsuds_v8si_maskz */

        case 5:
          if (!
#line 31697 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10357; /* *vpdpbsuds_v4si_maskz */

        default:
          return -1;
        }

    case 232:
      switch (pattern486 (x2))
        {
        case 0:
          if (!
#line 31670 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10328; /* vpdpbuud_v16si_mask */

        case 1:
          if (!
#line 31670 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10334; /* vpdpbuud_v8si_mask */

        case 2:
          if (!
#line 31670 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10340; /* vpdpbuud_v4si_mask */

        case 3:
          if (!
#line 31697 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10346; /* *vpdpbuud_v16si_maskz */

        case 4:
          if (!
#line 31697 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10352; /* *vpdpbuud_v8si_maskz */

        case 5:
          if (!
#line 31697 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10358; /* *vpdpbuud_v4si_maskz */

        default:
          return -1;
        }

    case 233:
      switch (pattern486 (x2))
        {
        case 0:
          if (!
#line 31670 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10329; /* vpdpbuuds_v16si_mask */

        case 1:
          if (!
#line 31670 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10335; /* vpdpbuuds_v8si_mask */

        case 2:
          if (!
#line 31670 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10341; /* vpdpbuuds_v4si_mask */

        case 3:
          if (!
#line 31697 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10347; /* *vpdpbuuds_v16si_maskz */

        case 4:
          if (!
#line 31697 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10353; /* *vpdpbuuds_v8si_maskz */

        case 5:
          if (!
#line 31697 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10359; /* *vpdpbuuds_v4si_maskz */

        default:
          return -1;
        }

    case 234:
      switch (pattern486 (x2))
        {
        case 0:
          if (!
#line 32079 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10476; /* vpdpwusd_v16si_mask */

        case 1:
          if (!
#line 32079 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10482; /* vpdpwusd_v8si_mask */

        case 2:
          if (!
#line 32079 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10488; /* vpdpwusd_v4si_mask */

        case 3:
          if (!
#line 32106 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10494; /* *vpdpwusd_v16si_maskz */

        case 4:
          if (!
#line 32106 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10500; /* *vpdpwusd_v8si_maskz */

        case 5:
          if (!
#line 32106 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10506; /* *vpdpwusd_v4si_maskz */

        default:
          return -1;
        }

    case 235:
      switch (pattern486 (x2))
        {
        case 0:
          if (!
#line 32079 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10477; /* vpdpwusds_v16si_mask */

        case 1:
          if (!
#line 32079 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10483; /* vpdpwusds_v8si_mask */

        case 2:
          if (!
#line 32079 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10489; /* vpdpwusds_v4si_mask */

        case 3:
          if (!
#line 32106 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10495; /* *vpdpwusds_v16si_maskz */

        case 4:
          if (!
#line 32106 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10501; /* *vpdpwusds_v8si_maskz */

        case 5:
          if (!
#line 32106 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10507; /* *vpdpwusds_v4si_maskz */

        default:
          return -1;
        }

    case 236:
      switch (pattern486 (x2))
        {
        case 0:
          if (!
#line 32079 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10478; /* vpdpwsud_v16si_mask */

        case 1:
          if (!
#line 32079 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10484; /* vpdpwsud_v8si_mask */

        case 2:
          if (!
#line 32079 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10490; /* vpdpwsud_v4si_mask */

        case 3:
          if (!
#line 32106 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10496; /* *vpdpwsud_v16si_maskz */

        case 4:
          if (!
#line 32106 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10502; /* *vpdpwsud_v8si_maskz */

        case 5:
          if (!
#line 32106 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10508; /* *vpdpwsud_v4si_maskz */

        default:
          return -1;
        }

    case 237:
      switch (pattern486 (x2))
        {
        case 0:
          if (!
#line 32079 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10479; /* vpdpwsuds_v16si_mask */

        case 1:
          if (!
#line 32079 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10485; /* vpdpwsuds_v8si_mask */

        case 2:
          if (!
#line 32079 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10491; /* vpdpwsuds_v4si_mask */

        case 3:
          if (!
#line 32106 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10497; /* *vpdpwsuds_v16si_maskz */

        case 4:
          if (!
#line 32106 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10503; /* *vpdpwsuds_v8si_maskz */

        case 5:
          if (!
#line 32106 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10509; /* *vpdpwsuds_v4si_maskz */

        default:
          return -1;
        }

    case 238:
      switch (pattern486 (x2))
        {
        case 0:
          if (!
#line 32079 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10480; /* vpdpwuud_v16si_mask */

        case 1:
          if (!
#line 32079 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10486; /* vpdpwuud_v8si_mask */

        case 2:
          if (!
#line 32079 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10492; /* vpdpwuud_v4si_mask */

        case 3:
          if (!
#line 32106 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10498; /* *vpdpwuud_v16si_maskz */

        case 4:
          if (!
#line 32106 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10504; /* *vpdpwuud_v8si_maskz */

        case 5:
          if (!
#line 32106 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10510; /* *vpdpwuud_v4si_maskz */

        default:
          return -1;
        }

    case 239:
      switch (pattern486 (x2))
        {
        case 0:
          if (!
#line 32079 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10481; /* vpdpwuuds_v16si_mask */

        case 1:
          if (!
#line 32079 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10487; /* vpdpwuuds_v8si_mask */

        case 2:
          if (!
#line 32079 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10493; /* vpdpwuuds_v4si_mask */

        case 3:
          if (!
#line 32106 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10499; /* *vpdpwuuds_v16si_maskz */

        case 4:
          if (!
#line 32106 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10505; /* *vpdpwuuds_v8si_maskz */

        case 5:
          if (!
#line 32106 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10511; /* *vpdpwuuds_v4si_maskz */

        default:
          return -1;
        }

    case 245:
      return recog_139 (x1, insn, pnum_clobbers);

    case 278:
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x3, 0, 2);
      operands[3] = x7;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[4] = x8;
      x4 = XEXP (x2, 2);
      operands[5] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V32BFmode:
          if (pattern1262 (x2, 
E_SImode, 
E_V32BFmode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32707 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10834; /* avx10_2_minmaxbf16_v32bf_mask */

        case E_V16BFmode:
          if (pattern1262 (x2, 
E_HImode, 
E_V16BFmode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32707 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10836; /* avx10_2_minmaxbf16_v16bf_mask */

        case E_V8BFmode:
          if (pattern1262 (x2, 
E_QImode, 
E_V8BFmode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32707 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10838; /* avx10_2_minmaxbf16_v8bf_mask */

        default:
          return -1;
        }

    case 279:
      return recog_134 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_168 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 1);
  operands[3] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[4] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[5] = x7;
  x8 = XEXP (x2, 1);
  operands[6] = x8;
  x9 = XEXP (x2, 2);
  operands[7] = x9;
  if (!register_operand (operands[7], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || GET_MODE (x3) != E_V4SFmode
          || pattern1648 (
E_V16SFmode) != 0
          || !nonimm_or_0_operand (operands[6], E_V4SFmode)
          || !(
#line 12560 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && INTVAL (operands[2]) % 4 == 0
   && INTVAL (operands[2]) == INTVAL (operands[3]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[4]) == INTVAL (operands[5]) - 1
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[6]))) && 
#line 731 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 5253; /* avx512f_vextractf32x4_1_mask */

    case E_V4SImode:
      if (GET_MODE (x2) != E_V4SImode
          || GET_MODE (x3) != E_V4SImode
          || !nonimm_or_0_operand (operands[6], E_V4SImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_V4SImode)
          && pattern1648 (
E_V16SImode) == 0
          && (
#line 12560 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && INTVAL (operands[2]) % 4 == 0
   && INTVAL (operands[2]) == INTVAL (operands[3]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[4]) == INTVAL (operands[5]) - 1
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[6]))) && 
#line 731 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 5254; /* avx512f_vextracti32x4_1_mask */
      if (!register_operand (operands[0], E_V4SImode)
          || !vector_operand (operands[1], E_V4SImode)
          || pattern1678 () != 0
          || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20754 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
        return -1;
      return 8378; /* sse2_pshufd_1_mask */

    case E_V4DImode:
      if (pattern751 (x2, 
E_V4DImode) != 0
          || pattern1678 () != 0
          || !nonimm_or_0_operand (operands[6], E_V4DImode)
          || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 27618 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && (32 == 64 || TARGET_AVX512VL))))
        return -1;
      return 9106; /* avx2_permv4di_1_mask */

    default:
      return -1;
    }
}

 int
recog_172 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 4);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  operands[6] = x5;
  res = recog_171 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (XWINT (x5, 0) != 4L)
    return -1;
  x6 = XVECEXP (x4, 0, 5);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x7 = XVECEXP (x4, 0, 6);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x8 = XVECEXP (x4, 0, 7);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
      || pattern1283 (x2, 
E_V8HImode) != 0
      || pattern890 (x4) != 0)
    return -1;
  x9 = XEXP (x2, 1);
  operands[6] = x9;
  if (!nonimm_or_0_operand (operands[6], E_V8HImode))
    return -1;
  x10 = XEXP (x2, 2);
  operands[7] = x10;
  if (!register_operand (operands[7], E_QImode)
      || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20910 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512BW && TARGET_AVX512VL)))
    return -1;
  return 8384; /* sse2_pshuflw_1_mask */
}

 int
recog_176 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  operands[2] = x5;
  res = recog_175 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (XWINT (x5, 0) != 0L)
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
      || pattern1284 (x4, 
11, 
10, 
9, 
8) != 0
      || pattern751 (x2, 
E_V16HImode) != 0
      || pattern1527 (x4) != 0)
    return -1;
  x9 = XVECEXP (x4, 0, 12);
  operands[6] = x9;
  if (!const_12_to_15_operand (operands[6], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x4, 0, 13);
  operands[7] = x10;
  if (!const_12_to_15_operand (operands[7], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x4, 0, 14);
  operands[8] = x11;
  if (!const_12_to_15_operand (operands[8], E_VOIDmode))
    return -1;
  x12 = XVECEXP (x4, 0, 15);
  operands[9] = x12;
  if (!const_12_to_15_operand (operands[9], E_VOIDmode))
    return -1;
  x13 = XEXP (x2, 1);
  operands[10] = x13;
  if (!nonimm_or_0_operand (operands[10], E_V16HImode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[11] = x14;
  if (!register_operand (operands[11], E_HImode)
      || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 21001 "../../gcc/config/i386/sse.md"
(TARGET_AVX2
   && TARGET_AVX512BW && TARGET_AVX512VL
   && INTVAL (operands[2]) + 8 == INTVAL (operands[6])
   && INTVAL (operands[3]) + 8 == INTVAL (operands[7])
   && INTVAL (operands[4]) + 8 == INTVAL (operands[8])
   && INTVAL (operands[5]) + 8 == INTVAL (operands[9]))))
    return -1;
  return 8388; /* avx2_pshufhw_1_mask */
}

 int
recog_181 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case MEM:
          operands[3] = x5;
          x6 = XEXP (x2, 2);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          operands[2] = x4;
          x7 = XEXP (x3, 2);
          operands[4] = x7;
          if (!register_operand (operands[4], E_QImode))
            return -1;
          x8 = XEXP (x2, 1);
          operands[1] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern1263 (x2, 
E_V8HFmode) != 0
                  || !(
#line 1705 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 2497; /* avx512f_movhf_mask */

            case E_V4SFmode:
              if (pattern1263 (x2, 
E_V4SFmode) != 0
                  || !
#line 1705 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
                return -1;
              return 2498; /* avx512f_movsf_mask */

            case E_V2DFmode:
              if (pattern1263 (x2, 
E_V2DFmode) != 0
                  || !(
#line 1705 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 2499; /* avx512f_movdf_mask */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          operands[1] = x4;
          x9 = XEXP (x5, 0);
          operands[2] = x9;
          x7 = XEXP (x3, 2);
          operands[3] = x7;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x8 = XEXP (x2, 1);
          operands[4] = x8;
          x6 = XEXP (x2, 2);
          operands[5] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V8DFmode:
              if (pattern1264 (x2, 
E_V8DFmode, 
E_V2DFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20101 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 12455 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_EVEX512))))
                return -1;
              return 8326; /* avx512dq_vinsertf64x2_1_mask */

            case E_V8DImode:
              if (pattern1264 (x2, 
E_V8DImode, 
E_V2DImode, 
E_QImode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20101 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 12456 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_EVEX512))))
                return -1;
              return 8328; /* avx512dq_vinserti64x2_1_mask */

            case E_V16SFmode:
              if (pattern1264 (x2, 
E_V16SFmode, 
E_V4SFmode, 
E_HImode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20101 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 12457 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8330; /* avx512f_vinsertf32x4_1_mask */

            case E_V16SImode:
              if (pattern1264 (x2, 
E_V16SImode, 
E_V4SImode, 
E_HImode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20101 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 12457 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8332; /* avx512f_vinserti32x4_1_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case SUBREG:
        case MEM:
          operands[1] = x10;
          x6 = XEXP (x2, 2);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          x7 = XEXP (x3, 2);
          operands[3] = x7;
          if (!register_operand (operands[3], E_QImode))
            return -1;
          x8 = XEXP (x2, 1);
          operands[4] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern1265 (x2, 
E_V8HFmode, 
E_HFmode) != 0
                  || !(
#line 1734 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1357 "../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16)))
                return -1;
              return 2500; /* *avx512f_loadhf_mask */

            case E_V4SFmode:
              if (pattern1265 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 1734 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
                return -1;
              return 2501; /* *avx512f_loadsf_mask */

            case E_V2DFmode:
              if (pattern1265 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 1734 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
                return -1;
              return 2502; /* *avx512f_loaddf_mask */

            default:
              return -1;
            }

        case SQRT:
          x6 = XEXP (x2, 2);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x11 = XEXP (x10, 0);
          operands[1] = x11;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          x7 = XEXP (x3, 2);
          operands[4] = x7;
          if (!register_operand (operands[4], E_QImode))
            return -1;
          x8 = XEXP (x2, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern1266 (x2, 
E_V8HFmode, 
E_HFmode) != 0
                  || !(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3115 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 2942; /* *avx512fp16_vmsqrtv8hf2_mask */

            case E_V4SFmode:
              if (pattern1266 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3115 "../../gcc/config/i386/sse.md"
(TARGET_SSE)))
                return -1;
              return 2946; /* *sse_vmsqrtv4sf2_mask */

            case E_V2DFmode:
              if (pattern1266 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3115 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 2950; /* *sse2_vmsqrtv2df2_mask */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x10, 0) != 1
              || XINT (x10, 1) != 56
              || GET_MODE (x10) != E_HFmode)
            return -1;
          x6 = XEXP (x2, 2);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || pattern993 (x2, 
E_V8HFmode) != 0)
            return -1;
          x12 = XVECEXP (x10, 0, 0);
          operands[1] = x12;
          if (!nonimmediate_operand (operands[1], E_HFmode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (!nonimm_or_0_operand (operands[3], E_V8HFmode))
            return -1;
          x7 = XEXP (x3, 2);
          operands[4] = x7;
          if (!register_operand (operands[4], E_QImode))
            return -1;
          x8 = XEXP (x2, 1);
          operands[2] = x8;
          if (!register_operand (operands[2], E_V8HFmode)
              || !(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3264 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 2981; /* *avx512fp16_vmrsqrtv8hf2 */

        case FLOAT_EXTEND:
          x6 = XEXP (x2, 2);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          x7 = XEXP (x3, 2);
          operands[4] = x7;
          if (!register_operand (operands[4], E_QImode))
            return -1;
          x8 = XEXP (x2, 1);
          operands[2] = x8;
          x11 = XEXP (x10, 0);
          switch (GET_CODE (x11))
            {
            case VEC_SELECT:
              if (GET_MODE (x11) != E_HFmode)
                return -1;
              x13 = XEXP (x11, 1);
              if (GET_CODE (x13) != PARALLEL
                  || XVECLEN (x13, 0) != 1)
                return -1;
              x14 = XVECEXP (x13, 0, 0);
              if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x15 = XEXP (x11, 0);
              operands[1] = x15;
              if (!register_operand (operands[1], E_V8HFmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V2DFmode:
                  if (pattern1441 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                      || !(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8365 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                    return -1;
                  return 4701; /* avx512fp16_vcvtsh2sd_mask */

                case E_V4SFmode:
                  if (pattern1441 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                      || !(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8365 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                    return -1;
                  return 4705; /* avx512fp16_vcvtsh2ss_mask */

                default:
                  return -1;
                }

            case SUBREG:
            case MEM:
              operands[1] = x11;
              if (!memory_operand (operands[1], E_HFmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V2DFmode:
                  if (pattern1441 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                      || !(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8379 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                    return -1;
                  return 4709; /* avx512fp16_vcvtsh2sd_mask_mem */

                case E_V4SFmode:
                  if (pattern1441 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                      || !(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8379 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                    return -1;
                  return 4711; /* avx512fp16_vcvtsh2ss_mask_mem */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case FLOAT_TRUNCATE:
          x11 = XEXP (x10, 0);
          switch (GET_CODE (x11))
            {
            case VEC_SELECT:
              x13 = XEXP (x11, 1);
              if (GET_CODE (x13) != PARALLEL
                  || XVECLEN (x13, 0) != 1)
                return -1;
              x14 = XVECEXP (x13, 0, 0);
              if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x6 = XEXP (x2, 2);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
                  || pattern877 (x2, 
E_HFmode, 
E_V8HFmode) != 0)
                return -1;
              x15 = XEXP (x11, 0);
              operands[1] = x15;
              x5 = XEXP (x3, 1);
              operands[3] = x5;
              if (!nonimm_or_0_operand (operands[3], E_V8HFmode))
                return -1;
              x7 = XEXP (x3, 2);
              operands[4] = x7;
              if (!register_operand (operands[4], E_QImode))
                return -1;
              x8 = XEXP (x2, 1);
              operands[2] = x8;
              if (!register_operand (operands[2], E_V8HFmode))
                return -1;
              switch (GET_MODE (x11))
                {
                case E_DFmode:
                  if (!register_operand (operands[1], E_V2DFmode)
                      || !(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8395 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                    return -1;
                  return 4714; /* avx512fp16_vcvtsd2sh_mask */

                case E_SFmode:
                  if (!register_operand (operands[1], E_V4SFmode)
                      || !(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8395 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                    return -1;
                  return 4718; /* avx512fp16_vcvtss2sh_mask */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
            case MEM:
              x7 = XEXP (x3, 2);
              switch (GET_CODE (x7))
                {
                case REG:
                case SUBREG:
                  operands[4] = x7;
                  if (!register_operand (operands[4], E_QImode))
                    return -1;
                  x6 = XEXP (x2, 2);
                  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
                      || pattern877 (x2, 
E_HFmode, 
E_V8HFmode) != 0)
                    return -1;
                  operands[1] = x11;
                  x5 = XEXP (x3, 1);
                  operands[3] = x5;
                  if (!nonimm_or_0_operand (operands[3], E_V8HFmode))
                    return -1;
                  x8 = XEXP (x2, 1);
                  operands[2] = x8;
                  if (!register_operand (operands[2], E_V8HFmode))
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_SFmode:
                      if (!memory_operand (operands[1], E_SFmode)
                          || !(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8409 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                        return -1;
                      return 4721; /* avx512fp16_vcvtss2sh_mask_mem */

                    case E_DFmode:
                      if (!memory_operand (operands[1], E_DFmode)
                          || !(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8409 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                        return -1;
                      return 4723; /* avx512fp16_vcvtsd2sh_mask_mem */

                    default:
                      return -1;
                    }

                case CONST_INT:
                  if (XWINT (x7, 0) != 1L
                      || pattern877 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                      || pattern1354 (x2, 
E_V4SFmode, 
E_V2DFmode) != 0
                      || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10066 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                    return -1;
                  return 5082; /* sse2_cvtsd2ss_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      switch (pattern306 (x2))
        {
        case 0:
          if (!(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2723 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 2763; /* avx512fp16_vmaddv8hf3_mask */

        case 1:
          if (!(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2723 "../../gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 2771; /* sse_vmaddv4sf3_mask */

        case 2:
          if (!(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2723 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2779; /* sse2_vmaddv2df3_mask */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern306 (x2))
        {
        case 0:
          if (!(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2723 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 2767; /* avx512fp16_vmsubv8hf3_mask */

        case 1:
          if (!(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2723 "../../gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 2775; /* sse_vmsubv4sf3_mask */

        case 2:
          if (!(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2723 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2783; /* sse2_vmsubv2df3_mask */

        default:
          return -1;
        }

    case MULT:
      switch (pattern306 (x2))
        {
        case 0:
          if (!(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2814 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 2829; /* avx512fp16_vmmulv8hf3_mask */

        case 1:
          if (!(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2814 "../../gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 2837; /* sse_vmmulv4sf3_mask */

        case 2:
          if (!(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2814 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2845; /* sse2_vmmulv2df3_mask */

        default:
          return -1;
        }

    case DIV:
      switch (pattern306 (x2))
        {
        case 0:
          if (!(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2814 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 2833; /* avx512fp16_vmdivv8hf3_mask */

        case 1:
          if (!(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2814 "../../gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 2841; /* sse_vmdivv4sf3_mask */

        case 2:
          if (!(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2814 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2849; /* sse2_vmdivv2df3_mask */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_147 (x1, insn, pnum_clobbers);

    case SQRT:
      x6 = XEXP (x2, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      x7 = XEXP (x3, 2);
      operands[4] = x7;
      if (!register_operand (operands[4], E_QImode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern1197 (x2, 
E_V8HFmode) != 0
              || !(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3096 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 2930; /* avx512fp16_vmsqrtv8hf2_mask */

        case E_V4SFmode:
          if (pattern1197 (x2, 
E_V4SFmode) != 0
              || !(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3096 "../../gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 2934; /* sse_vmsqrtv4sf2_mask */

        case E_V2DFmode:
          if (pattern1197 (x2, 
E_V2DFmode) != 0
              || !(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3096 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2938; /* sse2_vmsqrtv2df2_mask */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern306 (x2))
        {
        case 0:
          if (!(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3480 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 3098; /* *avx512fp16_vmsmaxv8hf3_mask */

        case 1:
          if (!(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3480 "../../gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 3106; /* *sse_vmsmaxv4sf3_mask */

        case 2:
          if (!(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3480 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 3114; /* *sse2_vmsmaxv2df3_mask */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern306 (x2))
        {
        case 0:
          if (!(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3480 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 3102; /* *avx512fp16_vmsminv8hf3_mask */

        case 1:
          if (!(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3480 "../../gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 3110; /* *sse_vmsminv4sf3_mask */

        case 2:
          if (!(
#line 355 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3480 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 3118; /* *sse2_vmsminv2df3_mask */

        default:
          return -1;
        }

    case FMA:
      return recog_146 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      if (pattern307 (x4, 
1, 
E_V2SFmode, 
E_V2DFmode) != 0)
        return -1;
      x7 = XEXP (x3, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode
          || GET_MODE (x3) != E_V2DFmode
          || pattern1354 (x2, 
E_V2DFmode, 
E_V4SFmode) != 0
          || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10110 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 5087; /* sse2_cvtss2sd_mask */

    default:
      return -1;
    }
}

 int
recog_196 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern133 (x2))
    {
    case 0:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3319 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 389 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
        return -1;
      return 2984; /* *smaxv32hf3_mask */

    case 1:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3319 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 390 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 2991; /* *smaxv16hf3_mask */

    case 2:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3319 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (16 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 391 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 2995; /* *smaxv8hf3_mask */

    case 3:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3319 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 392 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 3000; /* *smaxv16sf3_mask */

    case 4:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3319 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 392 "../../gcc/config/i386/sse.md"
(TARGET_AVX))))
        return -1;
      return 3007; /* *smaxv8sf3_mask */

    case 5:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3319 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (16 == 64 || TARGET_AVX512VL)
   && 1)))
        return -1;
      return 3011; /* *smaxv4sf3_mask */

    case 6:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3319 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 393 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 3016; /* *smaxv8df3_mask */

    case 7:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3319 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 393 "../../gcc/config/i386/sse.md"
(TARGET_AVX))))
        return -1;
      return 3023; /* *smaxv4df3_mask */

    case 8:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3319 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (16 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 394 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
        return -1;
      return 3027; /* *smaxv2df3_mask */

    case 9:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17770 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7707; /* *avx512f_smaxv16si3_mask */

    case 10:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17770 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7715; /* *avx512f_smaxv8si3_mask */

    case 11:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonimmediate_operand (operands[2], E_V4SImode)
          && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17770 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return 7723; /* *avx512f_smaxv4si3_mask */
      if (!vector_operand (operands[1], E_V4SImode)
          || !vector_operand (operands[2], E_V4SImode)
          || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17873 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && (16 == 64 || TARGET_AVX512VL)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
        return -1;
      return 7807; /* *sse4_1_smaxv4si3_mask */

    case 12:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17770 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7731; /* *avx512f_smaxv8di3_mask */

    case 13:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17770 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7739; /* *avx512f_smaxv4di3_mask */

    case 14:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17770 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7747; /* *avx512f_smaxv2di3_mask */

    case 15:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17781 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7755; /* *avx512bw_smaxv64qi3_mask */

    case 16:
      if (nonimmediate_operand (operands[1], E_V16QImode)
          && nonimmediate_operand (operands[2], E_V16QImode)
          && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17781 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return 7763; /* *avx512bw_smaxv16qi3_mask */
      if (!vector_operand (operands[1], E_V16QImode)
          || !vector_operand (operands[2], E_V16QImode)
          || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17873 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && (16 == 64 || TARGET_AVX512VL)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
        return -1;
      return 7803; /* *sse4_1_smaxv16qi3_mask */

    case 17:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17781 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7771; /* *avx512bw_smaxv32qi3_mask */

    case 18:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17781 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7779; /* *avx512bw_smaxv32hi3_mask */

    case 19:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17781 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7787; /* *avx512bw_smaxv16hi3_mask */

    case 20:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17781 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7795; /* *avx512bw_smaxv8hi3_mask */

    case 21:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32184 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
        return -1;
      return 10528; /* avx10_2_smaxbf16_v32bf_mask */

    case 22:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32184 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
        return -1;
      return 10532; /* avx10_2_smaxbf16_v16bf_mask */

    case 23:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32184 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
        return -1;
      return 10536; /* avx10_2_smaxbf16_v8bf_mask */

    case 24:
      if (!(
#line 3480 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
        return -1;
      return 3097; /* *avx512fp16_vmsmaxv8hf3 */

    case 25:
      if (!
#line 3480 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 3105; /* *sse_vmsmaxv4sf3 */

    case 26:
      if (!(
#line 3480 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3113; /* *sse2_vmsmaxv2df3 */

    default:
      return -1;
    }
}

 int
recog_208 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x2) != E_V32HFmode
          || !vector_operand (operands[1], E_V32HFmode)
          || !(
#line 14093 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 6955; /* avx512bw_getexpv32hf */

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x2) != E_V16HFmode
          || !vector_operand (operands[1], E_V16HFmode)
          || !(
#line 14093 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 6959; /* avx512vl_getexpv16hf */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x2) != E_V8HFmode
          || !vector_operand (operands[1], E_V8HFmode)
          || !(
#line 14093 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 6963; /* avx512fp16_getexpv8hf */

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x2) != E_V16SFmode
          || !vector_operand (operands[1], E_V16SFmode)
          || !(
#line 14093 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 6967; /* avx512f_getexpv16sf */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x2) != E_V8SFmode
          || !vector_operand (operands[1], E_V8SFmode)
          || !(
#line 14093 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 6971; /* avx512vl_getexpv8sf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || !vector_operand (operands[1], E_V4SFmode)
          || !(
#line 14093 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 6975; /* avx512vl_getexpv4sf */

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x2) != E_V8DFmode
          || !vector_operand (operands[1], E_V8DFmode)
          || !(
#line 14093 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 6979; /* avx512f_getexpv8df */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x2) != E_V4DFmode
          || !vector_operand (operands[1], E_V4DFmode)
          || !(
#line 14093 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 6983; /* avx512vl_getexpv4df */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode
          || !vector_operand (operands[1], E_V2DFmode)
          || !(
#line 14093 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 6987; /* avx512vl_getexpv2df */

    case E_V32BFmode:
      if (!register_operand (operands[0], E_V32BFmode)
          || GET_MODE (x2) != E_V32BFmode
          || !nonimmediate_operand (operands[1], E_V32BFmode)
          || !
#line 32489 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10629; /* avx10_2_getexpbf16_v32bf */

    case E_V16BFmode:
      if (!register_operand (operands[0], E_V16BFmode)
          || GET_MODE (x2) != E_V16BFmode
          || !nonimmediate_operand (operands[1], E_V16BFmode)
          || !
#line 32489 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10631; /* avx10_2_getexpbf16_v16bf */

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x2) != E_V8BFmode
          || !nonimmediate_operand (operands[1], E_V8BFmode)
          || !
#line 32489 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10633; /* avx10_2_getexpbf16_v8bf */

    default:
      return -1;
    }
}

 int
recog_216 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern321 (x2))
    {
    case 0:
      if (!(
#line 1647 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2461; /* *avx512f_loadv16si */

    case 1:
      if (!(
#line 1647 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2462; /* *avx512vl_loadv8si */

    case 2:
      if (!(
#line 1647 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2463; /* *avx512vl_loadv4si */

    case 3:
      if (!(
#line 1647 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2464; /* *avx512f_loadv8di */

    case 4:
      if (!(
#line 1647 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2465; /* *avx512vl_loadv4di */

    case 5:
      if (!(
#line 1647 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2466; /* *avx512vl_loadv2di */

    case 6:
      if (!(
#line 1647 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2467; /* *avx512f_loadv16sf */

    case 7:
      if (!(
#line 1647 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2468; /* *avx512vl_loadv8sf */

    case 8:
      if (!(
#line 1647 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2469; /* *avx512vl_loadv4sf */

    case 9:
      if (!(
#line 1647 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2470; /* *avx512f_loadv8df */

    case 10:
      if (!(
#line 1647 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2471; /* *avx512vl_loadv4df */

    case 11:
      if (!(
#line 1647 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2472; /* *avx512vl_loadv2df */

    case 12:
      if (!(
#line 1691 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2485; /* *avx512bw_loadv64qi */

    case 13:
      if (!(
#line 1691 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2486; /* *avx512vl_loadv16qi */

    case 14:
      if (!(
#line 1691 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2487; /* *avx512vl_loadv32qi */

    case 15:
      if (!(
#line 1691 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2488; /* *avx512bw_loadv32hi */

    case 16:
      if (!(
#line 1691 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2489; /* *avx512vl_loadv16hi */

    case 17:
      if (!(
#line 1691 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2490; /* *avx512vl_loadv8hi */

    case 18:
      if (!(
#line 1691 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2491; /* *avx512bw_loadv32hf */

    case 19:
      if (!(
#line 1691 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2492; /* *avx512vl_loadv16hf */

    case 20:
      if (!(
#line 1691 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2493; /* *avx512fp16_loadv8hf */

    case 21:
      if (!(
#line 1691 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2494; /* *avx512bw_loadv32bf */

    case 22:
      if (!(
#line 1691 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2495; /* *avx512vl_loadv16bf */

    case 23:
      if (!(
#line 1691 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2496; /* *avx512vl_loadv8bf */

    default:
      return -1;
    }
}

 int
recog_226 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (XINT (x3, 1))
    {
    case 157:
      if (!const_4_or_8_to_11_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          if (pattern1010 (x2, 
E_V32HFmode, 
E_V32HImode) != 0
              || !(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7710 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 767 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4346; /* avx512fp16_vcvtph2uw_v32hi_round */

        case E_V16SImode:
          if (!register_operand (operands[0], E_V16SImode)
              || GET_MODE (x2) != E_V16SImode
              || GET_MODE (x3) != E_V16SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16HFmode:
              if (!register_operand (operands[1], E_V16HFmode)
                  || !(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7710 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 767 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4354; /* avx512fp16_vcvtph2udq_v16si_round */

            case E_V16SFmode:
              if (!nonimmediate_operand (operands[1], E_V16SFmode)
                  || !(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8773 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4782; /* *avx512f_fixuns_notruncv16sfv16si_round */

            default:
              return -1;
            }

        case E_V8DImode:
          switch (pattern1205 (x2, 
E_V8DImode))
            {
            case 0:
              if (!(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7710 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 767 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4362; /* avx512fp16_vcvtph2uqq_v8di_round */

            case 1:
              if (!(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8806 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DImode == V16SFmode
							      || V8DImode == V8DFmode
							      || V8DImode == V8DImode
							      || V8DImode == V16SImode
							      || V8DImode == V32HFmode)) && 
#line 636 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4802; /* *avx512dq_cvtps2uqqv8di_round */

            case 2:
              if (!(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9784 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 546 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 5028; /* fixuns_notruncv8dfv8di2_round */

            default:
              return -1;
            }

        case E_V16HImode:
          if (pattern1010 (x2, 
E_V16HFmode, 
E_V16HImode) != 0
              || !(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7710 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 768 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4370; /* avx512fp16_vcvtph2uw_v16hi_round */

        case E_V8SImode:
          switch (pattern1205 (x2, 
E_V8SImode))
            {
            case 0:
              if (!(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7710 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 768 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4378; /* avx512fp16_vcvtph2udq_v8si_round */

            case 1:
              if (!(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8773 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4786; /* *avx512vl_fixuns_notruncv8sfv8si_round */

            case 2:
              if (!(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9565 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 470 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4948; /* fixuns_notruncv8dfv8si2_round */

            default:
              return -1;
            }

        case E_V4DImode:
          if (pattern1010 (x2, 
E_V8HFmode, 
E_V4DImode) != 0
              || !(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7710 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 769 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4386; /* avx512fp16_vcvtph2uqq_v4di_round */

        case E_V8HImode:
          if (pattern1010 (x2, 
E_V8HFmode, 
E_V8HImode) != 0
              || !(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7710 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 769 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4394; /* avx512fp16_vcvtph2uw_v8hi_round */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || GET_MODE (x3) != E_V4SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HFmode:
              if (!register_operand (operands[1], E_V8HFmode)
                  || !(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7710 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 770 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4402; /* avx512fp16_vcvtph2udq_v4si_round */

            case E_V4SFmode:
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8773 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 684 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4790; /* *avx512vl_fixuns_notruncv4sfv4si_round */

            case E_V4DFmode:
              if (!nonimmediate_operand (operands[1], E_V4DFmode)
                  || !(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9565 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 470 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4952; /* fixuns_notruncv4dfv4si2_round */

            default:
              return -1;
            }

        case E_V2DImode:
          if (pattern1010 (x2, 
E_V8HFmode, 
E_V2DImode) != 0
              || !(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7710 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 770 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4410; /* avx512fp16_vcvtph2uqq_v2di_round */

        default:
          return -1;
        }

    case 47:
      if (!const_4_or_8_to_11_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          if (pattern1010 (x2, 
E_V32HFmode, 
E_V32HImode) != 0
              || !(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7710 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 767 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4350; /* avx512fp16_vcvtph2w_v32hi_round */

        case E_V16SImode:
          switch (pattern1012 (x2))
            {
            case 0:
              if (!(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7710 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 767 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4358; /* avx512fp16_vcvtph2dq_v16si_round */

            case 1:
              if (!(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8762 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4778; /* avx512f_fix_notruncv16sfv16si_round */

            default:
              return -1;
            }

        case E_V8DImode:
          if (!register_operand (operands[0], E_V8DImode)
              || GET_MODE (x2) != E_V8DImode
              || GET_MODE (x3) != E_V8DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HFmode:
              if (!register_operand (operands[1], E_V8HFmode)
                  || !(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7710 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 767 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4366; /* avx512fp16_vcvtph2qq_v8di_round */

            case E_V8SFmode:
              if (!nonimmediate_operand (operands[1], E_V8SFmode)
                  || !(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8783 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DImode == V16SFmode
							      || V8DImode == V8DFmode
							      || V8DImode == V8DImode
							      || V8DImode == V16SImode
							      || V8DImode == V32HFmode)) && 
#line 636 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4794; /* *avx512dq_cvtps2qqv8di_round */

            case E_V8DFmode:
              if (!register_operand (operands[1], E_V8DFmode)
                  || !(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9773 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 546 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 5020; /* fix_notruncv8dfv8di2_round */

            default:
              return -1;
            }

        case E_V16HImode:
          if (pattern1010 (x2, 
E_V16HFmode, 
E_V16HImode) != 0
              || !(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7710 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 768 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4374; /* avx512fp16_vcvtph2w_v16hi_round */

        case E_V8SImode:
          switch (pattern1011 (x2))
            {
            case 0:
              if (!(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7710 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 768 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4382; /* avx512fp16_vcvtph2dq_v8si_round */

            case 1:
              if (!(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9464 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4938; /* avx512f_cvtpd2dq512_round */

            default:
              return -1;
            }

        case E_V4DImode:
          if (pattern1010 (x2, 
E_V8HFmode, 
E_V4DImode) != 0
              || !(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7710 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 769 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4390; /* avx512fp16_vcvtph2qq_v4di_round */

        case E_V8HImode:
          if (pattern1010 (x2, 
E_V8HFmode, 
E_V8HImode) != 0
              || !(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7710 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 769 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4398; /* avx512fp16_vcvtph2w_v8hi_round */

        case E_V4SImode:
          if (pattern1010 (x2, 
E_V8HFmode, 
E_V4SImode) != 0
              || !(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7710 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 770 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4406; /* avx512fp16_vcvtph2dq_v4si_round */

        case E_V2DImode:
          if (pattern1010 (x2, 
E_V8HFmode, 
E_V2DImode) != 0
              || !(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7710 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 770 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4414; /* avx512fp16_vcvtph2qq_v2di_round */

        default:
          return -1;
        }

    case 173:
      switch (pattern1013 (x2))
        {
        case 0:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7935 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 703 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4504; /* unspec_avx512fp16_fix_truncv8hi2_round */

        case 1:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7935 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 703 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4512; /* unspec_avx512fp16_fix_truncv16hi2_round */

        case 2:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7935 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 703 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4520; /* unspec_avx512fp16_fix_truncv32hi2_round */

        case 3:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7935 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 704 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4528; /* unspec_avx512fp16_fix_truncv8si2_round */

        case 4:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9623 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4959; /* unspec_fix_truncv8dfv8si2_round */

        case 5:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7935 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 704 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4536; /* unspec_avx512fp16_fix_truncv16si2_round */

        case 6:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8830 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4810; /* unspec_fix_truncv16sfv16si2_round */

        case 7:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7935 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 705 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4544; /* unspec_avx512fp16_fix_truncv8di2_round */

        case 8:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9752 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 546 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4988; /* unspec_fix_truncv8dfv8di2_round */

        case 9:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9795 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DImode == V16SFmode
									      || V8DImode == V8DFmode
									      || V8DImode == V8DImode
									      || V8DImode == V16SImode
									      || V8DImode == V32HFmode)) && 
#line 636 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 5036; /* unspec_fix_truncv8sfv8di2_round */

        default:
          return -1;
        }

    case 174:
      switch (pattern1013 (x2))
        {
        case 0:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7935 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 703 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4508; /* unspec_avx512fp16_fixuns_truncv8hi2_round */

        case 1:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7935 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 703 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4516; /* unspec_avx512fp16_fixuns_truncv16hi2_round */

        case 2:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7935 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 703 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4524; /* unspec_avx512fp16_fixuns_truncv32hi2_round */

        case 3:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7935 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 704 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4532; /* unspec_avx512fp16_fixuns_truncv8si2_round */

        case 4:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9623 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4963; /* unspec_fixuns_truncv8dfv8si2_round */

        case 5:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7935 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 704 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4540; /* unspec_avx512fp16_fixuns_truncv16si2_round */

        case 6:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8830 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4814; /* unspec_fixuns_truncv16sfv16si2_round */

        case 7:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7935 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 705 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4548; /* unspec_avx512fp16_fixuns_truncv8di2_round */

        case 8:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9752 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 546 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4992; /* unspec_fixuns_truncv8dfv8di2_round */

        case 9:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9795 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DImode == V16SFmode
									      || V8DImode == V8DFmode
									      || V8DImode == V8DImode
									      || V8DImode == V16SImode
									      || V8DImode == V32HFmode)) && 
#line 636 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 5040; /* unspec_fixuns_truncv8sfv8di2_round */

        default:
          return -1;
        }

    case 166:
      if (!const48_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern1206 (x2, 
E_V32HFmode) != 0
              || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14093 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 6956; /* avx512bw_getexpv32hf_round */

        case E_V16HFmode:
          if (pattern1206 (x2, 
E_V16HFmode) != 0
              || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14093 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 6960; /* avx512vl_getexpv16hf_round */

        case E_V8HFmode:
          if (pattern1206 (x2, 
E_V8HFmode) != 0
              || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14093 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 6964; /* avx512fp16_getexpv8hf_round */

        case E_V16SFmode:
          if (pattern1206 (x2, 
E_V16SFmode) != 0
              || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14093 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 6968; /* avx512f_getexpv16sf_round */

        case E_V8SFmode:
          if (pattern1206 (x2, 
E_V8SFmode) != 0
              || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14093 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 6972; /* avx512vl_getexpv8sf_round */

        case E_V4SFmode:
          if (pattern1206 (x2, 
E_V4SFmode) != 0
              || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14093 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 6976; /* avx512vl_getexpv4sf_round */

        case E_V8DFmode:
          if (pattern1206 (x2, 
E_V8DFmode) != 0
              || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14093 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 6980; /* avx512f_getexpv8df_round */

        case E_V4DFmode:
          if (pattern1206 (x2, 
E_V4DFmode) != 0
              || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14093 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 6984; /* avx512vl_getexpv4df_round */

        case E_V2DFmode:
          if (pattern1206 (x2, 
E_V2DFmode) != 0
              || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14093 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 6988; /* avx512vl_getexpv2df_round */

        default:
          return -1;
        }

    case 150:
      if (pattern1014 (x2, 
E_V16HImode, 
E_V16SFmode) != 0
          || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29175 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9589; /* *avx512f_vcvtph2ps512_round */

    case 266:
      if (pattern1015 (x2, 
E_V32HFmode, 
E_V32HImode) != 0
          || !(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32582 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 571 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10690; /* avx10_2_cvtph2ibsv32hf_round */

    case 267:
      if (pattern1015 (x2, 
E_V32HFmode, 
E_V32HImode) != 0
          || !(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32582 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 571 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10694; /* avx10_2_cvtph2iubsv32hf_round */

    case 272:
      if (pattern1014 (x2, 
E_V32HFmode, 
E_V32HImode) != 0
          || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32597 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V32HFmode == V16SFmode
									      || V32HFmode == V8DFmode
									      || V32HFmode == V8DImode
									      || V32HFmode == V16SImode
									      || V32HFmode == V32HFmode)) && 
#line 571 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10706; /* avx10_2_cvttph2ibsv32hf_round */

    case 273:
      if (pattern1014 (x2, 
E_V32HFmode, 
E_V32HImode) != 0
          || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32597 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V32HFmode == V16SFmode
									      || V32HFmode == V8DFmode
									      || V32HFmode == V8DImode
									      || V32HFmode == V16SImode
									      || V32HFmode == V32HFmode)) && 
#line 571 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10710; /* avx10_2_cvttph2iubsv32hf_round */

    case 268:
      if (pattern1015 (x2, 
E_V16SFmode, 
E_V16SImode) != 0
          || !(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32612 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10722; /* avx10_2_cvtps2ibsv16sf_round */

    case 269:
      if (pattern1015 (x2, 
E_V16SFmode, 
E_V16SImode) != 0
          || !(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32612 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10726; /* avx10_2_cvtps2iubsv16sf_round */

    case 274:
      if (pattern1014 (x2, 
E_V16SFmode, 
E_V16SImode) != 0
          || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32627 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V16SFmode == V16SFmode
									      || V16SFmode == V8DFmode
									      || V16SFmode == V8DImode
									      || V16SFmode == V16SImode
									      || V16SFmode == V32HFmode)) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10738; /* avx10_2_cvttps2ibsv16sf_round */

    case 275:
      if (pattern1014 (x2, 
E_V16SFmode, 
E_V16SImode) != 0
          || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32627 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V16SFmode == V16SFmode
									      || V16SFmode == V8DFmode
									      || V16SFmode == V8DImode
									      || V16SFmode == V16SImode
									      || V16SFmode == V32HFmode)) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10742; /* avx10_2_cvttps2iubsv16sf_round */

    case 276:
      switch (pattern1016 (x2))
        {
        case 0:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32646 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V16SFmode == V16SFmode
									      || V16SFmode == V8DFmode
									      || V16SFmode == V8DImode
									      || V16SFmode == V16SImode
									      || V16SFmode == V32HFmode)) && 
#line 385 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
            return -1;
          return 10754; /* avx10_2_vcvttps2dqsv16sf_round */

        case 1:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32646 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 386 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
            return -1;
          return 10770; /* avx10_2_vcvttpd2dqsv8df_round */

        case 2:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32657 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 450 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
            return -1;
          return 10786; /* avx10_2_vcvttpd2qqsv8df_round */

        case 3:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32668 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V8DImode == V16SFmode
									      || V8DImode == V8DFmode
									      || V8DImode == V8DImode
									      || V8DImode == V16SImode
									      || V8DImode == V32HFmode)) && 
#line 627 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
            return -1;
          return 10802; /* avx10_2_vcvttps2qqsv8di_round */

        default:
          return -1;
        }

    case 277:
      switch (pattern1016 (x2))
        {
        case 0:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32646 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V16SFmode == V16SFmode
									      || V16SFmode == V8DFmode
									      || V16SFmode == V8DImode
									      || V16SFmode == V16SImode
									      || V16SFmode == V32HFmode)) && 
#line 385 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
            return -1;
          return 10758; /* avx10_2_vcvttps2udqsv16sf_round */

        case 1:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32646 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 386 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
            return -1;
          return 10774; /* avx10_2_vcvttpd2udqsv8df_round */

        case 2:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32657 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 450 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
            return -1;
          return 10790; /* avx10_2_vcvttpd2uqqsv8df_round */

        case 3:
          if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32668 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V8DImode == V16SFmode
									      || V8DImode == V8DFmode
									      || V8DImode == V8DImode
									      || V8DImode == V16SImode
									      || V8DImode == V32HFmode)) && 
#line 627 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
            return -1;
          return 10806; /* avx10_2_vcvttps2uqqsv8di_round */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_239 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (pattern780 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
          || !
#line 28688 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9421; /* avx_maskloadps */

    case E_V2DFmode:
      if (pattern780 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
          || !
#line 28688 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9422; /* avx_maskloadpd */

    case E_V4DImode:
      if (pattern781 (x3, 
E_V4DImode) != 0
          || !
#line 28688 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9423; /* avx2_maskloadq256 */

    case E_V2DImode:
      if (pattern781 (x3, 
E_V2DImode) != 0
          || !
#line 28688 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9424; /* avx2_maskloadq */

    case E_V8SFmode:
      if (pattern780 (x3, 
E_V8SFmode, 
E_V8SImode) != 0
          || !
#line 28688 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9425; /* avx_maskloadps256 */

    case E_V4DFmode:
      if (pattern780 (x3, 
E_V4DFmode, 
E_V4DImode) != 0
          || !
#line 28688 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9426; /* avx_maskloadpd256 */

    case E_V8SImode:
      if (pattern781 (x3, 
E_V8SImode) != 0
          || !
#line 28688 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9427; /* avx2_maskloadd256 */

    case E_V4SImode:
      if (pattern781 (x3, 
E_V4SImode) != 0
          || !
#line 28688 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9428; /* avx2_maskloadd */

    default:
      return -1;
    }
}

 int
recog_245 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8SFmode)
              && nonimmediate_operand (operands[2], E_V8SFmode)
              && nonimmediate_operand (operands[3], E_V8SFmode)
              && (
#line 6483 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4) && 
#line 421 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 4029; /* *fma_fmaddsub_v8sf */
          if (!vector_operand (operands[1], E_V8SFmode)
              || !vector_operand (operands[2], E_V8SFmode)
              || !vector_operand (operands[3], E_V8SFmode)
              || !(
#line 6501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4045; /* *fma_fmaddsub_v8sf */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4SFmode)
              && nonimmediate_operand (operands[2], E_V4SFmode)
              && nonimmediate_operand (operands[3], E_V4SFmode)
              && 
#line 6483 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 4030; /* *fma_fmaddsub_v4sf */
          if (!vector_operand (operands[1], E_V4SFmode)
              || !vector_operand (operands[2], E_V4SFmode)
              || !vector_operand (operands[3], E_V4SFmode)
              || !(
#line 6501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4047; /* *fma_fmaddsub_v4sf */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x3) != E_V4DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4DFmode)
              && nonimmediate_operand (operands[2], E_V4DFmode)
              && nonimmediate_operand (operands[3], E_V4DFmode)
              && (
#line 6483 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 4031; /* *fma_fmaddsub_v4df */
          if (!vector_operand (operands[1], E_V4DFmode)
              || !vector_operand (operands[2], E_V4DFmode)
              || !vector_operand (operands[3], E_V4DFmode)
              || !(
#line 6501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4053; /* *fma_fmaddsub_v4df */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V2DFmode)
              && nonimmediate_operand (operands[2], E_V2DFmode)
              && nonimmediate_operand (operands[3], E_V2DFmode)
              && (
#line 6483 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return 4032; /* *fma_fmaddsub_v2df */
          if (!vector_operand (operands[1], E_V2DFmode)
              || !vector_operand (operands[2], E_V2DFmode)
              || !vector_operand (operands[3], E_V2DFmode)
              || !(
#line 6501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4055; /* *fma_fmaddsub_v2df */

        case E_V32HFmode:
          if (pattern661 (x3, 
E_V32HFmode) != 0
              || !(
#line 6501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 524 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 4033; /* *fma_fmaddsub_v32hf */

        case E_V16HFmode:
          if (pattern661 (x3, 
E_V16HFmode) != 0
              || !(
#line 6501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 525 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4037; /* *fma_fmaddsub_v16hf */

        case E_V8HFmode:
          if (pattern661 (x3, 
E_V8HFmode) != 0
              || !(
#line 6501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 526 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4039; /* *fma_fmaddsub_v8hf */

        case E_V16SFmode:
          if (pattern661 (x3, 
E_V16SFmode) != 0
              || !(
#line 6501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4041; /* *fma_fmaddsub_v16sf */

        case E_V8DFmode:
          if (pattern661 (x3, 
E_V8DFmode) != 0
              || !(
#line 6501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4049; /* *fma_fmaddsub_v8df */

        default:
          return -1;
        }

    case NEG:
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode
              || GET_MODE (x6) != E_V8SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8SFmode)
              && nonimmediate_operand (operands[2], E_V8SFmode)
              && nonimmediate_operand (operands[3], E_V8SFmode)
              && (
#line 6552 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4) && 
#line 421 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 4093; /* *fma_fmsubadd_v8sf */
          if (!vector_operand (operands[1], E_V8SFmode)
              || !vector_operand (operands[2], E_V8SFmode)
              || !vector_operand (operands[3], E_V8SFmode)
              || !(
#line 6571 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4109; /* *fma_fmsubadd_v8sf */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || GET_MODE (x6) != E_V4SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4SFmode)
              && nonimmediate_operand (operands[2], E_V4SFmode)
              && nonimmediate_operand (operands[3], E_V4SFmode)
              && 
#line 6552 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 4094; /* *fma_fmsubadd_v4sf */
          if (!vector_operand (operands[1], E_V4SFmode)
              || !vector_operand (operands[2], E_V4SFmode)
              || !vector_operand (operands[3], E_V4SFmode)
              || !(
#line 6571 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4111; /* *fma_fmsubadd_v4sf */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x3) != E_V4DFmode
              || GET_MODE (x6) != E_V4DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4DFmode)
              && nonimmediate_operand (operands[2], E_V4DFmode)
              && nonimmediate_operand (operands[3], E_V4DFmode)
              && (
#line 6552 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 4095; /* *fma_fmsubadd_v4df */
          if (!vector_operand (operands[1], E_V4DFmode)
              || !vector_operand (operands[2], E_V4DFmode)
              || !vector_operand (operands[3], E_V4DFmode)
              || !(
#line 6571 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4117; /* *fma_fmsubadd_v4df */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || GET_MODE (x6) != E_V2DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V2DFmode)
              && nonimmediate_operand (operands[2], E_V2DFmode)
              && nonimmediate_operand (operands[3], E_V2DFmode)
              && (
#line 6552 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return 4096; /* *fma_fmsubadd_v2df */
          if (!vector_operand (operands[1], E_V2DFmode)
              || !vector_operand (operands[2], E_V2DFmode)
              || !vector_operand (operands[3], E_V2DFmode)
              || !(
#line 6571 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4119; /* *fma_fmsubadd_v2df */

        case E_V32HFmode:
          if (pattern1021 (x3, 
E_V32HFmode) != 0
              || !(
#line 6571 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 524 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 4097; /* *fma_fmsubadd_v32hf */

        case E_V16HFmode:
          if (pattern1021 (x3, 
E_V16HFmode) != 0
              || !(
#line 6571 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 525 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4101; /* *fma_fmsubadd_v16hf */

        case E_V8HFmode:
          if (pattern1021 (x3, 
E_V8HFmode) != 0
              || !(
#line 6571 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 526 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4103; /* *fma_fmsubadd_v8hf */

        case E_V16SFmode:
          if (pattern1021 (x3, 
E_V16SFmode) != 0
              || !(
#line 6571 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4105; /* *fma_fmsubadd_v16sf */

        case E_V8DFmode:
          if (pattern1021 (x3, 
E_V8DFmode) != 0
              || !(
#line 6571 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4113; /* *fma_fmsubadd_v8df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_251 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_255_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (pattern152 (x3, 
E_V32HFmode) != 0
          || !
#line 32719 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10839; /* avx10_2_minmaxpv32hf */

    case E_V16HFmode:
      if (pattern152 (x3, 
E_V16HFmode) != 0
          || !
#line 32719 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10843; /* avx10_2_minmaxpv16hf */

    case E_V8HFmode:
      if (pattern152 (x3, 
E_V8HFmode) != 0
          || !
#line 32719 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10847; /* avx10_2_minmaxpv8hf */

    case E_V16SFmode:
      if (pattern152 (x3, 
E_V16SFmode) != 0
          || !
#line 32719 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10851; /* avx10_2_minmaxpv16sf */

    case E_V8SFmode:
      if (pattern152 (x3, 
E_V8SFmode) != 0
          || !
#line 32719 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10855; /* avx10_2_minmaxpv8sf */

    case E_V4SFmode:
      if (pattern152 (x3, 
E_V4SFmode) != 0
          || !
#line 32719 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10859; /* avx10_2_minmaxpv4sf */

    case E_V8DFmode:
      if (pattern152 (x3, 
E_V8DFmode) != 0
          || !
#line 32719 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10863; /* avx10_2_minmaxpv8df */

    case E_V4DFmode:
      if (pattern152 (x3, 
E_V4DFmode) != 0
          || !
#line 32719 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10867; /* avx10_2_minmaxpv4df */

    case E_V2DFmode:
      if (pattern152 (x3, 
E_V2DFmode) != 0
          || !
#line 32719 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10871; /* avx10_2_minmaxpv2df */

    default:
      return -1;
    }
}

 int
recog_255 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern175 (x1))
    {
    case 0:
      if (!(
#line 30473 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 767 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10136; /* vpshld_v32hi */

    case 1:
      if (!(
#line 30473 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 767 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10138; /* vpshld_v16si */

    case 2:
      if (!(
#line 30473 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 767 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10140; /* vpshld_v8di */

    case 3:
      if (!(
#line 30473 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 768 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10142; /* vpshld_v16hi */

    case 4:
      if (!(
#line 30473 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 768 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10144; /* vpshld_v8si */

    case 5:
      if (!(
#line 30473 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 769 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10146; /* vpshld_v4di */

    case 6:
      if (!(
#line 30473 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 769 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10148; /* vpshld_v8hi */

    case 7:
      if (!(
#line 30473 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 770 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10150; /* vpshld_v4si */

    case 8:
      if (!(
#line 30473 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 770 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10152; /* vpshld_v2di */

    default:
      return -1;
    }
}

 int
recog_260 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_255_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V32QImode:
      if (pattern152 (x3, 
E_V32QImode) != 0)
        return -1;
      if ((
#line 23861 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 639 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 8656; /* avx2_mpsadbw */
      if (!(
#line 23895 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 610 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8660; /* *avx2_mpsadbw */

    case E_V16QImode:
      if (pattern152 (x3, 
E_V16QImode) != 0)
        return -1;
      if (
#line 23861 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
        return 8657; /* sse4_1_mpsadbw */
      if (!
#line 23895 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 8662; /* *sse4_1_mpsadbw */

    case E_V64QImode:
      if (pattern152 (x3, 
E_V64QImode) != 0
          || !
#line 23883 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 8658; /* avx10_2_mpsadbw */

    default:
      return -1;
    }
}

 int
recog_266 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern789 (x2, 
E_V2SFmode, 
E_V4SFmode) == 0
              && 
#line 11894 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 5201; /* *vec_concatv4sf */
          break;

        case E_V8HFmode:
          if (pattern789 (x2, 
E_V4HFmode, 
E_V8HFmode) == 0
              && 
#line 11894 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 5202; /* *vec_concatv8hf */
          break;

        case E_V8BFmode:
          if (pattern789 (x2, 
E_V4BFmode, 
E_V8BFmode) == 0
              && 
#line 11894 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 5203; /* *vec_concatv8bf */
          break;

        case E_V16QImode:
          if (pattern789 (x2, 
E_V8QImode, 
E_V16QImode) == 0
              && 
#line 21636 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 8417; /* *vec_concatv16qi */
          break;

        case E_V8HImode:
          if (pattern789 (x2, 
E_V4HImode, 
E_V8HImode) == 0
              && 
#line 21636 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 8418; /* *vec_concatv8hi */
          break;

        case E_V4SImode:
          if (pattern789 (x2, 
E_V2SImode, 
E_V4SImode) == 0
              && 
#line 21636 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 8419; /* *vec_concatv4si */
          break;

        case E_V2DImode:
          if (pattern789 (x2, 
E_DImode, 
E_V2DImode) == 0
              && 
#line 21724 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 8425; /* vec_concatv2di */
          break;

        case E_V32QImode:
          if (register_operand (operands[0], E_V32QImode)
              && GET_MODE (x2) == E_V32QImode
              && rtx_equal_p (x4, operands[1]))
            {
              if (memory_operand (operands[1], E_V16QImode)
                  && 
#line 27953 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return 9228; /* avx2_vbroadcasti128_v32qi */
              if (nonimmediate_operand (operands[1], E_V16QImode)
                  && 
#line 28067 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return 9247; /* avx_vbroadcastf128_v32qi */
            }
          break;

        case E_V16HImode:
          if (register_operand (operands[0], E_V16HImode)
              && GET_MODE (x2) == E_V16HImode
              && rtx_equal_p (x4, operands[1]))
            {
              if (memory_operand (operands[1], E_V8HImode)
                  && 
#line 27953 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return 9229; /* avx2_vbroadcasti128_v16hi */
              if (nonimmediate_operand (operands[1], E_V8HImode)
                  && 
#line 28067 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return 9248; /* avx_vbroadcastf128_v16hi */
            }
          break;

        case E_V8SImode:
          if (register_operand (operands[0], E_V8SImode)
              && GET_MODE (x2) == E_V8SImode
              && rtx_equal_p (x4, operands[1]))
            {
              if (memory_operand (operands[1], E_V4SImode)
                  && 
#line 27953 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return 9230; /* avx2_vbroadcasti128_v8si */
              if (nonimmediate_operand (operands[1], E_V4SImode)
                  && 
#line 28067 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return 9249; /* avx_vbroadcastf128_v8si */
            }
          break;

        case E_V4DImode:
          if (register_operand (operands[0], E_V4DImode)
              && GET_MODE (x2) == E_V4DImode
              && memory_operand (operands[1], E_V2DImode)
              && rtx_equal_p (x4, operands[1])
              && 
#line 27953 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 9231; /* avx2_vbroadcasti128_v4di */
          break;

        case E_V8SFmode:
          if (pattern790 (x2, 
E_V4SFmode, 
E_V8SFmode) == 0
              && 
#line 28067 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return 9251; /* avx_vbroadcastf128_v8sf */
          break;

        case E_V4DFmode:
          if (pattern790 (x2, 
E_V2DFmode, 
E_V4DFmode) == 0
              && 
#line 28067 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return 9252; /* avx_vbroadcastf128_v4df */
          break;

        case E_V16HFmode:
          if (pattern790 (x2, 
E_V8HFmode, 
E_V16HFmode) == 0
              && 
#line 28067 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return 9253; /* avx_vbroadcastf128_v16hf */
          break;

        case E_V16BFmode:
          if (pattern790 (x2, 
E_V8BFmode, 
E_V16BFmode) == 0
              && 
#line 28067 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return 9254; /* avx_vbroadcastf128_v16bf */
          break;

        default:
          break;
        }
      break;

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern912 (x2, 
E_V2SFmode, 
E_V4SFmode) == 0
              && 
#line 11910 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 5204; /* *vec_concatv4sf_0 */
          break;

        case E_V8HFmode:
          if (pattern912 (x2, 
E_V4HFmode, 
E_V8HFmode) == 0
              && 
#line 11910 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 5205; /* *vec_concatv8hf_0 */
          break;

        case E_V8BFmode:
          if (pattern912 (x2, 
E_V4BFmode, 
E_V8BFmode) == 0
              && 
#line 11910 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 5206; /* *vec_concatv8bf_0 */
          break;

        case E_V16QImode:
          if (pattern912 (x2, 
E_V8QImode, 
E_V16QImode) == 0
              && 
#line 21707 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 8422; /* *vec_concatv16qi_0 */
          break;

        case E_V8HImode:
          if (pattern912 (x2, 
E_V4HImode, 
E_V8HImode) == 0
              && 
#line 21707 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 8423; /* *vec_concatv8hi_0 */
          break;

        case E_V4SImode:
          if (pattern912 (x2, 
E_V2SImode, 
E_V4SImode) == 0
              && 
#line 21707 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 8424; /* *vec_concatv4si_0 */
          break;

        case E_V2DImode:
          if (pattern912 (x2, 
E_DImode, 
E_V2DImode) == 0
              && 
#line 21785 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 8426; /* *vec_concatv2di_0 */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (pattern791 (x2, 
E_DFmode, 
E_V2DFmode) != 0
          || !
#line 14971 "../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7156; /* vec_concatv2df */

    case E_V32QImode:
      if (pattern791 (x2, 
E_V16QImode, 
E_V32QImode) != 0
          || !
#line 29012 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V16QImode)
       || !MEM_P (operands[1]))))
        return -1;
      return 9542; /* avx_vec_concatv32qi */

    case E_V16HImode:
      if (pattern791 (x2, 
E_V8HImode, 
E_V16HImode) != 0
          || !
#line 29012 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V8HImode)
       || !MEM_P (operands[1]))))
        return -1;
      return 9543; /* avx_vec_concatv16hi */

    case E_V16HFmode:
      if (pattern791 (x2, 
E_V8HFmode, 
E_V16HFmode) != 0
          || !
#line 29012 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V8HFmode)
       || !MEM_P (operands[1]))))
        return -1;
      return 9544; /* avx_vec_concatv16hf */

    case E_V16BFmode:
      if (pattern791 (x2, 
E_V8BFmode, 
E_V16BFmode) != 0
          || !
#line 29012 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V8BFmode)
       || !MEM_P (operands[1]))))
        return -1;
      return 9545; /* avx_vec_concatv16bf */

    case E_V8SImode:
      if (pattern791 (x2, 
E_V4SImode, 
E_V8SImode) != 0
          || !
#line 29012 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V4SImode)
       || !MEM_P (operands[1]))))
        return -1;
      return 9546; /* avx_vec_concatv8si */

    case E_V8SFmode:
      if (pattern791 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
          || !
#line 29012 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V4SFmode)
       || !MEM_P (operands[1]))))
        return -1;
      return 9548; /* avx_vec_concatv8sf */

    case E_V4DFmode:
      if (pattern791 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
          || !
#line 29012 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V2DFmode)
       || !MEM_P (operands[1]))))
        return -1;
      return 9549; /* avx_vec_concatv4df */

    case E_V64QImode:
      if (pattern791 (x2, 
E_V32QImode, 
E_V64QImode) != 0
          || !(
#line 29012 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V32QImode)
       || !MEM_P (operands[1]))) && 
#line 363 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9550; /* avx_vec_concatv64qi */

    case E_V32HImode:
      if (pattern791 (x2, 
E_V16HImode, 
E_V32HImode) != 0
          || !(
#line 29012 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V16HImode)
       || !MEM_P (operands[1]))) && 
#line 364 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9551; /* avx_vec_concatv32hi */

    case E_V32HFmode:
      if (pattern791 (x2, 
E_V16HFmode, 
E_V32HFmode) != 0
          || !(
#line 29012 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V16HFmode)
       || !MEM_P (operands[1]))) && 
#line 365 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9552; /* avx_vec_concatv32hf */

    case E_V32BFmode:
      if (pattern791 (x2, 
E_V16BFmode, 
E_V32BFmode) != 0
          || !(
#line 29012 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V16BFmode)
       || !MEM_P (operands[1]))) && 
#line 366 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9553; /* avx_vec_concatv32bf */

    case E_V16SImode:
      if (pattern791 (x2, 
E_V8SImode, 
E_V16SImode) != 0
          || !(
#line 29012 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V8SImode)
       || !MEM_P (operands[1]))) && 
#line 367 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9554; /* avx_vec_concatv16si */

    case E_V8DImode:
      if (pattern791 (x2, 
E_V4DImode, 
E_V8DImode) != 0
          || !(
#line 29012 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V4DImode)
       || !MEM_P (operands[1]))) && 
#line 368 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9555; /* avx_vec_concatv8di */

    case E_V16SFmode:
      if (pattern791 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
          || !(
#line 29012 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V8SFmode)
       || !MEM_P (operands[1]))) && 
#line 369 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9556; /* avx_vec_concatv16sf */

    case E_V8DFmode:
      if (pattern791 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0
          || !(
#line 29012 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V4DFmode)
       || !MEM_P (operands[1]))) && 
#line 370 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9557; /* avx_vec_concatv8df */

    default:
      return -1;
    }
}

 int
recog_273 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x2, 1);
  x6 = XVECEXP (x5, 0, 1);
  operands[4] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[5] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[6] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (pattern1501 (x2, 
E_V4SImode, 
E_V8SImode) != 0
          || !
#line 11618 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 5186; /* sse_shufps_v4si */

    case E_V4SFmode:
      if (pattern1501 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
          || !
#line 11618 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 5187; /* sse_shufps_v4sf */

    case E_V4DFmode:
      if (pattern1398 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0)
        return -1;
      if (const_0_to_1_operand (operands[3], E_VOIDmode)
          && const_4_to_5_operand (operands[4], E_VOIDmode)
          && const_2_to_3_operand (operands[5], E_VOIDmode)
          && const_6_to_7_operand (operands[6], E_VOIDmode)
          && 
#line 14460 "../../gcc/config/i386/sse.md"
(TARGET_AVX && 1))
        return 7129; /* avx_shufpd256_1 */
      if (!const_0_to_3_operand (operands[3], E_VOIDmode)
          || !const_0_to_3_operand (operands[4], E_VOIDmode)
          || !const_4_to_7_operand (operands[5], E_VOIDmode)
          || !const_4_to_7_operand (operands[6], E_VOIDmode)
          || !
#line 20241 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1))
        return -1;
      return 8351; /* *avx512dq_shuf_f64x2_1 */

    case E_V4DImode:
      if (pattern1398 (x2, 
E_V4DImode, 
E_V8DImode) != 0
          || pattern1500 () != 0
          || !
#line 20241 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1))
        return -1;
      return 8349; /* *avx512dq_shuf_i64x2_1 */

    default:
      return -1;
    }
}

 int
recog_274 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) == CONST_INT)
    {
      res = recog_272 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x4;
  res = recog_273 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  if (GET_CODE (x7) != CONST_INT
      || pattern1300 (x2, 
E_V4SImode, 
E_V8SImode) != 0)
    return -1;
  switch (XWINT (x4, 0))
    {
    case 2L:
      if (XWINT (x5, 0) != 6L
          || XWINT (x6, 0) != 3L
          || XWINT (x7, 0) != 7L
          || !
#line 19821 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
        return -1;
      return 8307; /* vec_interleave_highv4si */

    case 0L:
      if (XWINT (x5, 0) != 4L
          || XWINT (x6, 0) != 1L
          || XWINT (x7, 0) != 5L
          || !
#line 19875 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
        return -1;
      return 8313; /* vec_interleave_lowv4si */

    default:
      return -1;
    }
}

 int
recog_276 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) == CONST_INT)
    {
      res = recog_275 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x4;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  operands[4] = x5;
  x8 = XVECEXP (x3, 0, 2);
  operands[5] = x8;
  x9 = XVECEXP (x3, 0, 3);
  operands[6] = x9;
  x10 = XVECEXP (x3, 0, 4);
  operands[7] = x10;
  x11 = XVECEXP (x3, 0, 5);
  operands[8] = x11;
  x12 = XVECEXP (x3, 0, 6);
  operands[9] = x12;
  x13 = XVECEXP (x3, 0, 7);
  operands[10] = x13;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SFmode:
      if (pattern1398 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0)
        return -1;
      if (const_0_to_3_operand (operands[3], E_VOIDmode)
          && const_0_to_3_operand (operands[4], E_VOIDmode)
          && const_8_to_11_operand (operands[5], E_VOIDmode)
          && const_8_to_11_operand (operands[6], E_VOIDmode)
          && const_4_to_7_operand (operands[7], E_VOIDmode)
          && const_4_to_7_operand (operands[8], E_VOIDmode)
          && const_12_to_15_operand (operands[9], E_VOIDmode)
          && const_12_to_15_operand (operands[10], E_VOIDmode)
          && 
#line 11539 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && 1
   && (INTVAL (operands[3]) == (INTVAL (operands[7]) - 4)
       && INTVAL (operands[4]) == (INTVAL (operands[8]) - 4)
       && INTVAL (operands[5]) == (INTVAL (operands[9]) - 4)
       && INTVAL (operands[6]) == (INTVAL (operands[10]) - 4))))
        return 5183; /* avx_shufps256_1 */
      if (!const_0_to_7_operand (operands[3], E_VOIDmode)
          || pattern1653 () != 0
          || !
#line 20397 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3))
        return -1;
      return 8363; /* avx512vl_shuf_f32x4_1 */

    case E_V8DFmode:
      if (pattern1398 (x2, 
E_V8DFmode, 
E_V16DFmode) != 0)
        return -1;
      if (const_0_to_1_operand (operands[3], E_VOIDmode)
          && const_8_to_9_operand (operands[4], E_VOIDmode)
          && const_2_to_3_operand (operands[5], E_VOIDmode)
          && const_10_to_11_operand (operands[6], E_VOIDmode)
          && const_4_to_5_operand (operands[7], E_VOIDmode)
          && const_12_to_13_operand (operands[8], E_VOIDmode)
          && const_6_to_7_operand (operands[9], E_VOIDmode)
          && const_14_to_15_operand (operands[10], E_VOIDmode)
          && 
#line 14411 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return 7127; /* avx512f_shufpd512_1 */
      if (!const_0_to_7_operand (operands[3], E_VOIDmode)
          || pattern1653 () != 0
          || !(
#line 20299 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1
   && (INTVAL (operands[7]) & 1) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && (INTVAL (operands[9]) & 1) == 0
   && INTVAL (operands[9]) == INTVAL (operands[10]) - 1) && 
#line 727 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 8353; /* avx512f_shuf_f64x2_1 */

    case E_V8DImode:
      if (pattern1654 (x2, 
E_V8DImode, 
E_V16DImode) != 0
          || !(
#line 20299 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1
   && (INTVAL (operands[7]) & 1) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && (INTVAL (operands[9]) & 1) == 0
   && INTVAL (operands[9]) == INTVAL (operands[10]) - 1) && 
#line 727 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 8355; /* avx512f_shuf_i64x2_1 */

    case E_V8SImode:
      if (pattern1654 (x2, 
E_V8SImode, 
E_V16SImode) != 0
          || !
#line 20397 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3))
        return -1;
      return 8361; /* avx512vl_shuf_i32x4_1 */

    default:
      return -1;
    }
}

 int
recog_279 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) == CONST_INT)
    {
      x6 = XEXP (x2, 0);
      x7 = XEXP (x6, 1);
      operands[2] = x7;
      switch (XWINT (x4, 0))
        {
        case 1L:
          if (XWINT (x5, 0) == 3L)
            {
              switch (GET_MODE (operands[0]))
                {
                case E_V2DFmode:
                  if (pattern1465 (x2, 
E_V2DFmode, 
E_V4DFmode) == 0
                      && 
#line 13474 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_vec_interleave_v2df_operator_ok (operands, 1)))
                    return 5318; /* *vec_interleave_highv2df */
                  break;

                case E_V2DImode:
                  if (pattern1466 (x2, 
E_V2DImode, 
E_V4DImode) == 0
                      && 
#line 14557 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
                    return 7136; /* vec_interleave_highv2di */
                  break;

                default:
                  break;
                }
            }
          break;

        case 0L:
          if (XWINT (x5, 0) == 2L)
            {
              switch (GET_MODE (operands[0]))
                {
                case E_V2DFmode:
                  if (pattern1465 (x2, 
E_V2DFmode, 
E_V4DFmode) == 0
                      && 
#line 13617 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_vec_interleave_v2df_operator_ok (operands, 0)))
                    return 5328; /* *vec_interleave_lowv2df */
                  break;

                case E_V2DImode:
                  if (pattern1466 (x2, 
E_V2DImode, 
E_V4DImode) == 0
                      && 
#line 14607 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
                    return 7142; /* vec_interleave_lowv2di */
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
    }
  operands[3] = x4;
  if (!const_0_to_1_operand (operands[3], E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  operands[4] = x5;
  if (!const_2_to_3_operand (operands[4], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (pattern1466 (x2, 
E_V2DImode, 
E_V4DImode) != 0
          || !
#line 14625 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 7144; /* sse2_shufpd_v2di */

    case E_V2DFmode:
      if (pattern1466 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
          || !
#line 14625 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 7145; /* sse2_shufpd_v2df */

    default:
      return -1;
    }
}

 int
recog_282 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      x5 = XEXP (x2, 1);
      switch (XVECLEN (x5, 0))
        {
        case 4:
          res = recog_274 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 8:
          res = recog_276 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 16:
          res = recog_278 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 2:
          res = recog_279 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 64:
          res = recog_280 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 32:
          res = recog_281 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      operands[2] = x4;
      if (XVECLEN (x5, 0) < 1)
        return -1;
      operands[3] = x5;
      x6 = XVECEXP (x5, 0, 0);
      operands[4] = x6;
      if (!const_int_operand (operands[4], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SImode:
          if (pattern1398 (x2, 
E_V8SImode, 
E_V16SImode) != 0
              || !
#line 28390 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && avx_vperm2f128_parallel (operands[3], V8SImode)))
            return -1;
          return 9386; /* *avx_vperm2f128v8si_nozero */

        case E_V8SFmode:
          if (pattern1398 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
              || !
#line 28390 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && avx_vperm2f128_parallel (operands[3], V8SFmode)))
            return -1;
          return 9387; /* *avx_vperm2f128v8sf_nozero */

        case E_V4DFmode:
          if (pattern1398 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0
              || !
#line 28390 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && avx_vperm2f128_parallel (operands[3], V4DFmode)))
            return -1;
          return 9388; /* *avx_vperm2f128v4df_nozero */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      switch (pattern800 (x2))
        {
        case 0:
          if (!
#line 24199 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 8693; /* *avx2_zero_extendv16qiv16hi2_1 */

        case 1:
          if (!
#line 24252 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
            return -1;
          return 8701; /* *avx512bw_zero_extendv32qiv32hi2_1 */

        case 2:
          if (!
#line 24348 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return -1;
          return 8717; /* *sse4_1_zero_extendv8qiv8hi2_3 */

        case 3:
          if (!
#line 24596 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 8753; /* avx512f_zero_extendv16hiv16si2_1 */

        case 4:
          if (!
#line 24650 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 8761; /* avx2_zero_extendv8hiv8si2_1 */

        case 5:
          if (!
#line 24755 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return -1;
          return 8777; /* *sse4_1_zero_extendv4hiv4si2_3 */

        case 6:
          if (pmovzx_parallel (operands[3], E_VOIDmode)
              && 
#line 25152 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return 8848; /* *avx512f_zero_extendv8siv8di2_1 */
          if (!movq_parallel (operands[3], E_VOIDmode)
              || !(
#line 29126 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9564; /* *vec_concatv16si_0_1 */

        case 7:
          if (pmovzx_parallel (operands[3], E_VOIDmode)
              && 
#line 25204 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 8854; /* *avx2_zero_extendv4siv4di2_1 */
          if (!movq_parallel (operands[3], E_VOIDmode)
              || !(
#line 29126 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 9565; /* *vec_concatv8si_0_1 */

        case 8:
          if (vector_operand (operands[1], E_V4SImode)
              && pmovzx_parallel (operands[3], E_VOIDmode)
              && 
#line 25289 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return 8868; /* *sse4_1_zero_extendv2siv2di2_3 */
          if (!nonimmediate_operand (operands[1], E_V4SImode)
              || !movq_parallel (operands[3], E_VOIDmode)
              || !
#line 29126 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 9566; /* *vec_concatv4si_0_1 */

        case 9:
          if (!(
#line 29126 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9567; /* *vec_concatv8di_0_1 */

        case 10:
          if (!(
#line 29126 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 9568; /* *vec_concatv4di_0_1 */

        case 11:
          if (!
#line 29126 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 9569; /* *vec_concatv2di_0_1 */

        case 12:
          if (!(
#line 29126 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9570; /* *vec_concatv32hf_0_1 */

        case 13:
          if (!(
#line 29126 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 9571; /* *vec_concatv16hf_0_1 */

        case 14:
          if (!
#line 29126 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 9572; /* *vec_concatv8hf_0_1 */

        case 15:
          if (!(
#line 29126 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9573; /* *vec_concatv32bf_0_1 */

        case 16:
          if (!(
#line 29126 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 9574; /* *vec_concatv16bf_0_1 */

        case 17:
          if (!
#line 29126 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 9575; /* *vec_concatv8bf_0_1 */

        case 18:
          if (!(
#line 29126 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9576; /* *vec_concatv16sf_0_1 */

        case 19:
          if (!(
#line 29126 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 9577; /* *vec_concatv8sf_0_1 */

        case 20:
          if (!
#line 29126 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 9578; /* *vec_concatv4sf_0_1 */

        case 21:
          if (!(
#line 29126 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9579; /* *vec_concatv8df_0_1 */

        case 22:
          if (!(
#line 29126 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 9580; /* *vec_concatv4df_0_1 */

        case 23:
          if (!(
#line 29126 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 9581; /* *vec_concatv2df_0_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_293 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) == CONST_INT)
    {
      res = recog_290 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[2] = x4;
  res = recog_292 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (XWINT (x4, 0) != 0L
      || x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
      || pattern831 (x3, 
11, 
10, 
9, 
8) != 0
      || !register_operand (operands[0], E_V16HImode)
      || GET_MODE (x2) != E_V16HImode
      || !nonimmediate_operand (operands[1], E_V16HImode)
      || pattern1468 (x3) != 0)
    return -1;
  x8 = XVECEXP (x3, 0, 12);
  operands[6] = x8;
  if (!const_12_to_15_operand (operands[6], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x3, 0, 13);
  operands[7] = x9;
  if (!const_12_to_15_operand (operands[7], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x3, 0, 14);
  operands[8] = x10;
  if (!const_12_to_15_operand (operands[8], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x3, 0, 15);
  operands[9] = x11;
  if (!const_12_to_15_operand (operands[9], E_VOIDmode)
      || !
#line 21001 "../../gcc/config/i386/sse.md"
(TARGET_AVX2
   && 1 && 1
   && INTVAL (operands[2]) + 8 == INTVAL (operands[6])
   && INTVAL (operands[3]) + 8 == INTVAL (operands[7])
   && INTVAL (operands[4]) + 8 == INTVAL (operands[8])
   && INTVAL (operands[5]) + 8 == INTVAL (operands[9])))
    return -1;
  return 8387; /* avx2_pshufhw_1 */
}

 int
recog_300 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern529 (x2))
        {
        case 0:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5446; /* *avx512bw_vpternlogv64qi_1 */

        case 1:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5473; /* *avx512vl_vpternlogv32qi_1 */

        case 2:
          if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5500; /* *avx512vl_vpternlogv16qi_1 */

        case 3:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5527; /* *avx512bw_vpternlogv32hi_1 */

        case 4:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5554; /* *avx512vl_vpternlogv16hi_1 */

        case 5:
          if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5581; /* *avx512vl_vpternlogv8hi_1 */

        case 6:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5608; /* *avx512f_vpternlogv16si_1 */

        case 7:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5635; /* *avx512vl_vpternlogv8si_1 */

        case 8:
          if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5662; /* *avx512vl_vpternlogv4si_1 */

        case 9:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5689; /* *avx512f_vpternlogv8di_1 */

        case 10:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5716; /* *avx512vl_vpternlogv4di_1 */

        case 11:
          if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5743; /* *avx512vl_vpternlogv2di_1 */

        case 12:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5449; /* *avx512bw_vpternlogv64qi_1 */

        case 13:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5476; /* *avx512vl_vpternlogv32qi_1 */

        case 14:
          if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5503; /* *avx512vl_vpternlogv16qi_1 */

        case 15:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5530; /* *avx512bw_vpternlogv32hi_1 */

        case 16:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5557; /* *avx512vl_vpternlogv16hi_1 */

        case 17:
          if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5584; /* *avx512vl_vpternlogv8hi_1 */

        case 18:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5611; /* *avx512f_vpternlogv16si_1 */

        case 19:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5638; /* *avx512vl_vpternlogv8si_1 */

        case 20:
          if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5665; /* *avx512vl_vpternlogv4si_1 */

        case 21:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5692; /* *avx512f_vpternlogv8di_1 */

        case 22:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5719; /* *avx512vl_vpternlogv4di_1 */

        case 23:
          if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5746; /* *avx512vl_vpternlogv2di_1 */

        case 24:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5452; /* *avx512bw_vpternlogv64qi_1 */

        case 25:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5479; /* *avx512vl_vpternlogv32qi_1 */

        case 26:
          if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5506; /* *avx512vl_vpternlogv16qi_1 */

        case 27:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5533; /* *avx512bw_vpternlogv32hi_1 */

        case 28:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5560; /* *avx512vl_vpternlogv16hi_1 */

        case 29:
          if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5587; /* *avx512vl_vpternlogv8hi_1 */

        case 30:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5614; /* *avx512f_vpternlogv16si_1 */

        case 31:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5641; /* *avx512vl_vpternlogv8si_1 */

        case 32:
          if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5668; /* *avx512vl_vpternlogv4si_1 */

        case 33:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5695; /* *avx512f_vpternlogv8di_1 */

        case 34:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5722; /* *avx512vl_vpternlogv4di_1 */

        case 35:
          if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5749; /* *avx512vl_vpternlogv2di_1 */

        case 36:
          if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6736; /* *avx512bw_vpternlogv64qi_3 */

        case 37:
          if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6745; /* *avx512vl_vpternlogv32qi_3 */

        case 38:
          if (!
#line 14008 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6754; /* *avx512vl_vpternlogv16qi_3 */

        case 39:
          if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6763; /* *avx512bw_vpternlogv32hi_3 */

        case 40:
          if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6772; /* *avx512vl_vpternlogv16hi_3 */

        case 41:
          if (!
#line 14008 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6781; /* *avx512vl_vpternlogv8hi_3 */

        case 42:
          if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6790; /* *avx512f_vpternlogv16si_3 */

        case 43:
          if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6799; /* *avx512vl_vpternlogv8si_3 */

        case 44:
          if (!
#line 14008 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6808; /* *avx512vl_vpternlogv4si_3 */

        case 45:
          if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6817; /* *avx512f_vpternlogv8di_3 */

        case 46:
          if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6826; /* *avx512vl_vpternlogv4di_3 */

        case 47:
          if (!
#line 14008 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6835; /* *avx512vl_vpternlogv2di_3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern531 (x2))
        {
        case 0:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6094; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6121; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6148; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6175; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6202; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6229; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6256; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6283; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6310; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6337; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6364; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6391; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern531 (x2))
        {
        case 0:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6097; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6124; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6151; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6178; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6205; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6232; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6259; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6286; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6313; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6340; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6367; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6394; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern531 (x2))
        {
        case 0:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6100; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6127; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6154; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6181; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6208; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6235; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6262; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6289; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6316; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6343; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6370; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6397; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_310 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern533 (x2))
            {
            case 0:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5763; /* *avx512bw_vpternlogv32hf_1 */

            case 1:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5790; /* *avx512vl_vpternlogv16hf_1 */

            case 2:
              if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5817; /* *avx512fp16_vpternlogv8hf_1 */

            case 3:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5844; /* *avx512bw_vpternlogv32bf_1 */

            case 4:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5871; /* *avx512vl_vpternlogv16bf_1 */

            case 5:
              if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5898; /* *avx512vl_vpternlogv8bf_1 */

            case 6:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5925; /* *avx512f_vpternlogv16sf_1 */

            case 7:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5952; /* *avx512vl_vpternlogv8sf_1 */

            case 8:
              if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5979; /* *avx512vl_vpternlogv4sf_1 */

            case 9:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6006; /* *avx512f_vpternlogv8df_1 */

            case 10:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6033; /* *avx512vl_vpternlogv4df_1 */

            case 11:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 6060; /* *avx512vl_vpternlogv2df_1 */

            case 12:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5766; /* *avx512bw_vpternlogv32hf_1 */

            case 13:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5793; /* *avx512vl_vpternlogv16hf_1 */

            case 14:
              if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5820; /* *avx512fp16_vpternlogv8hf_1 */

            case 15:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5847; /* *avx512bw_vpternlogv32bf_1 */

            case 16:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5874; /* *avx512vl_vpternlogv16bf_1 */

            case 17:
              if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5901; /* *avx512vl_vpternlogv8bf_1 */

            case 18:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5928; /* *avx512f_vpternlogv16sf_1 */

            case 19:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5955; /* *avx512vl_vpternlogv8sf_1 */

            case 20:
              if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5982; /* *avx512vl_vpternlogv4sf_1 */

            case 21:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6009; /* *avx512f_vpternlogv8df_1 */

            case 22:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6036; /* *avx512vl_vpternlogv4df_1 */

            case 23:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 6063; /* *avx512vl_vpternlogv2df_1 */

            case 24:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5769; /* *avx512bw_vpternlogv32hf_1 */

            case 25:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5796; /* *avx512vl_vpternlogv16hf_1 */

            case 26:
              if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5823; /* *avx512fp16_vpternlogv8hf_1 */

            case 27:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5850; /* *avx512bw_vpternlogv32bf_1 */

            case 28:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5877; /* *avx512vl_vpternlogv16bf_1 */

            case 29:
              if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5904; /* *avx512vl_vpternlogv8bf_1 */

            case 30:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5931; /* *avx512f_vpternlogv16sf_1 */

            case 31:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5958; /* *avx512vl_vpternlogv8sf_1 */

            case 32:
              if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5985; /* *avx512vl_vpternlogv4sf_1 */

            case 33:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6012; /* *avx512f_vpternlogv8df_1 */

            case 34:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6039; /* *avx512vl_vpternlogv4df_1 */

            case 35:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 6066; /* *avx512vl_vpternlogv2df_1 */

            case 36:
              if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6843; /* *avx512bw_vpternlogv32hf_3 */

            case 37:
              if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6852; /* *avx512vl_vpternlogv16hf_3 */

            case 38:
              if (!
#line 14008 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6861; /* *avx512fp16_vpternlogv8hf_3 */

            case 39:
              if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6870; /* *avx512bw_vpternlogv32bf_3 */

            case 40:
              if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6879; /* *avx512vl_vpternlogv16bf_3 */

            case 41:
              if (!
#line 14008 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6888; /* *avx512vl_vpternlogv8bf_3 */

            case 42:
              if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6897; /* *avx512f_vpternlogv16sf_3 */

            case 43:
              if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6906; /* *avx512vl_vpternlogv8sf_3 */

            case 44:
              if (!
#line 14008 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6915; /* *avx512vl_vpternlogv4sf_3 */

            case 45:
              if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6924; /* *avx512f_vpternlogv8df_3 */

            case 46:
              if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6933; /* *avx512vl_vpternlogv4df_3 */

            case 47:
              if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 6942; /* *avx512vl_vpternlogv2df_3 */

            default:
              return -1;
            }

        case AND:
          switch (pattern534 (x2))
            {
            case 0:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6411; /* *avx512bw_vpternlogv32hf_2 */

            case 1:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6438; /* *avx512vl_vpternlogv16hf_2 */

            case 2:
              if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6465; /* *avx512fp16_vpternlogv8hf_2 */

            case 3:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6492; /* *avx512bw_vpternlogv32bf_2 */

            case 4:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6519; /* *avx512vl_vpternlogv16bf_2 */

            case 5:
              if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6546; /* *avx512vl_vpternlogv8bf_2 */

            case 6:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6573; /* *avx512f_vpternlogv16sf_2 */

            case 7:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6600; /* *avx512vl_vpternlogv8sf_2 */

            case 8:
              if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6627; /* *avx512vl_vpternlogv4sf_2 */

            case 9:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6654; /* *avx512f_vpternlogv8df_2 */

            case 10:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6681; /* *avx512vl_vpternlogv4df_2 */

            case 11:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 6708; /* *avx512vl_vpternlogv2df_2 */

            default:
              return -1;
            }

        case IOR:
          switch (pattern534 (x2))
            {
            case 0:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6414; /* *avx512bw_vpternlogv32hf_2 */

            case 1:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6441; /* *avx512vl_vpternlogv16hf_2 */

            case 2:
              if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6468; /* *avx512fp16_vpternlogv8hf_2 */

            case 3:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6495; /* *avx512bw_vpternlogv32bf_2 */

            case 4:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6522; /* *avx512vl_vpternlogv16bf_2 */

            case 5:
              if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6549; /* *avx512vl_vpternlogv8bf_2 */

            case 6:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6576; /* *avx512f_vpternlogv16sf_2 */

            case 7:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6603; /* *avx512vl_vpternlogv8sf_2 */

            case 8:
              if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6630; /* *avx512vl_vpternlogv4sf_2 */

            case 9:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6657; /* *avx512f_vpternlogv8df_2 */

            case 10:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6684; /* *avx512vl_vpternlogv4df_2 */

            case 11:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 6711; /* *avx512vl_vpternlogv2df_2 */

            default:
              return -1;
            }

        case XOR:
          switch (pattern534 (x2))
            {
            case 0:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6417; /* *avx512bw_vpternlogv32hf_2 */

            case 1:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6444; /* *avx512vl_vpternlogv16hf_2 */

            case 2:
              if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6471; /* *avx512fp16_vpternlogv8hf_2 */

            case 3:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6498; /* *avx512bw_vpternlogv32bf_2 */

            case 4:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6525; /* *avx512vl_vpternlogv16bf_2 */

            case 5:
              if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6552; /* *avx512vl_vpternlogv8bf_2 */

            case 6:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6579; /* *avx512f_vpternlogv16sf_2 */

            case 7:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6606; /* *avx512vl_vpternlogv8sf_2 */

            case 8:
              if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6633; /* *avx512vl_vpternlogv4sf_2 */

            case 9:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6660; /* *avx512f_vpternlogv8df_2 */

            case 10:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6687; /* *avx512vl_vpternlogv4df_2 */

            case 11:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 6714; /* *avx512vl_vpternlogv2df_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern533 (x2))
            {
            case 0:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5772; /* *avx512bw_vpternlogv32hf_1 */

            case 1:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5799; /* *avx512vl_vpternlogv16hf_1 */

            case 2:
              if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5826; /* *avx512fp16_vpternlogv8hf_1 */

            case 3:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5853; /* *avx512bw_vpternlogv32bf_1 */

            case 4:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5880; /* *avx512vl_vpternlogv16bf_1 */

            case 5:
              if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5907; /* *avx512vl_vpternlogv8bf_1 */

            case 6:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5934; /* *avx512f_vpternlogv16sf_1 */

            case 7:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5961; /* *avx512vl_vpternlogv8sf_1 */

            case 8:
              if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5988; /* *avx512vl_vpternlogv4sf_1 */

            case 9:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6015; /* *avx512f_vpternlogv8df_1 */

            case 10:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6042; /* *avx512vl_vpternlogv4df_1 */

            case 11:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 6069; /* *avx512vl_vpternlogv2df_1 */

            case 12:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5775; /* *avx512bw_vpternlogv32hf_1 */

            case 13:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5802; /* *avx512vl_vpternlogv16hf_1 */

            case 14:
              if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5829; /* *avx512fp16_vpternlogv8hf_1 */

            case 15:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5856; /* *avx512bw_vpternlogv32bf_1 */

            case 16:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5883; /* *avx512vl_vpternlogv16bf_1 */

            case 17:
              if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5910; /* *avx512vl_vpternlogv8bf_1 */

            case 18:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5937; /* *avx512f_vpternlogv16sf_1 */

            case 19:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5964; /* *avx512vl_vpternlogv8sf_1 */

            case 20:
              if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5991; /* *avx512vl_vpternlogv4sf_1 */

            case 21:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6018; /* *avx512f_vpternlogv8df_1 */

            case 22:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6045; /* *avx512vl_vpternlogv4df_1 */

            case 23:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 6072; /* *avx512vl_vpternlogv2df_1 */

            case 24:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5778; /* *avx512bw_vpternlogv32hf_1 */

            case 25:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5805; /* *avx512vl_vpternlogv16hf_1 */

            case 26:
              if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5832; /* *avx512fp16_vpternlogv8hf_1 */

            case 27:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5859; /* *avx512bw_vpternlogv32bf_1 */

            case 28:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5886; /* *avx512vl_vpternlogv16bf_1 */

            case 29:
              if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5913; /* *avx512vl_vpternlogv8bf_1 */

            case 30:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5940; /* *avx512f_vpternlogv16sf_1 */

            case 31:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5967; /* *avx512vl_vpternlogv8sf_1 */

            case 32:
              if (!
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5994; /* *avx512vl_vpternlogv4sf_1 */

            case 33:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6021; /* *avx512f_vpternlogv8df_1 */

            case 34:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6048; /* *avx512vl_vpternlogv4df_1 */

            case 35:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 6075; /* *avx512vl_vpternlogv2df_1 */

            case 36:
              if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6846; /* *avx512bw_vpternlogv32hf_3 */

            case 37:
              if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6855; /* *avx512vl_vpternlogv16hf_3 */

            case 38:
              if (!
#line 14008 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6864; /* *avx512fp16_vpternlogv8hf_3 */

            case 39:
              if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6873; /* *avx512bw_vpternlogv32bf_3 */

            case 40:
              if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6882; /* *avx512vl_vpternlogv16bf_3 */

            case 41:
              if (!
#line 14008 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6891; /* *avx512vl_vpternlogv8bf_3 */

            case 42:
              if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6900; /* *avx512f_vpternlogv16sf_3 */

            case 43:
              if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6909; /* *avx512vl_vpternlogv8sf_3 */

            case 44:
              if (!
#line 14008 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6918; /* *avx512vl_vpternlogv4sf_3 */

            case 45:
              if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6927; /* *avx512f_vpternlogv8df_3 */

            case 46:
              if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6936; /* *avx512vl_vpternlogv4df_3 */

            case 47:
              if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 6945; /* *avx512vl_vpternlogv2df_3 */

            default:
              return -1;
            }

        case AND:
          switch (pattern534 (x2))
            {
            case 0:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6420; /* *avx512bw_vpternlogv32hf_2 */

            case 1:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6447; /* *avx512vl_vpternlogv16hf_2 */

            case 2:
              if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6474; /* *avx512fp16_vpternlogv8hf_2 */

            case 3:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6501; /* *avx512bw_vpternlogv32bf_2 */

            case 4:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6528; /* *avx512vl_vpternlogv16bf_2 */

            case 5:
              if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6555; /* *avx512vl_vpternlogv8bf_2 */

            case 6:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6582; /* *avx512f_vpternlogv16sf_2 */

            case 7:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6609; /* *avx512vl_vpternlogv8sf_2 */

            case 8:
              if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6636; /* *avx512vl_vpternlogv4sf_2 */

            case 9:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6663; /* *avx512f_vpternlogv8df_2 */

            case 10:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6690; /* *avx512vl_vpternlogv4df_2 */

            case 11:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 6717; /* *avx512vl_vpternlogv2df_2 */

            default:
              return -1;
            }

        case IOR:
          switch (pattern534 (x2))
            {
            case 0:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6423; /* *avx512bw_vpternlogv32hf_2 */

            case 1:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6450; /* *avx512vl_vpternlogv16hf_2 */

            case 2:
              if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6477; /* *avx512fp16_vpternlogv8hf_2 */

            case 3:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6504; /* *avx512bw_vpternlogv32bf_2 */

            case 4:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6531; /* *avx512vl_vpternlogv16bf_2 */

            case 5:
              if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6558; /* *avx512vl_vpternlogv8bf_2 */

            case 6:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6585; /* *avx512f_vpternlogv16sf_2 */

            case 7:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6612; /* *avx512vl_vpternlogv8sf_2 */

            case 8:
              if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6639; /* *avx512vl_vpternlogv4sf_2 */

            case 9:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6666; /* *avx512f_vpternlogv8df_2 */

            case 10:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6693; /* *avx512vl_vpternlogv4df_2 */

            case 11:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 6720; /* *avx512vl_vpternlogv2df_2 */

            default:
              return -1;
            }

        case XOR:
          switch (pattern534 (x2))
            {
            case 0:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6426; /* *avx512bw_vpternlogv32hf_2 */

            case 1:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6453; /* *avx512vl_vpternlogv16hf_2 */

            case 2:
              if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6480; /* *avx512fp16_vpternlogv8hf_2 */

            case 3:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6507; /* *avx512bw_vpternlogv32bf_2 */

            case 4:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6534; /* *avx512vl_vpternlogv16bf_2 */

            case 5:
              if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6561; /* *avx512vl_vpternlogv8bf_2 */

            case 6:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6588; /* *avx512f_vpternlogv16sf_2 */

            case 7:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6615; /* *avx512vl_vpternlogv8sf_2 */

            case 8:
              if (!
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6642; /* *avx512vl_vpternlogv4sf_2 */

            case 9:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6669; /* *avx512f_vpternlogv8df_2 */

            case 10:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6696; /* *avx512vl_vpternlogv4df_2 */

            case 11:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 6723; /* *avx512vl_vpternlogv2df_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      return recog_309 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_369 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[3] = x6;
  x7 = XEXP (x4, 0);
  operands[4] = x7;
  switch (GET_MODE (operands[3]))
    {
    case E_SFmode:
      if (!nonimmediate_operand (operands[3], E_SFmode)
          || !nonimmediate_operand (operands[4], E_V4SFmode)
          || !
#line 5913 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_SSE2 && TARGET_SSE_MATH
   && optimize_function_for_speed_p (cfun)))
        return -1;
      *pnum_clobbers = 2;
      return 223; /* *fixuns_truncsf_1 */

    case E_DFmode:
      if (!nonimmediate_operand (operands[3], E_DFmode)
          || !nonimmediate_operand (operands[4], E_V2DFmode)
          || !
#line 5913 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_SSE2 && TARGET_SSE_MATH
   && optimize_function_for_speed_p (cfun)))
        return -1;
      *pnum_clobbers = 2;
      return 224; /* *fixuns_truncdf_1 */

    default:
      return -1;
    }
}

 int
recog_373 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  switch (pattern554 (x1))
    {
    case 0:
      x2 = XVECEXP (x1, 0, 1);
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 17
          || GET_MODE (x3) != E_CCmode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (GET_MODE (x5) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode))
            return -1;
          if (x86_64_hilo_general_operand (operands[2], E_DImode)
              && (
#line 6467 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1237 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return 266; /* *adddi3_doubleword */
          if (!x86_64_general_operand (operands[2], E_DImode)
              || !(
#line 6617 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
  && true) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 285; /* *adddi_1 */

        case E_TImode:
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (pattern560 (x5, 
E_TImode) != 0
              || !(
#line 6467 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, TImode, operands, TARGET_APX_NDD)) && 
#line 1238 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 267; /* *addti3_doubleword */

        case E_SImode:
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (pattern562 (x5) != 0
              || !
#line 6617 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
  && true))
            return -1;
          return 283; /* *addsi_1 */

        case E_HImode:
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (pattern561 (x5, 
E_HImode) != 0
              || !
#line 6815 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, HImode, operands, TARGET_APX_NDD)
  && true))
            return -1;
          return 298; /* *addhi_1 */

        case E_QImode:
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (pattern561 (x5, 
E_QImode) != 0
              || !
#line 6872 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, QImode, operands, TARGET_APX_NDD)
  && true))
            return -1;
          return 300; /* *addqi_1 */

        case E_V2QImode:
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (pattern564 (x5, 
E_V2QImode) != 0
              || !
#line 3241 "../../gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size || TARGET_SSE2))
            return -1;
          return 2136; /* addv2qi3 */

        default:
          return -1;
        }

    case 1:
      x2 = XVECEXP (x1, 0, 1);
      if (XVECLEN (x2, 0) != 1)
        return -1;
      x6 = XVECEXP (x2, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (XINT (x2, 1))
        {
        case 111:
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (pattern212 (x5, 
E_V2SFmode) != 0
              || !
#line 746 "../../gcc/config/i386/mmx.md"
(TARGET_3DNOW && ix86_binary_operator_ok (PLUS, V2SFmode, operands)))
            return -1;
          return 2052; /* *mmx_addv2sf3 */

        case 175:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              x4 = XVECEXP (x1, 0, 0);
              x5 = XEXP (x4, 1);
              if (pattern564 (x5, 
E_QImode) != 0
                  || !(
#line 2266 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2092 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ)))
                return -1;
              return 2597; /* kaddqi */

            case E_HImode:
              x4 = XVECEXP (x1, 0, 0);
              x5 = XEXP (x4, 1);
              if (pattern564 (x5, 
E_HImode) != 0
                  || !(
#line 2266 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2092 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ)))
                return -1;
              return 2598; /* kaddhi */

            case E_SImode:
              x4 = XVECEXP (x1, 0, 0);
              x5 = XEXP (x4, 1);
              if (pattern564 (x5, 
E_SImode) != 0
                  || !(
#line 2266 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2093 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return -1;
              return 2599; /* kaddsi */

            case E_DImode:
              x4 = XVECEXP (x1, 0, 0);
              x5 = XEXP (x4, 1);
              if (pattern564 (x5, 
E_DImode) != 0
                  || !(
#line 2266 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2093 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return -1;
              return 2600; /* kadddi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (!
#line 6948 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
        return -1;
      return 301; /* *addqi_1_slp */

    case 3:
      if (!
#line 6948 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
        return -1;
      return 302; /* *addhi_1_slp */

    default:
      return -1;
    }
}

 int
recog_379 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x2, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  x8 = XEXP (x4, 0);
  operands[0] = x8;
  x9 = XEXP (x4, 1);
  switch (GET_CODE (x9))
    {
    case AND:
      x10 = XEXP (x9, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XEXP (x9, 1);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      switch (GET_MODE (x6))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[1], E_DImode)
              || !x86_64_szext_general_operand (operands[2], E_DImode)
              || !nonimmediate_operand (operands[0], E_DImode)
              || GET_MODE (x9) != E_DImode
              || !
#line 12912 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_match_ccmode
	(insn,
	 /* If we are going to emit andl instead of andq, and the operands[2]
	    constant might have the SImode sign bit set, make sure the sign
	    flag isn't tested, because the instruction will set the sign flag
	    based on bit 31 rather than bit 63.  If it isn't CONST_INT,
	    conservatively assume it might have bit 31 set.  */
	 (satisfies_constraint_Z (operands[2])
	  && (!CONST_INT_P (operands[2])
	      || val_signbit_known_set_p (SImode, INTVAL (operands[2]))))
	 ? CCZmode : CCNOmode)
   && ix86_binary_operator_ok (AND, DImode, operands, TARGET_APX_NDD)))
            return -1;
          return 749; /* *anddi_2 */

        case E_QImode:
          if (pattern1407 (x9, 
E_QImode) != 0)
            return -1;
          if (
#line 12963 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, QImode, operands, TARGET_APX_NDD)
   && ix86_match_ccmode (insn,
			 CONST_INT_P (operands[2])
			 && INTVAL (operands[2]) >= 0 ? CCNOmode : CCZmode)))
            return 751; /* *andqi_2_maybe_si */
          if (!
#line 13005 "../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (AND, QImode, operands, TARGET_APX_NDD)))
            return -1;
          return 752; /* *andqi_2 */

        case E_HImode:
          if (pattern1407 (x9, 
E_HImode) != 0
              || !
#line 13005 "../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (AND, HImode, operands, TARGET_APX_NDD)))
            return -1;
          return 753; /* *andhi_2 */

        case E_SImode:
          if (pattern1408 (x9, 
E_SImode) != 0
              || !
#line 13005 "../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (AND, SImode, operands, TARGET_APX_NDD)))
            return -1;
          return 754; /* *andsi_2 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pattern1410 (x1, 
AND) != 0
          || !
#line 12945 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (AND, SImode, operands, TARGET_APX_NDD)))
        return -1;
      return 750; /* *andsi_2_zext */

    default:
      return -1;
    }
}

 int
recog_384 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17)
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x6 = XEXP (x4, 0);
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      x8 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x8))
        {
        case CLOBBER:
          x9 = XEXP (x8, 0);
          operands[0] = x9;
          switch (GET_MODE (x6))
            {
            case E_QImode:
              if (!general_operand (operands[2], E_QImode)
                  || !nonimmediate_operand (operands[1], E_QImode)
                  || !scratch_operand (operands[0], E_QImode)
                  || !
#line 7227 "../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCZmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 314; /* *addqi_3 */

            case E_HImode:
              if (!general_operand (operands[2], E_HImode)
                  || !nonimmediate_operand (operands[1], E_HImode)
                  || !scratch_operand (operands[0], E_HImode)
                  || !
#line 7227 "../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCZmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 315; /* *addhi_3 */

            case E_SImode:
              if (!x86_64_general_operand (operands[2], E_SImode)
                  || !nonimmediate_operand (operands[1], E_SImode)
                  || !scratch_operand (operands[0], E_SImode)
                  || !
#line 7227 "../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCZmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 316; /* *addsi_3 */

            case E_DImode:
              if (!x86_64_general_operand (operands[2], E_DImode)
                  || !nonimmediate_operand (operands[1], E_DImode)
                  || !scratch_operand (operands[0], E_DImode)
                  || !(
#line 7227 "../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCZmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 1163 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 317; /* *adddi_3 */

            default:
              return -1;
            }

        case SET:
          x10 = XEXP (x8, 1);
          if (GET_CODE (x10) != ZERO_EXTEND
              || pattern1217 (x1, 
PLUS) != 0
              || !x86_64_general_operand (operands[2], E_SImode)
              || !nonimmediate_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x8, 0);
          operands[0] = x9;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x11 = XEXP (x10, 0);
          x12 = XEXP (x11, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x13 = XEXP (x11, 1);
          if (!rtx_equal_p (x13, operands[2])
              || !
#line 7276 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_match_ccmode (insn, CCZmode)
   && ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)))
            return -1;
          return 318; /* *addsi_3_zext */

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x5, 0) != 0L)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x6 = XEXP (x4, 0);
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x10 = XEXP (x8, 1);
      switch (GET_CODE (x10))
        {
        case NEG:
          switch (pattern1219 (x1))
            {
            case 0:
              if (!
#line 14421 "../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && ix86_unary_operator_ok (NEG, QImode, operands, TARGET_APX_NDD)))
                return -1;
              return 975; /* *negqi_2 */

            case 1:
              if (!
#line 14421 "../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && ix86_unary_operator_ok (NEG, HImode, operands, TARGET_APX_NDD)))
                return -1;
              return 976; /* *neghi_2 */

            case 2:
              if (!
#line 14421 "../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && ix86_unary_operator_ok (NEG, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 977; /* *negsi_2 */

            case 3:
              if (!(
#line 14421 "../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && ix86_unary_operator_ok (NEG, DImode, operands, TARGET_APX_NDD)) && 
#line 1163 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 978; /* *negdi_2 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (pattern1220 (x1, 
NEG) != 0
              || !
#line 14438 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_unary_operator_ok (NEG, SImode, operands, TARGET_APX_NDD)))
            return -1;
          return 979; /* *negsi_2_zext */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_388 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x4;
      res = recog_387 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x4) != SUBREG
          || pattern811 (x4) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern231 (x5, 
E_CCmode, 
17) != 0
          || GET_MODE (x3) != E_QImode
          || !nonimmediate_operand (operands[1], E_QImode))
        return -1;
      x6 = XEXP (x4, 0);
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!int248_register_operand (operands[2], E_VOIDmode))
        return -1;
      x8 = XEXP (x2, 0);
      switch (GET_CODE (x8))
        {
        case STRICT_LOW_PART:
          x9 = XEXP (x8, 0);
          operands[0] = x9;
          if (!register_operand (operands[0], E_QImode))
            return -1;
          switch (pattern1779 ())
            {
            case 0:
              if (!
#line 8217 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              return 405; /* *subqi_exthi_1_slp */

            case 1:
              if (!
#line 8217 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              return 406; /* *subqi_extsi_1_slp */

            case 2:
              if (!(
#line 8217 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1166 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 407; /* *subqi_extdi_1_slp */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x8;
          if (!nonimmediate_operand (operands[0], E_QImode))
            return -1;
          switch (pattern1779 ())
            {
            case 0:
              return 416; /* *subqi_exthi_0 */

            case 1:
              return 417; /* *subqi_extsi_0 */

            case 2:
              if (!
#line 1166 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 418; /* *subqi_extdi_0 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern374 (x5) != 0)
        return -1;
      switch (pattern1149 (x2))
        {
        case 0:
          if (!(
#line 8105 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (UNKNOWN, DImode, operands, TARGET_APX_NDD)) && 
#line 1237 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 382; /* *subdi3_doubleword_zext */

        case 1:
          if (!(
#line 8105 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (UNKNOWN, TImode, operands, TARGET_APX_NDD)) && 
#line 1238 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 383; /* *subti3_doubleword_zext */

        default:
          return -1;
        }

    case LTU:
    case UNLT:
      switch (pattern683 (x1))
        {
        case 0:
          if (pattern1543 (x3, 
E_QImode) != 0
              || !
#line 9351 "../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 491; /* *subqi3_carry_0 */

        case 1:
          if (pattern1543 (x3, 
E_HImode) != 0
              || !
#line 9351 "../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 492; /* *subhi3_carry_0 */

        case 2:
          if (pattern1543 (x3, 
E_SImode) != 0
              || !
#line 9351 "../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 493; /* *subsi3_carry_0 */

        case 3:
          if (pattern1543 (x3, 
E_DImode) != 0
              || !(
#line 9351 "../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1163 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 494; /* *subdi3_carry_0 */

        default:
          return -1;
        }

    case GE:
    case GEU:
      switch (pattern683 (x1))
        {
        case 0:
          if (pattern1544 (x3, 
E_QImode) != 0
              || !
#line 9365 "../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 495; /* *subqi3_carry_0r */

        case 1:
          if (pattern1544 (x3, 
E_HImode) != 0
              || !
#line 9365 "../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 496; /* *subhi3_carry_0r */

        case 2:
          if (pattern1544 (x3, 
E_SImode) != 0
              || !
#line 9365 "../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 497; /* *subsi3_carry_0r */

        case 3:
          if (pattern1544 (x3, 
E_DImode) != 0
              || !(
#line 9365 "../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1163 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 498; /* *subdi3_carry_0r */

        default:
          return -1;
        }

    case EQ:
      switch (pattern687 (x1))
        {
        case 0:
          if (!
#line 10309 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, QImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 582; /* *subqi3_eq_0 */

        case 1:
          if (!
#line 10309 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, HImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 583; /* *subhi3_eq_0 */

        case 2:
          if (!
#line 10309 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 584; /* *subsi3_eq_0 */

        case 3:
          if (!(
#line 10309 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1163 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 585; /* *subdi3_eq_0 */

        default:
          return -1;
        }

    case NE:
      switch (pattern687 (x1))
        {
        case 0:
          if (!
#line 10330 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, QImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 586; /* *subqi3_ne_0 */

        case 1:
          if (!
#line 10330 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, HImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 587; /* *subhi3_ne_0 */

        case 2:
          if (!
#line 10330 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 588; /* *subsi3_ne_0 */

        case 3:
          if (!(
#line 10330 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1163 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 589; /* *subdi3_ne_0 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_394 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ASHIFT:
      return recog_393 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (pattern566 (x1))
        {
        case 0:
          if (
#line 12745 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return 726; /* *iorqi_1_slp */
          break;

        case 1:
          if (
#line 12745 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return 729; /* *iorhi_1_slp */
          break;

        case 2:
          if (x86_64_hilo_general_operand (operands[2], E_DImode)
              && (
#line 13531 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (IOR, DImode, operands, TARGET_APX_NDD)) && 
#line 1237 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return 819; /* *iordi3_doubleword */
          if (x86_64_general_operand (operands[2], E_DImode)
              && (
#line 13589 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (IOR, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1166 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 832; /* *iordi_1 */
          if (const_int_operand (operands[2], E_DImode)
              && 
#line 13637 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_USE_BT
   && ix86_binary_operator_ok (IOR, DImode, operands)
   && IN_RANGE (exact_log2 (INTVAL (operands[2])), 31, 63)))
            return 838; /* *iordi_1_bts */
          break;

        case 3:
          if ((
#line 13531 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (IOR, TImode, operands, TARGET_APX_NDD)) && 
#line 1238 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 821; /* *iorti3_doubleword */
          break;

        case 4:
          if (
#line 13589 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (IOR, HImode, operands, TARGET_APX_NDD)
   && true))
            return 824; /* *iorhi_1 */
          break;

        case 5:
          if (
#line 13589 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (IOR, SImode, operands, TARGET_APX_NDD)
   && true))
            return 828; /* *iorsi_1 */
          break;

        case 6:
          if (
#line 4713 "../../gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (IOR, V4QImode, operands)))
            return 2284; /* *iorv4qi3 */
          break;

        case 7:
          if (
#line 4713 "../../gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (IOR, V2QImode, operands)))
            return 2287; /* *iorv2qi3 */
          break;

        case 8:
          if (
#line 4713 "../../gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (IOR, V2HImode, operands)))
            return 2290; /* *iorv2hi3 */
          break;

        case 9:
          if (
#line 2107 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return 2573; /* kiorqi */
          break;

        case 10:
          if (
#line 2107 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return 2576; /* kiorhi */
          break;

        case 11:
          if ((
#line 2107 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2088 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 2579; /* kiorsi */
          break;

        case 12:
          if ((
#line 2107 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2088 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 2582; /* kiordi */
          break;

        default:
          break;
        }
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER
          || pattern567 (x1) != 0)
        return -1;
      if (GET_CODE (x4) == SUBREG
          && pattern555 (x4) == 0)
        {
          x6 = XEXP (x4, 0);
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          switch (pattern1604 (x2))
            {
            case 0:
              if (
#line 12772 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return 732; /* *iorqi_exthi_1_slp */
              break;

            case 1:
              if (
#line 12772 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return 735; /* *iorqi_extsi_1_slp */
              break;

            case 2:
              if ((
#line 12772 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1166 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 738; /* *iorqi_extdi_1_slp */
              break;

            case 3:
              return 756; /* *iorqi_exthi_0 */

            case 4:
              return 759; /* *iorqi_extsi_0 */

            case 5:
              if (
#line 1166 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return 762; /* *iorqi_extdi_0 */
              break;

            default:
              break;
            }
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) == SUBREG)
            {
              switch (pattern1605 (x2))
                {
                case 0:
                  if (
#line 12805 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    return 741; /* *iorqi_exthi_2_slp */
                  break;

                case 1:
                  if (
#line 12805 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    return 744; /* *iorqi_extsi_2_slp */
                  break;

                case 2:
                  if ((
#line 12805 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1166 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 747; /* *iorqi_extdi_2_slp */
                  break;

                case 3:
                  return 765; /* *iorqi_ext2hi_0 */

                case 4:
                  return 768; /* *iorqi_ext2si_0 */

                case 5:
                  if (
#line 1166 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return 771; /* *iorqi_ext2di_0 */
                  break;

                default:
                  break;
                }
            }
        }
      x9 = XEXP (x2, 0);
      operands[0] = x9;
      if (!nonimmediate_operand (operands[0], E_QImode))
        return -1;
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_QImode))
        return -1;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      if (!general_operand (operands[2], E_QImode)
          || !
#line 13779 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (IOR, QImode, operands, TARGET_APX_NDD)
   && true))
        return -1;
      return 868; /* *iorqi_1 */

    case ZERO_EXTEND:
      if (pattern370 (x1) != 0
          || !
#line 13766 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (IOR, SImode, operands, TARGET_APX_NDD)))
        return -1;
      return 865; /* *iorsi_1_zext_imm */

    case LSHIFTRT:
      if (pattern340 (x1) != 0)
        return -1;
      switch (pattern1041 (x3, 
ASHIFT))
        {
        case 0:
          x8 = XEXP (x3, 1);
          x10 = XEXP (x8, 0);
          x11 = XEXP (x10, 0);
          x12 = XEXP (x11, 0);
          operands[1] = x12;
          if (nonimmediate_operand (operands[0], E_DImode))
            {
              x13 = XEXP (x4, 1);
              x14 = XEXP (x13, 0);
              operands[2] = x14;
              x6 = XEXP (x4, 0);
              if (rtx_equal_p (x6, operands[0]))
                {
                  x15 = XEXP (x10, 1);
                  x16 = XEXP (x15, 1);
                  x17 = XEXP (x16, 0);
                  if (rtx_equal_p (x17, operands[2])
                      && 
#line 16790 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && true))
                    return 1143; /* x86_64_shrd */
                }
            }
          operands[2] = x12;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!nonimmediate_operand (operands[1], E_DImode))
            return -1;
          x13 = XEXP (x4, 1);
          x14 = XEXP (x13, 0);
          operands[3] = x14;
          x15 = XEXP (x10, 1);
          x16 = XEXP (x15, 1);
          x17 = XEXP (x16, 0);
          if (!rtx_equal_p (x17, operands[3])
              || !
#line 16811 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1145; /* x86_64_shrd_ndd */

        case 1:
          if (pattern1040 (x3, 
E_SImode, 
E_DImode) != 0)
            return -1;
          x8 = XEXP (x3, 1);
          x10 = XEXP (x8, 0);
          x11 = XEXP (x10, 0);
          x12 = XEXP (x11, 0);
          operands[1] = x12;
          if (nonimmediate_operand (operands[0], E_SImode))
            {
              x13 = XEXP (x4, 1);
              x14 = XEXP (x13, 0);
              operands[2] = x14;
              x6 = XEXP (x4, 0);
              if (rtx_equal_p (x6, operands[0]))
                {
                  x15 = XEXP (x10, 1);
                  x16 = XEXP (x15, 1);
                  x17 = XEXP (x16, 0);
                  if (rtx_equal_p (x17, operands[2]))
                    return 1155; /* x86_shrd */
                }
            }
          operands[2] = x12;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          x13 = XEXP (x4, 1);
          x14 = XEXP (x13, 0);
          operands[3] = x14;
          x15 = XEXP (x10, 1);
          x16 = XEXP (x15, 1);
          x17 = XEXP (x16, 0);
          if (!rtx_equal_p (x17, operands[3])
              || !
#line 17042 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1157; /* x86_shrd_ndd */

        case 2:
          x8 = XEXP (x3, 1);
          switch (GET_CODE (x8))
            {
            case SUBREG:
              switch (pattern1221 (x3, 
ASHIFT))
                {
                case 0:
                  x13 = XEXP (x4, 1);
                  operands[2] = x13;
                  if (pattern1658 (x3) == 0
                      && 
#line 16826 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && true))
                    return 1147; /* x86_64_shrd_1 */
                  operands[3] = x13;
                  if (pattern1659 (x3) != 0
                      || !
#line 16848 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && INTVAL (operands[4]) == 64 - INTVAL (operands[3])
   && true))
                    return -1;
                  return 1149; /* x86_64_shrd_ndd_1 */

                case 1:
                  x13 = XEXP (x4, 1);
                  operands[2] = x13;
                  if (pattern1660 (x3) == 0
                      && 
#line 17057 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 32 - INTVAL (operands[2])
   && true))
                    return 1159; /* x86_shrd_1 */
                  operands[3] = x13;
                  if (pattern1661 (x3) != 0
                      || !
#line 17079 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && (INTVAL (operands[4]) == 32 - INTVAL (operands[3]))
   && true))
                    return -1;
                  return 1161; /* x86_shrd_ndd_1 */

                default:
                  return -1;
                }

            case ASHIFT:
              switch (pattern1223 (x3))
                {
                case 0:
                  if (!
#line 16920 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return -1;
                  return 1151; /* *x86_64_shrd_shld_1_nozext */

                case 1:
                  if (!
#line 17151 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 32 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return -1;
                  return 1163; /* *x86_shrd_shld_1_nozext */

                case 2:
                  x10 = XEXP (x8, 0);
                  operands[1] = x10;
                  if (nonimmediate_operand (operands[0], E_DImode))
                    {
                      x13 = XEXP (x4, 1);
                      operands[2] = x13;
                      x6 = XEXP (x4, 0);
                      if (rtx_equal_p (x6, operands[0]))
                        {
                          x18 = XEXP (x8, 1);
                          x19 = XEXP (x18, 1);
                          if (rtx_equal_p (x19, operands[2])
                              && 
#line 16973 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_pre_reload_split ()))
                            return 1152; /* *x86_64_shrd_2 */
                        }
                    }
                  operands[2] = x10;
                  if (!register_operand (operands[0], E_DImode))
                    return -1;
                  x6 = XEXP (x4, 0);
                  operands[1] = x6;
                  if (!nonimmediate_operand (operands[1], E_DImode))
                    return -1;
                  x13 = XEXP (x4, 1);
                  operands[3] = x13;
                  x18 = XEXP (x8, 1);
                  x19 = XEXP (x18, 1);
                  if (!rtx_equal_p (x19, operands[2])
                      || !
#line 16994 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
  && ix86_pre_reload_split ()))
                    return -1;
                  return 1153; /* *x86_64_shrd_ndd_2 */

                case 3:
                  x10 = XEXP (x8, 0);
                  operands[1] = x10;
                  if (nonimmediate_operand (operands[0], E_SImode))
                    {
                      x13 = XEXP (x4, 1);
                      operands[2] = x13;
                      x6 = XEXP (x4, 0);
                      if (rtx_equal_p (x6, operands[0]))
                        {
                          x18 = XEXP (x8, 1);
                          x19 = XEXP (x18, 1);
                          if (rtx_equal_p (x19, operands[2])
                              && 
#line 17203 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_pre_reload_split ()))
                            return 1164; /* *x86_shrd_2 */
                        }
                    }
                  operands[2] = x10;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x6 = XEXP (x4, 0);
                  operands[1] = x6;
                  if (!nonimmediate_operand (operands[1], E_SImode))
                    return -1;
                  x13 = XEXP (x4, 1);
                  operands[3] = x13;
                  x18 = XEXP (x8, 1);
                  x19 = XEXP (x18, 1);
                  if (!rtx_equal_p (x19, operands[3])
                      || !
#line 17224 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && ix86_pre_reload_split ()))
                    return -1;
                  return 1165; /* *x86_shrd_ndd_2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != PLUS)
        return -1;
      x20 = XEXP (x6, 1);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || pattern340 (x1) != 0)
        return -1;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x8 = XEXP (x3, 1);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode
              || GET_MODE (x6) != E_SImode
              || !nonimmediate_operand (operands[1], E_SImode)
              || !
#line 22204 "../../gcc/config/i386/i386.md"
(TARGET_TBM))
            return -1;
          return 1608; /* *tbm_blci_si */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode
              || GET_MODE (x6) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode)
              || !(
#line 22204 "../../gcc/config/i386/i386.md"
(TARGET_TBM) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1609; /* *tbm_blci_di */

        default:
          return -1;
        }

    case PLUS:
      x13 = XEXP (x4, 1);
      if (GET_CODE (x13) != CONST_INT
          || pattern347 (x1) != 0)
        return -1;
      switch (XWINT (x13, 0))
        {
        case 1L:
          switch (pattern1312 (x3))
            {
            case 0:
              if (!
#line 22244 "../../gcc/config/i386/i386.md"
(TARGET_TBM))
                return -1;
              return 1614; /* *tbm_blcs_si */

            case 1:
              if (!(
#line 22244 "../../gcc/config/i386/i386.md"
(TARGET_TBM) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1615; /* *tbm_blcs_di */

            case 2:
              if (!
#line 22285 "../../gcc/config/i386/i386.md"
(TARGET_TBM))
                return -1;
              return 1620; /* *tbm_t1mskc_si */

            case 3:
              if (!(
#line 22285 "../../gcc/config/i386/i386.md"
(TARGET_TBM) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1621; /* *tbm_t1mskc_di */

            default:
              return -1;
            }

        case -1L:
          switch (pattern1312 (x3))
            {
            case 0:
              if (!
#line 22257 "../../gcc/config/i386/i386.md"
(TARGET_TBM))
                return -1;
              return 1616; /* *tbm_blsfill_si */

            case 1:
              if (!(
#line 22257 "../../gcc/config/i386/i386.md"
(TARGET_TBM) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1617; /* *tbm_blsfill_di */

            case 2:
              if (!
#line 22271 "../../gcc/config/i386/i386.md"
(TARGET_TBM))
                return -1;
              return 1618; /* *tbm_blsic_si */

            case 3:
              if (!(
#line 22271 "../../gcc/config/i386/i386.md"
(TARGET_TBM) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1619; /* *tbm_blsic_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_411 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x6))
    {
    case CLOBBER:
      switch (pattern699 (x1))
        {
        case 0:
          if (!
#line 21526 "../../gcc/config/i386/i386.md"
(TARGET_LZCNT))
            return -1;
          return 1534; /* clzsi2_lzcnt */

        case 1:
          if (!(
#line 21526 "../../gcc/config/i386/i386.md"
(TARGET_LZCNT) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1535; /* clzdi2_lzcnt */

        default:
          return -1;
        }

    case UNSPEC:
      switch (pattern700 (x1))
        {
        case 0:
          if (
#line 21551 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF && TARGET_LZCNT))
            return 1536; /* *clzsi2_lzcnt_falsedep_nf */
          if (pnum_clobbers == NULL
              || !
#line 21564 "../../gcc/config/i386/i386.md"
(TARGET_LZCNT))
            return -1;
          *pnum_clobbers = 1;
          return 1538; /* *clzsi2_lzcnt_falsedep */

        case 1:
          if ((
#line 21551 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF && TARGET_LZCNT) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 1537; /* *clzdi2_lzcnt_falsedep_nf */
          if (pnum_clobbers == NULL
              || !(
#line 21564 "../../gcc/config/i386/i386.md"
(TARGET_LZCNT) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1539; /* *clzdi2_lzcnt_falsedep */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_417 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      if (register_operand (operands[0], E_V64QImode)
          && int_float_vector_all_ones_operand (operands[1], E_V64QImode)
          && register_operand (operands[2], E_V64QImode)
          && (
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 282 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2422; /* *vmovv64qi_constm1_pternlog_false_dep */
      break;

    case E_V32QImode:
      if (register_operand (operands[0], E_V32QImode)
          && int_float_vector_all_ones_operand (operands[1], E_V32QImode)
          && register_operand (operands[2], E_V32QImode)
          && (
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 282 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2423; /* *vmovv32qi_constm1_pternlog_false_dep */
      break;

    case E_V16QImode:
      if (register_operand (operands[0], E_V16QImode)
          && int_float_vector_all_ones_operand (operands[1], E_V16QImode)
          && register_operand (operands[2], E_V16QImode)
          && 
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2424; /* *vmovv16qi_constm1_pternlog_false_dep */
      break;

    case E_V32HImode:
      if (register_operand (operands[0], E_V32HImode)
          && int_float_vector_all_ones_operand (operands[1], E_V32HImode)
          && register_operand (operands[2], E_V32HImode)
          && (
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 283 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2425; /* *vmovv32hi_constm1_pternlog_false_dep */
      break;

    case E_V16HImode:
      if (register_operand (operands[0], E_V16HImode)
          && int_float_vector_all_ones_operand (operands[1], E_V16HImode)
          && register_operand (operands[2], E_V16HImode)
          && (
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 283 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2426; /* *vmovv16hi_constm1_pternlog_false_dep */
      break;

    case E_V8HImode:
      if (register_operand (operands[0], E_V8HImode)
          && int_float_vector_all_ones_operand (operands[1], E_V8HImode)
          && register_operand (operands[2], E_V8HImode)
          && 
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2427; /* *vmovv8hi_constm1_pternlog_false_dep */
      break;

    case E_V16SImode:
      if (register_operand (operands[0], E_V16SImode)
          && int_float_vector_all_ones_operand (operands[1], E_V16SImode)
          && register_operand (operands[2], E_V16SImode)
          && (
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 284 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2428; /* *vmovv16si_constm1_pternlog_false_dep */
      break;

    case E_V8SImode:
      if (register_operand (operands[0], E_V8SImode)
          && int_float_vector_all_ones_operand (operands[1], E_V8SImode)
          && register_operand (operands[2], E_V8SImode)
          && (
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 284 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2429; /* *vmovv8si_constm1_pternlog_false_dep */
      break;

    case E_V4SImode:
      if (register_operand (operands[0], E_V4SImode)
          && int_float_vector_all_ones_operand (operands[1], E_V4SImode)
          && register_operand (operands[2], E_V4SImode)
          && 
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2430; /* *vmovv4si_constm1_pternlog_false_dep */
      break;

    case E_V8DImode:
      if (register_operand (operands[0], E_V8DImode)
          && int_float_vector_all_ones_operand (operands[1], E_V8DImode)
          && register_operand (operands[2], E_V8DImode)
          && (
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 285 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2431; /* *vmovv8di_constm1_pternlog_false_dep */
      break;

    case E_V4DImode:
      if (register_operand (operands[0], E_V4DImode)
          && int_float_vector_all_ones_operand (operands[1], E_V4DImode)
          && register_operand (operands[2], E_V4DImode)
          && (
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 285 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2432; /* *vmovv4di_constm1_pternlog_false_dep */
      break;

    case E_V2DImode:
      if (register_operand (operands[0], E_V2DImode)
          && int_float_vector_all_ones_operand (operands[1], E_V2DImode)
          && register_operand (operands[2], E_V2DImode)
          && 
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2433; /* *vmovv2di_constm1_pternlog_false_dep */
      break;

    case E_V4TImode:
      if (register_operand (operands[0], E_V4TImode)
          && int_float_vector_all_ones_operand (operands[1], E_V4TImode)
          && register_operand (operands[2], E_V4TImode)
          && (
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 286 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2434; /* *vmovv4ti_constm1_pternlog_false_dep */
      break;

    case E_V2TImode:
      if (register_operand (operands[0], E_V2TImode)
          && int_float_vector_all_ones_operand (operands[1], E_V2TImode)
          && register_operand (operands[2], E_V2TImode)
          && (
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 286 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2435; /* *vmovv2ti_constm1_pternlog_false_dep */
      break;

    case E_V1TImode:
      if (register_operand (operands[0], E_V1TImode)
          && int_float_vector_all_ones_operand (operands[1], E_V1TImode)
          && register_operand (operands[2], E_V1TImode)
          && 
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2436; /* *vmovv1ti_constm1_pternlog_false_dep */
      break;

    case E_V32HFmode:
      if (register_operand (operands[0], E_V32HFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V32HFmode)
          && register_operand (operands[2], E_V32HFmode)
          && (
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 287 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2437; /* *vmovv32hf_constm1_pternlog_false_dep */
      break;

    case E_V16HFmode:
      if (register_operand (operands[0], E_V16HFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V16HFmode)
          && register_operand (operands[2], E_V16HFmode)
          && (
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 287 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2438; /* *vmovv16hf_constm1_pternlog_false_dep */
      break;

    case E_V8HFmode:
      if (register_operand (operands[0], E_V8HFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V8HFmode)
          && register_operand (operands[2], E_V8HFmode)
          && 
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2439; /* *vmovv8hf_constm1_pternlog_false_dep */
      break;

    case E_V32BFmode:
      if (register_operand (operands[0], E_V32BFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V32BFmode)
          && register_operand (operands[2], E_V32BFmode)
          && (
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 288 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2440; /* *vmovv32bf_constm1_pternlog_false_dep */
      break;

    case E_V16BFmode:
      if (register_operand (operands[0], E_V16BFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V16BFmode)
          && register_operand (operands[2], E_V16BFmode)
          && (
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 288 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2441; /* *vmovv16bf_constm1_pternlog_false_dep */
      break;

    case E_V8BFmode:
      if (register_operand (operands[0], E_V8BFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V8BFmode)
          && register_operand (operands[2], E_V8BFmode)
          && 
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2442; /* *vmovv8bf_constm1_pternlog_false_dep */
      break;

    case E_V16SFmode:
      if (register_operand (operands[0], E_V16SFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V16SFmode)
          && register_operand (operands[2], E_V16SFmode)
          && (
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 289 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2443; /* *vmovv16sf_constm1_pternlog_false_dep */
      break;

    case E_V8SFmode:
      if (register_operand (operands[0], E_V8SFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V8SFmode)
          && register_operand (operands[2], E_V8SFmode)
          && (
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 289 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2444; /* *vmovv8sf_constm1_pternlog_false_dep */
      break;

    case E_V4SFmode:
      if (register_operand (operands[0], E_V4SFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V4SFmode)
          && register_operand (operands[2], E_V4SFmode)
          && 
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2445; /* *vmovv4sf_constm1_pternlog_false_dep */
      break;

    case E_V8DFmode:
      if (register_operand (operands[0], E_V8DFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V8DFmode)
          && register_operand (operands[2], E_V8DFmode)
          && (
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 290 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2446; /* *vmovv8df_constm1_pternlog_false_dep */
      break;

    case E_V4DFmode:
      if (register_operand (operands[0], E_V4DFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V4DFmode)
          && register_operand (operands[2], E_V4DFmode)
          && (
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 290 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2447; /* *vmovv4df_constm1_pternlog_false_dep */
      break;

    case E_V2DFmode:
      if (register_operand (operands[0], E_V2DFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V2DFmode)
          && register_operand (operands[2], E_V2DFmode)
          && 
#line 1581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2448; /* *vmovv2df_constm1_pternlog_false_dep */
      break;

    default:
      break;
    }
  switch (GET_CODE (x4))
    {
    case VEC_MERGE:
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      x8 = XEXP (x4, 1);
      operands[3] = x8;
      x9 = XEXP (x4, 2);
      operands[1] = x9;
      operands[4] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern1319 (x4, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 10423 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !TARGET_AVX512DQ) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5144; /* *avx512f_cvtmask2dv16si_pternlog_false_dep */

        case E_V8SImode:
          if (pattern1319 (x4, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 10423 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !TARGET_AVX512DQ) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5145; /* *avx512vl_cvtmask2dv8si_pternlog_false_dep */

        case E_V4SImode:
          if (pattern1319 (x4, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 10423 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !TARGET_AVX512DQ) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5146; /* *avx512vl_cvtmask2dv4si_pternlog_false_dep */

        case E_V8DImode:
          if (pattern1319 (x4, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 10423 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !TARGET_AVX512DQ) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5147; /* *avx512f_cvtmask2qv8di_pternlog_false_dep */

        case E_V4DImode:
          if (pattern1319 (x4, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 10423 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !TARGET_AVX512DQ) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5148; /* *avx512vl_cvtmask2qv4di_pternlog_false_dep */

        case E_V2DImode:
          if (pattern1319 (x4, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 10423 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !TARGET_AVX512DQ) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5149; /* *avx512vl_cvtmask2qv2di_pternlog_false_dep */

        default:
          return -1;
        }

    case XOR:
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern1229 (x4, 
E_V16SImode) != 0
              || !(
#line 18488 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 578 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7910; /* *one_cmplv16si2_pternlog_false_dep */

        case E_V8DImode:
          if (pattern1229 (x4, 
E_V8DImode) != 0
              || !(
#line 18488 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 579 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7911; /* *one_cmplv8di2_pternlog_false_dep */

        case E_V64QImode:
          if (pattern1229 (x4, 
E_V64QImode) != 0
              || !(
#line 18488 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 580 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7912; /* *one_cmplv64qi2_pternlog_false_dep */

        case E_V32QImode:
          if (pattern1229 (x4, 
E_V32QImode) != 0
              || !(
#line 18488 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 580 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7913; /* *one_cmplv32qi2_pternlog_false_dep */

        case E_V16QImode:
          if (pattern1229 (x4, 
E_V16QImode) != 0
              || !
#line 18488 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)))
            return -1;
          return 7914; /* *one_cmplv16qi2_pternlog_false_dep */

        case E_V32HImode:
          if (pattern1229 (x4, 
E_V32HImode) != 0
              || !(
#line 18488 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 581 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7915; /* *one_cmplv32hi2_pternlog_false_dep */

        case E_V16HImode:
          if (pattern1229 (x4, 
E_V16HImode) != 0
              || !(
#line 18488 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 581 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7916; /* *one_cmplv16hi2_pternlog_false_dep */

        case E_V8HImode:
          if (pattern1229 (x4, 
E_V8HImode) != 0
              || !
#line 18488 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)))
            return -1;
          return 7917; /* *one_cmplv8hi2_pternlog_false_dep */

        case E_V8SImode:
          if (pattern1229 (x4, 
E_V8SImode) != 0
              || !(
#line 18488 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 582 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7918; /* *one_cmplv8si2_pternlog_false_dep */

        case E_V4SImode:
          if (pattern1229 (x4, 
E_V4SImode) != 0
              || !
#line 18488 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)))
            return -1;
          return 7919; /* *one_cmplv4si2_pternlog_false_dep */

        case E_V4DImode:
          if (pattern1229 (x4, 
E_V4DImode) != 0
              || !(
#line 18488 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 583 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7920; /* *one_cmplv4di2_pternlog_false_dep */

        case E_V2DImode:
          if (pattern1229 (x4, 
E_V2DImode) != 0
              || !
#line 18488 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)))
            return -1;
          return 7921; /* *one_cmplv2di2_pternlog_false_dep */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x3;
      if (pattern44 (x1, 
E_CCZmode) != 0)
        return NULL;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      switch (pattern838 ())
        {
        case 0:
          if (!((
#line 1684 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 1237 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 1686 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_1 (insn, operands);

        case 1:
          if (!((
#line 1684 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 1238 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1686 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_2 (insn, operands);

        default:
          return NULL;
        }

    case NEG:
      if (GET_MODE (x3) != E_QImode)
        return NULL;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != GEU
          || GET_MODE (x5) != E_QImode)
        return NULL;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 17)
        return NULL;
      x7 = XEXP (x5, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != LTU
          || GET_MODE (x4) != E_QImode)
        return NULL;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 17)
        return NULL;
      x9 = XEXP (x4, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern44 (x1, 
E_CCCmode) != 0)
        return NULL;
      switch (GET_MODE (x6))
        {
        case E_CCmode:
          if (GET_MODE (x8) != E_CCmode
              || !(
#line 9875 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 9877 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_193 (insn, operands);

        case E_CCCmode:
          if (GET_MODE (x8) != E_CCCmode
              || !(
#line 9875 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 9877 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_194 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x10 = XEXP (x1, 0);
      if (GET_CODE (x10) != REG)
        return NULL;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x5;
          if (register_operand (operands[0], E_TImode)
              && REGNO (x10) == 17
              && GET_MODE (x10) == E_CCZmode
              && GET_MODE (x2) == E_CCZmode
              && GET_MODE (x3) == E_TImode)
            {
              x11 = XEXP (x3, 1);
              operands[1] = x11;
              if (general_operand (operands[1], E_TImode)
                  && (
#line 12192 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_pre_reload_split ()) && 
#line 12195 "../../gcc/config/i386/i386.md"
( 1)))
                return gen_split_271 (insn, operands);
            }
          operands[2] = x5;
          operands[0] = x10;
          if (!flags_reg_operand (operands[0], E_VOIDmode))
            return NULL;
          operands[1] = x2;
          if (!compare_operator (operands[1], E_VOIDmode))
            return NULL;
          x11 = XEXP (x3, 1);
          operands[3] = x11;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return NULL;
          if (QIreg_operand (operands[2], E_VOIDmode)
              && 
#line 12363 "../../gcc/config/i386/i386.md"
(reload_completed
    && GET_MODE (operands[2]) != QImode
    && ((ix86_match_ccmode (insn, CCZmode)
    	 && !(INTVAL (operands[3]) & ~(255 << 8)))
	|| (ix86_match_ccmode (insn, CCNOmode)
	    && !(INTVAL (operands[3]) & ~(127 << 8))))))
            return gen_split_281 (insn, operands);
          if (!nonimmediate_operand (operands[2], E_VOIDmode)
              || !
#line 12389 "../../gcc/config/i386/i386.md"
(reload_completed
    && GET_MODE (operands[2]) != QImode
    && (!REG_P (operands[2]) || ANY_QI_REG_P (operands[2]))
    && ((ix86_match_ccmode (insn, CCZmode)
	 && !(INTVAL (operands[3]) & ~255))
	|| (ix86_match_ccmode (insn, CCNOmode)
	    && !(INTVAL (operands[3]) & ~127)))))
            return NULL;
          return gen_split_282 (insn, operands);

        case NOT:
          if (REGNO (x10) != 17
              || GET_MODE (x10) != E_CCZmode
              || GET_MODE (x2) != E_CCZmode)
            return NULL;
          switch (pattern839 (x3))
            {
            case 0:
              if (!(
#line 12322 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()
   && (!TARGET_BMI || !REG_P (operands[1]))) && 
#line 12325 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_275 (insn, operands);

            case 1:
              if (!(
#line 12322 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()
   && (!TARGET_BMI || !REG_P (operands[1]))) && 
#line 12325 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_276 (insn, operands);

            case 2:
              if (!(
#line 12322 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()
   && (!TARGET_BMI || !REG_P (operands[1]))) && 
#line 12325 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_277 (insn, operands);

            case 3:
              if (register_operand (operands[0], E_DImode)
                  && x86_64_szext_nonmemory_operand (operands[1], E_DImode)
                  && ((
#line 12322 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()
   && (!TARGET_BMI || !REG_P (operands[1]))) && 
#line 1163 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 12325 "../../gcc/config/i386/i386.md"
( 1)))
                return gen_split_278 (insn, operands);
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || !nonimmediate_operand (operands[1], E_DImode)
                  || !((
#line 12340 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 1197 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 12342 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_279 (insn, operands);

            case 4:
              if (!((
#line 12340 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 1198 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 12342 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_280 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ZERO_EXTRACT:
      switch (pattern46 (x1))
        {
        case 0:
          if (!(
#line 12214 "../../gcc/config/i386/i386.md"
(/* Ensure that resulting mask is zero or sign extended operand.  */
   INTVAL (operands[4]) >= 0
   && ((INTVAL (operands[3]) > 0
	&& INTVAL (operands[3]) + INTVAL (operands[4]) <= 32)
       || (HImode == DImode
	   && INTVAL (operands[3]) > 32
	   && INTVAL (operands[3]) + INTVAL (operands[4]) == 64))
   && ix86_match_ccmode (insn,
			 /* If zero_extract mode precision is the same
			    as len, the SF of the zero_extract
			    comparison will be the most significant
			    extracted bit, but this could be matched
			    after splitting only for pos 0 len all bits
			    trivial extractions.  Require CCZmode.  */
			 (GET_MODE_PRECISION (HImode)
			  == INTVAL (operands[3]))
			 /* Otherwise, require CCZmode if we'd use a mask
			    with the most significant bit set and can't
			    widen it to wider mode.  *testdi_1 also
			    requires CCZmode if the mask has bit
			    31 set and all bits above it clear.  */
			 || (INTVAL (operands[3]) + INTVAL (operands[4])
			     >= 32)
			 /* We can't widen also if val is not a REG.  */
			 || (INTVAL (operands[3]) + INTVAL (operands[4])
			     == GET_MODE_PRECISION (GET_MODE (operands[2]))
			     && !register_operand (operands[2],
						   GET_MODE (operands[2])))
			 /* And we shouldn't widen if
			    TARGET_PARTIAL_REG_STALL.  */
			 || (TARGET_PARTIAL_REG_STALL
			     && (INTVAL (operands[3]) + INTVAL (operands[4])
				 >= (paradoxical_subreg_p (operands[2])
				     && (GET_MODE_CLASS
					  (GET_MODE (SUBREG_REG (operands[2])))
					 == MODE_INT)
				     ? GET_MODE_PRECISION
					 (GET_MODE (SUBREG_REG (operands[2])))
				     : GET_MODE_PRECISION
					 (GET_MODE (operands[2])))))
			 ? CCZmode : CCNOmode)) && 
#line 12256 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_272 (insn, operands);

        case 1:
          if (!(
#line 12214 "../../gcc/config/i386/i386.md"
(/* Ensure that resulting mask is zero or sign extended operand.  */
   INTVAL (operands[4]) >= 0
   && ((INTVAL (operands[3]) > 0
	&& INTVAL (operands[3]) + INTVAL (operands[4]) <= 32)
       || (SImode == DImode
	   && INTVAL (operands[3]) > 32
	   && INTVAL (operands[3]) + INTVAL (operands[4]) == 64))
   && ix86_match_ccmode (insn,
			 /* If zero_extract mode precision is the same
			    as len, the SF of the zero_extract
			    comparison will be the most significant
			    extracted bit, but this could be matched
			    after splitting only for pos 0 len all bits
			    trivial extractions.  Require CCZmode.  */
			 (GET_MODE_PRECISION (SImode)
			  == INTVAL (operands[3]))
			 /* Otherwise, require CCZmode if we'd use a mask
			    with the most significant bit set and can't
			    widen it to wider mode.  *testdi_1 also
			    requires CCZmode if the mask has bit
			    31 set and all bits above it clear.  */
			 || (INTVAL (operands[3]) + INTVAL (operands[4])
			     >= 32)
			 /* We can't widen also if val is not a REG.  */
			 || (INTVAL (operands[3]) + INTVAL (operands[4])
			     == GET_MODE_PRECISION (GET_MODE (operands[2]))
			     && !register_operand (operands[2],
						   GET_MODE (operands[2])))
			 /* And we shouldn't widen if
			    TARGET_PARTIAL_REG_STALL.  */
			 || (TARGET_PARTIAL_REG_STALL
			     && (INTVAL (operands[3]) + INTVAL (operands[4])
				 >= (paradoxical_subreg_p (operands[2])
				     && (GET_MODE_CLASS
					  (GET_MODE (SUBREG_REG (operands[2])))
					 == MODE_INT)
				     ? GET_MODE_PRECISION
					 (GET_MODE (SUBREG_REG (operands[2])))
				     : GET_MODE_PRECISION
					 (GET_MODE (operands[2])))))
			 ? CCZmode : CCNOmode)) && 
#line 12256 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_273 (insn, operands);

        case 2:
          if (!((
#line 12214 "../../gcc/config/i386/i386.md"
(/* Ensure that resulting mask is zero or sign extended operand.  */
   INTVAL (operands[4]) >= 0
   && ((INTVAL (operands[3]) > 0
	&& INTVAL (operands[3]) + INTVAL (operands[4]) <= 32)
       || (DImode == DImode
	   && INTVAL (operands[3]) > 32
	   && INTVAL (operands[3]) + INTVAL (operands[4]) == 64))
   && ix86_match_ccmode (insn,
			 /* If zero_extract mode precision is the same
			    as len, the SF of the zero_extract
			    comparison will be the most significant
			    extracted bit, but this could be matched
			    after splitting only for pos 0 len all bits
			    trivial extractions.  Require CCZmode.  */
			 (GET_MODE_PRECISION (DImode)
			  == INTVAL (operands[3]))
			 /* Otherwise, require CCZmode if we'd use a mask
			    with the most significant bit set and can't
			    widen it to wider mode.  *testdi_1 also
			    requires CCZmode if the mask has bit
			    31 set and all bits above it clear.  */
			 || (INTVAL (operands[3]) + INTVAL (operands[4])
			     >= 32)
			 /* We can't widen also if val is not a REG.  */
			 || (INTVAL (operands[3]) + INTVAL (operands[4])
			     == GET_MODE_PRECISION (GET_MODE (operands[2]))
			     && !register_operand (operands[2],
						   GET_MODE (operands[2])))
			 /* And we shouldn't widen if
			    TARGET_PARTIAL_REG_STALL.  */
			 || (TARGET_PARTIAL_REG_STALL
			     && (INTVAL (operands[3]) + INTVAL (operands[4])
				 >= (paradoxical_subreg_p (operands[2])
				     && (GET_MODE_CLASS
					  (GET_MODE (SUBREG_REG (operands[2])))
					 == MODE_INT)
				     ? GET_MODE_PRECISION
					 (GET_MODE (SUBREG_REG (operands[2])))
				     : GET_MODE_PRECISION
					 (GET_MODE (operands[2])))))
			 ? CCZmode : CCNOmode)) && 
#line 1166 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 12256 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_274 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
      if (XWINT (x3, 0) != 0L)
        return NULL;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != ZERO_EXTRACT)
        return NULL;
      x9 = XEXP (x4, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      x12 = XEXP (x4, 2);
      if (GET_CODE (x12) != SUBREG
          || maybe_ne (SUBREG_BYTE (x12), 0)
          || GET_MODE (x12) != E_QImode)
        return NULL;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != AND)
        return NULL;
      x10 = XEXP (x1, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 17
          || GET_MODE (x10) != E_CCCmode
          || GET_MODE (x2) != E_CCCmode)
        return NULL;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      switch (pattern1433 (x4))
        {
        case 0:
          if (!(
#line 19188 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 19193 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_814 (insn, operands);

        case 1:
          if (!(
#line 19188 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 19193 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_816 (insn, operands);

        case 2:
          if (!((
#line 19188 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 1166 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19193 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_818 (insn, operands);

        case 3:
          if (!((
#line 19188 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19193 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_815 (insn, operands);

        case 4:
          if (!((
#line 19188 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19193 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_817 (insn, operands);

        case 5:
          if (!((
#line 19188 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19193 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_819 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_13 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case COMPARE:
      return split_5 (x1, insn);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x2;
      res = split_1 (x1, insn);
      if (res != NULL_RTX)
        return res;
      switch (GET_CODE (x2))
        {
        case REG:
          if (REGNO (x2) != 17
              || pattern56 (x1, 
E_CCCmode) != 0
              || !(
#line 9885 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 9887 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_195 (insn, operands);

        case SUBREG:
          if (maybe_ne (SUBREG_BYTE (x2), 0))
            return NULL;
          x3 = XEXP (x2, 0);
          switch (GET_CODE (x3))
            {
            case NOT:
              switch (pattern253 (x1))
                {
                case 0:
                  if (!
#line 15147 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
                    return NULL;
                  return gen_split_549 (insn, operands);

                case 1:
                  if (!
#line 15147 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
                    return NULL;
                  return gen_split_550 (insn, operands);

                case 2:
                  if (!(
#line 15147 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))) && 
#line 1166 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return NULL;
                  return gen_split_551 (insn, operands);

                default:
                  return NULL;
                }

            case LSHIFTRT:
              x4 = XEXP (x1, 0);
              operands[0] = x4;
              switch (pattern294 (x2))
                {
                case 0:
                  if (!((
#line 16740 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF && UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1237 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 16742 "../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_601 (insn, operands);

                case 1:
                  if (!((
#line 16740 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF && UINTVAL (operands[2]) < 8 * BITS_PER_UNIT) && 
#line 1238 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 16742 "../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_603 (insn, operands);

                default:
                  return NULL;
                }

            case ASHIFTRT:
              x4 = XEXP (x1, 0);
              operands[0] = x4;
              switch (pattern294 (x2))
                {
                case 0:
                  if (!((
#line 16740 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF && UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1237 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 16742 "../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_602 (insn, operands);

                case 1:
                  if (!((
#line 16740 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF && UINTVAL (operands[2]) < 8 * BITS_PER_UNIT) && 
#line 1238 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 16742 "../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_604 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PLUS:
      return split_6 (x1, insn);

    case IOR:
      return split_7 (x1, insn);

    case XOR:
      return split_8 (x1, insn);

    case FLOAT_EXTEND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_CODE (operands[1]))
        {
        case SUBREG:
        case MEM:
          if (memory_operand (operands[1], E_VOIDmode)
              && any_fp_register_operand (operands[0], E_VOIDmode)
              && 
#line 4616 "../../gcc/config/i386/i386.md"
(reload_completed
   && (GET_MODE (operands[0]) == TFmode
       || GET_MODE (operands[0]) == XFmode
       || GET_MODE (operands[0]) == DFmode)
   && ix86_standard_x87sse_constant_load_p (insn, operands[0])))
            return gen_split_49 (insn, operands);
          break;

        case REG:
          res = split_2 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      if (!nonimmediate_operand (operands[1], E_SFmode)
          || !sse_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode)
        return NULL;
      if (
#line 5341 "../../gcc/config/i386/i386.md"
(TARGET_USE_VECTOR_FP_CONVERTS
   && optimize_insn_for_speed_p ()
   && reload_completed
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
        return gen_split_70 (insn, operands);
      if (!
#line 5404 "../../gcc/config/i386/i386.md"
(!TARGET_AVX
   && TARGET_SSE_PARTIAL_REG_FP_CONVERTS_DEPENDENCY
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && (!REG_P (operands[1])
       || (!TARGET_AVX && REGNO (operands[0]) != REGNO (operands[1])))
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
        return NULL;
      return gen_split_71 (insn, operands);

    case ZERO_EXTEND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (!nonimmediate_operand (operands[0], E_TImode)
                  || GET_MODE (x2) != E_TImode
                  || !nonimmediate_operand (operands[1], E_DImode)
                  || !(
#line 4662 "../../gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 4664 "../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_53 (insn, operands);

            case E_DImode:
              if (GET_MODE (x2) != E_DImode)
                return NULL;
              if (memory_operand (operands[0], E_DImode)
                  && memory_operand (operands[1], E_SImode)
                  && 
#line 4786 "../../gcc/config/i386/i386.md"
(reload_completed))
                return gen_split_54 (insn, operands);
              if (general_reg_operand (operands[0], E_DImode)
                  && general_reg_operand (operands[1], E_SImode)
                  && 
#line 4793 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT && reload_completed
   && REGNO (operands[0]) == REGNO (operands[1])))
                return gen_split_55 (insn, operands);
              if (!nonimmediate_gr_operand (operands[0], E_DImode)
                  || !nonimmediate_operand (operands[1], E_SImode)
                  || !
#line 4801 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT && reload_completed
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                return NULL;
              return gen_split_56 (insn, operands);

            default:
              return NULL;
            }

        case UNSPEC:
          if (XVECLEN (x3, 0) != 1
              || XINT (x3, 1) != 20
              || GET_MODE (x3) != E_SImode)
            return NULL;
          x5 = XVECEXP (x3, 0, 0);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !(
#line 23215 "../../gcc/config/i386/i386.md"
(TARGET_X32) && 
#line 23217 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_919 (insn, operands);

        default:
          return NULL;
        }

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) != E_SFmode)
        return NULL;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!sse_reg_operand (operands[0], E_SFmode))
        return NULL;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_DFmode))
        return NULL;
      if (
#line 5580 "../../gcc/config/i386/i386.md"
(TARGET_USE_VECTOR_FP_CONVERTS
   && optimize_insn_for_speed_p ()
   && reload_completed
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
        return gen_split_72 (insn, operands);
      if (!
#line 5634 "../../gcc/config/i386/i386.md"
(!TARGET_AVX
   && TARGET_SSE_PARTIAL_REG_FP_CONVERTS_DEPENDENCY
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && (!REG_P (operands[1])
       || (!TARGET_AVX && REGNO (operands[0]) != REGNO (operands[1])))
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
        return NULL;
      return gen_split_73 (insn, operands);

    case FLOAT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (GET_MODE (x2) != E_SFmode)
            return NULL;
          if (sse_reg_operand (operands[0], E_SFmode)
              && nonimmediate_operand (operands[1], E_SImode))
            {
              if (
#line 6161 "../../gcc/config/i386/i386.md"
(TARGET_SSE2
   && TARGET_USE_VECTOR_CONVERTS
   && optimize_function_for_speed_p (cfun)
   && reload_completed
   && (MEM_P (operands[1]) || TARGET_INTER_UNIT_MOVES_TO_VEC)
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
                return gen_split_79 (insn, operands);
              if (
#line 6246 "../../gcc/config/i386/i386.md"
(!TARGET_AVX
   && TARGET_SSE_PARTIAL_REG_CONVERTS_DEPENDENCY
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
                return gen_split_87 (insn, operands);
            }
          if (register_operand (operands[0], E_SFmode)
              && register_operand (operands[1], E_DImode)
              && 
#line 6190 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_INTER_UNIT_MOVES_TO_VEC
   && TARGET_80387 && X87_ENABLE_FLOAT (SFmode, DImode)
   && TARGET_SSE2 && optimize_function_for_speed_p (cfun)
   && can_create_pseudo_p ()))
            return gen_split_81 (insn, operands);
          if (!sse_reg_operand (operands[0], E_SFmode)
              || !nonimmediate_operand (operands[1], E_DImode)
              || !(
#line 6246 "../../gcc/config/i386/i386.md"
(!TARGET_AVX
   && TARGET_SSE_PARTIAL_REG_CONVERTS_DEPENDENCY
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_88 (insn, operands);

        case E_DFmode:
          if (GET_MODE (x2) != E_DFmode)
            return NULL;
          if (sse_reg_operand (operands[0], E_DFmode)
              && nonimmediate_operand (operands[1], E_SImode))
            {
              if (
#line 6161 "../../gcc/config/i386/i386.md"
(TARGET_SSE2
   && TARGET_USE_VECTOR_CONVERTS
   && optimize_function_for_speed_p (cfun)
   && reload_completed
   && (MEM_P (operands[1]) || TARGET_INTER_UNIT_MOVES_TO_VEC)
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
                return gen_split_80 (insn, operands);
              if (
#line 6246 "../../gcc/config/i386/i386.md"
(!TARGET_AVX
   && TARGET_SSE_PARTIAL_REG_CONVERTS_DEPENDENCY
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
                return gen_split_89 (insn, operands);
            }
          if (register_operand (operands[0], E_DFmode)
              && register_operand (operands[1], E_DImode)
              && 
#line 6190 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_INTER_UNIT_MOVES_TO_VEC
   && TARGET_80387 && X87_ENABLE_FLOAT (DFmode, DImode)
   && TARGET_SSE2 && optimize_function_for_speed_p (cfun)
   && can_create_pseudo_p ()))
            return gen_split_82 (insn, operands);
          if (!sse_reg_operand (operands[0], E_DFmode)
              || !nonimmediate_operand (operands[1], E_DImode)
              || !(
#line 6246 "../../gcc/config/i386/i386.md"
(!TARGET_AVX
   && TARGET_SSE_PARTIAL_REG_CONVERTS_DEPENDENCY
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_90 (insn, operands);

        case E_XFmode:
          if (!register_operand (operands[0], E_XFmode)
              || GET_MODE (x2) != E_XFmode
              || !register_operand (operands[1], E_DImode)
              || !
#line 6190 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_INTER_UNIT_MOVES_TO_VEC
   && TARGET_80387 && X87_ENABLE_FLOAT (XFmode, DImode)
   && TARGET_SSE2 && optimize_function_for_speed_p (cfun)
   && can_create_pseudo_p ()))
            return NULL;
          return gen_split_83 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      x3 = XEXP (x2, 0);
      if (!rtx_equal_p (x3, operands[0]))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!general_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !const1248_operand (operands[1], E_SImode)
              || !
#line 6430 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF && reload_completed))
            return NULL;
          return gen_split_96 (insn, operands);

        case E_DImode:
          if (!general_reg_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !const1248_operand (operands[1], E_DImode)
              || !(
#line 6430 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF && reload_completed) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_97 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
      switch (XVECLEN (x2, 0))
        {
        case 2:
          switch (XINT (x2, 1))
            {
            case 41:
              if (GET_MODE (x2) != E_CCCmode)
                return NULL;
              x7 = XVECEXP (x2, 0, 0);
              if (GET_CODE (x7) != LTU
                  || pattern712 (x7) != 0
                  || pattern250 (x1) != 0)
                return NULL;
              x8 = XEXP (x7, 0);
              switch (GET_MODE (x8))
                {
                case E_CCmode:
                  if (!(
#line 9906 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 9908 "../../gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_198 (insn, operands);

                case E_CCCmode:
                  if (!(
#line 9906 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 9908 "../../gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_199 (insn, operands);

                default:
                  return NULL;
                }

            case 46:
              if (pattern298 (x2) != 0)
                return NULL;
              x4 = XEXP (x1, 0);
              operands[0] = x4;
              if (!register_operand (operands[0], E_SImode))
                return NULL;
              x9 = XVECEXP (x2, 0, 1);
              operands[2] = x9;
              if (!register_operand (operands[2], E_SImode)
                  || !(
#line 19578 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 19580 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_856 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          switch (XINT (x2, 1))
            {
            case 98:
              switch (pattern302 (x2))
                {
                case 0:
                  if (!((
#line 21668 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21650 "../../gcc/config/i386/i386.md"
(TARGET_BMI)) && 
#line 21670 "../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
                    return NULL;
                  return gen_split_890 (insn, operands);

                case 1:
                  if (!((
#line 21668 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && (((
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21650 "../../gcc/config/i386/i386.md"
(TARGET_BMI)) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 21650 "../../gcc/config/i386/i386.md"
(TARGET_BMI))) && 
#line 21670 "../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
                    return NULL;
                  return gen_split_892 (insn, operands);

                default:
                  return NULL;
                }

            case 97:
              switch (pattern302 (x2))
                {
                case 0:
                  if (!((
#line 21668 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21651 "../../gcc/config/i386/i386.md"
(TARGET_LZCNT)) && 
#line 21670 "../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
                    return NULL;
                  return gen_split_891 (insn, operands);

                case 1:
                  if (!((
#line 21668 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && (((
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21651 "../../gcc/config/i386/i386.md"
(TARGET_LZCNT)) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 21651 "../../gcc/config/i386/i386.md"
(TARGET_LZCNT))) && 
#line 21670 "../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
                    return NULL;
                  return gen_split_893 (insn, operands);

                default:
                  return NULL;
                }

            case 20:
              x7 = XVECEXP (x2, 0, 0);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              switch (pattern23 (x2))
                {
                case 0:
                  if (!
#line 1410 "../../gcc/config/i386/i386.md"
(ptr_mode == SImode))
                    return NULL;
                  return gen_split_917 (insn, operands);

                case 1:
                  if (!
#line 1410 "../../gcc/config/i386/i386.md"
(ptr_mode == DImode))
                    return NULL;
                  return gen_split_918 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case AND:
          switch (pattern405 (x2))
            {
            case 0:
              return gen_split_400 (insn, operands);

            case 1:
              return gen_split_403 (insn, operands);

            case 2:
              return gen_split_409 (insn, operands);

            case 3:
              if (!
#line 1166 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_406 (insn, operands);

            case 4:
              if (!
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_412 (insn, operands);

            case 5:
              if (!
#line 13872 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_415 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern405 (x2))
            {
            case 0:
              return gen_split_401 (insn, operands);

            case 1:
              return gen_split_404 (insn, operands);

            case 2:
              return gen_split_410 (insn, operands);

            case 3:
              if (!
#line 1166 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_407 (insn, operands);

            case 4:
              if (!
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_413 (insn, operands);

            case 5:
              if (!
#line 13872 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_416 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern405 (x2))
            {
            case 0:
              return gen_split_402 (insn, operands);

            case 1:
              return gen_split_405 (insn, operands);

            case 2:
              return gen_split_411 (insn, operands);

            case 3:
              if (!
#line 1166 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_408 (insn, operands);

            case 4:
              if (!
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_414 (insn, operands);

            case 5:
              if (!
#line 13872 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_417 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case NOT:
      switch (pattern40 (x1))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !nonimmediate_operand (operands[1], E_DImode)
                  || !((
#line 14980 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, DImode, operands, TARGET_APX_NDD)) && 
#line 1237 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14982 "../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_540 (insn, operands);

            case E_TImode:
              if (!nonimmediate_operand (operands[0], E_TImode)
                  || GET_MODE (x2) != E_TImode
                  || !nonimmediate_operand (operands[1], E_TImode)
                  || !((
#line 14980 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, TImode, operands, TARGET_APX_NDD)) && 
#line 1238 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14982 "../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_541 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (!(
#line 15063 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 15067 "../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_542 (insn, operands);

        case 2:
          if (!(
#line 15063 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 15067 "../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_543 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_CODE (operands[2]))
        {
        case REG:
        case SUBREG:
          if (!register_operand (operands[2], E_QImode))
            return NULL;
          switch (pattern126 (x2))
            {
            case 0:
              if (!
#line 15982 "../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed))
                return NULL;
              return gen_split_570 (insn, operands);

            case 1:
              if (!(
#line 15982 "../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_571 (insn, operands);

            default:
              return NULL;
            }

        case CONST_INT:
          if (!const_0_to_3_operand (operands[2], E_VOIDmode))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!general_reg_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !index_reg_operand (operands[1], E_QImode)
                  || !
#line 16304 "../../gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])
   && !TARGET_APX_NDD))
                return NULL;
              return gen_split_581 (insn, operands);

            case E_HImode:
              if (!general_reg_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !index_reg_operand (operands[1], E_HImode)
                  || !
#line 16304 "../../gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])
   && !TARGET_APX_NDD))
                return NULL;
              return gen_split_582 (insn, operands);

            case E_SImode:
              if (!general_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !index_reg_operand (operands[1], E_SImode)
                  || !
#line 16304 "../../gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])
   && !TARGET_APX_NDD))
                return NULL;
              return gen_split_583 (insn, operands);

            case E_DImode:
              if (!general_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !index_reg_operand (operands[1], E_DImode)
                  || !(
#line 16304 "../../gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])
   && !TARGET_APX_NDD) && 
#line 1163 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_584 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case LSHIFTRT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern233 (x2))
        {
        case 0:
          if (!
#line 17429 "../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed))
            return NULL;
          return gen_split_618 (insn, operands);

        case 1:
          if (!(
#line 17429 "../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_620 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern233 (x2))
            {
            case 0:
              if (!
#line 17429 "../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed))
                return NULL;
              return gen_split_619 (insn, operands);

            case 1:
              if (!(
#line 17429 "../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_621 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          if (pattern292 (x2, 
E_V2DImode) != 0)
            return NULL;
          if ((
#line 18010 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_STV && TARGET_AVX512VL
   && INTVAL (operands[2]) == INTVAL (operands[3])
   && UINTVAL (operands[2]) < 32) && 
#line 18014 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return gen_split_676 (insn, operands);
          if (!(
#line 18027 "../../gcc/config/i386/i386.md"
(!TARGET_AVX512VL
   && INTVAL (operands[2]) == INTVAL (operands[3])
   && UINTVAL (operands[2]) < 32
   && ix86_pre_reload_split ()) && 
#line 18032 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_677 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      return split_9 (x1, insn);

    case ROTATERT:
      return split_11 (x1, insn);

    case IF_THEN_ELSE:
      return split_12 (x1, insn);

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      switch (GET_CODE (x2))
        {
        case GEU:
        case LTU:
          res = split_4 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case GTU:
        case LEU:
          operands[1] = x2;
          if (shr_comparison_operator (operands[1], E_QImode))
            {
              x4 = XEXP (x1, 0);
              operands[0] = x4;
              if (nonimmediate_operand (operands[0], E_QImode))
                {
                  x3 = XEXP (x2, 0);
                  operands[2] = x3;
                  if (register_operand (operands[2], E_DImode))
                    {
                      x6 = XEXP (x2, 1);
                      operands[3] = x6;
                      if (const_int_operand (operands[3], E_VOIDmode)
                          && 
#line 19465 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && IN_RANGE (exact_log2 (UINTVAL (operands[3]) + 1), 32, 63)))
                        return gen_split_850 (insn, operands);
                    }
                }
            }
          break;

        case NE:
          switch (pattern234 (x1))
            {
            case 0:
              return gen_split_857 (insn, operands);

            case 1:
              return gen_split_858 (insn, operands);

            default:
              break;
            }
          break;

        case EQ:
          switch (pattern234 (x1))
            {
            case 0:
              return gen_split_859 (insn, operands);

            case 1:
              return gen_split_860 (insn, operands);

            default:
              break;
            }
          break;

        default:
          break;
        }
      operands[1] = x2;
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 17)
        return NULL;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !ix86_comparison_operator (operands[1], E_DImode)
              || !(
#line 19503 "../../gcc/config/i386/i386.md"
(!TARGET_APX_ZU && TARGET_64BIT && !TARGET_PARTIAL_REG_STALL) && 
#line 19505 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_851 (insn, operands);

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || !ix86_comparison_operator (operands[1], E_HImode)
              || !(
#line 19536 "../../gcc/config/i386/i386.md"
(!TARGET_APX_ZU && !TARGET_PARTIAL_REG_STALL
   && (!TARGET_ZERO_EXTEND_WITH_AND || optimize_function_for_size_p (cfun))) && 
#line 19539 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_854 (insn, operands);

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !ix86_comparison_operator (operands[1], E_SImode)
              || !(
#line 19536 "../../gcc/config/i386/i386.md"
(!TARGET_APX_ZU && !TARGET_PARTIAL_REG_STALL
   && (!TARGET_ZERO_EXTEND_WITH_AND || optimize_function_for_size_p (cfun))) && 
#line 19539 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_855 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      return split_10 (x1, insn);

    case CLZ:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (pattern126 (x2))
        {
        case 0:
          if (!(
#line 21507 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF && TARGET_LZCNT) && 
#line 21509 "../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_884 (insn, operands);

        case 1:
          if (!((
#line 21507 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF && TARGET_LZCNT) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 21509 "../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_885 (insn, operands);

        default:
          return NULL;
        }

    case POPCOUNT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (pattern126 (x2))
        {
        case 0:
          if (!(
#line 22308 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF && TARGET_POPCNT) && 
#line 22316 "../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_908 (insn, operands);

        case 1:
          if (!((
#line 22308 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF && TARGET_POPCNT) && 
#line 1169 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 22316 "../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_909 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_45 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (nonimmediate_gr_operand (operands[0], E_V8QImode)
          && nonimmediate_gr_operand (operands[1], E_V8QImode)
          && 
#line 310 "../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_989 (insn, operands);
      break;

    case E_V4HImode:
      if (nonimmediate_gr_operand (operands[0], E_V4HImode)
          && nonimmediate_gr_operand (operands[1], E_V4HImode)
          && 
#line 310 "../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_990 (insn, operands);
      break;

    case E_V2SImode:
      if (nonimmediate_gr_operand (operands[0], E_V2SImode)
          && nonimmediate_gr_operand (operands[1], E_V2SImode)
          && 
#line 310 "../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_991 (insn, operands);
      break;

    case E_V1DImode:
      if (nonimmediate_gr_operand (operands[0], E_V1DImode)
          && nonimmediate_gr_operand (operands[1], E_V1DImode)
          && 
#line 310 "../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_992 (insn, operands);
      break;

    case E_V2SFmode:
      if (nonimmediate_gr_operand (operands[0], E_V2SFmode)
          && nonimmediate_gr_operand (operands[1], E_V2SFmode)
          && 
#line 310 "../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_993 (insn, operands);
      break;

    case E_V4HFmode:
      if (nonimmediate_gr_operand (operands[0], E_V4HFmode)
          && nonimmediate_gr_operand (operands[1], E_V4HFmode)
          && 
#line 310 "../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_994 (insn, operands);
      break;

    case E_V4BFmode:
      if (nonimmediate_gr_operand (operands[0], E_V4BFmode)
          && nonimmediate_gr_operand (operands[1], E_V4BFmode)
          && 
#line 310 "../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_995 (insn, operands);
      break;

    case E_V4QImode:
      if (push_operand (operands[0], E_V4QImode)
          && sse_reg_operand (operands[1], E_V4QImode))
        {
          if ((
#line 440 "../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1400 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_1013 (insn, operands);
          if ((
#line 440 "../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1400 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return gen_split_1018 (insn, operands);
        }
      break;

    case E_V2HImode:
      if (push_operand (operands[0], E_V2HImode)
          && sse_reg_operand (operands[1], E_V2HImode))
        {
          if ((
#line 440 "../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1400 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_1014 (insn, operands);
          if ((
#line 440 "../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1400 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return gen_split_1019 (insn, operands);
        }
      break;

    case E_V1SImode:
      if (push_operand (operands[0], E_V1SImode)
          && sse_reg_operand (operands[1], E_V1SImode))
        {
          if ((
#line 440 "../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1400 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_1015 (insn, operands);
          if ((
#line 440 "../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1400 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return gen_split_1020 (insn, operands);
        }
      break;

    case E_V2HFmode:
      if (push_operand (operands[0], E_V2HFmode)
          && sse_reg_operand (operands[1], E_V2HFmode))
        {
          if ((
#line 440 "../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1400 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_1016 (insn, operands);
          if ((
#line 440 "../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1400 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return gen_split_1021 (insn, operands);
        }
      break;

    case E_V2BFmode:
      if (push_operand (operands[0], E_V2BFmode)
          && sse_reg_operand (operands[1], E_V2BFmode))
        {
          if ((
#line 440 "../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1400 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_1017 (insn, operands);
          if ((
#line 440 "../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1400 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return gen_split_1022 (insn, operands);
        }
      break;

    case E_V2QImode:
      if (push_operand (operands[0], E_V2QImode)
          && sse_reg_operand (operands[1], E_V2QImode))
        {
          if ((
#line 614 "../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && reload_completed) && 
#line 1400 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_1023 (insn, operands);
          if ((
#line 614 "../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && reload_completed) && 
#line 1400 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return gen_split_1024 (insn, operands);
        }
      break;

    case E_P2QImode:
      if (nonimmediate_operand (operands[0], E_P2QImode)
          && nonimmediate_operand (operands[1], E_P2QImode)
          && (
#line 31027 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VP2INTERSECT
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 31030 "../../gcc/config/i386/sse.md"
( reload_completed)))
        return gen_split_3817 (insn, operands);
      break;

    case E_P2HImode:
      if (nonimmediate_operand (operands[0], E_P2HImode)
          && nonimmediate_operand (operands[1], E_P2HImode)
          && (
#line 31027 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VP2INTERSECT
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 31030 "../../gcc/config/i386/sse.md"
( reload_completed)))
        return gen_split_3818 (insn, operands);
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != SUBREG)
    return NULL;
  operands[0] = x3;
  switch (SUBREG_BYTE (x2))
    {
    case 8:
      if (GET_MODE (x2) != E_DFmode
          || !register_operand (operands[0], E_DFmode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2DFmode)
          || !
#line 14701 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
        return NULL;
      return gen_split_3172 (insn, operands);

    case 0:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x2) != E_DFmode
                  || !register_operand (operands[1], E_V2DFmode)
                  || !
#line 14754 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
                return NULL;
              return gen_split_3174 (insn, operands);

            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !register_operand (operands[1], E_VOIDmode)
                  || !
#line 21513 "../../gcc/config/i386/sse.md"
(can_create_pseudo_p ()
   && REG_P (operands[1])
   && VECTOR_MODE_P (GET_MODE (operands[1]))
   && ((TARGET_SSE && GET_MODE_SIZE (GET_MODE (operands[1])) == 16)
       || (TARGET_AVX && GET_MODE_SIZE (GET_MODE (operands[1])) == 32)
       || (TARGET_AVX512F && TARGET_EVEX512
	   && GET_MODE_SIZE (GET_MODE (operands[1])) == 64))
   && (SImode == SImode || TARGET_64BIT || MEM_P (operands[0]))))
                return NULL;
              return gen_split_3400 (insn, operands);

            case E_DImode:
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !register_operand (operands[1], E_VOIDmode)
                  || !
#line 21513 "../../gcc/config/i386/sse.md"
(can_create_pseudo_p ()
   && REG_P (operands[1])
   && VECTOR_MODE_P (GET_MODE (operands[1]))
   && ((TARGET_SSE && GET_MODE_SIZE (GET_MODE (operands[1])) == 16)
       || (TARGET_AVX && GET_MODE_SIZE (GET_MODE (operands[1])) == 32)
       || (TARGET_AVX512F && TARGET_EVEX512
	   && GET_MODE_SIZE (GET_MODE (operands[1])) == 64))
   && (DImode == SImode || TARGET_64BIT || MEM_P (operands[0]))))
                return NULL;
              return gen_split_3401 (insn, operands);

            default:
              return NULL;
            }

        case SS_TRUNCATE:
          switch (pattern720 (x2))
            {
            case 0:
              if (!(
#line 15474 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15476 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3186 (insn, operands);

            case 1:
              if (!(
#line 15569 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15571 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3189 (insn, operands);

            case 2:
              if (!(
#line 15569 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15571 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3192 (insn, operands);

            case 3:
              if (!(
#line 15920 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15922 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3208 (insn, operands);

            case 4:
              if (!((
#line 15667 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15649 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)) && 
#line 15669 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3195 (insn, operands);

            case 5:
              if (!(
#line 15667 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15669 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3198 (insn, operands);

            case 6:
              if (!(
#line 16183 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()) && 
#line 16185 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3215 (insn, operands);

            case 7:
              if (!(
#line 15829 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15831 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3202 (insn, operands);

            case 8:
              if (!(
#line 15829 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15831 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3205 (insn, operands);

            case 9:
              if (!(
#line 16070 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 16072 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3212 (insn, operands);

            default:
              return NULL;
            }

        case TRUNCATE:
          switch (pattern720 (x2))
            {
            case 0:
              if (!(
#line 15474 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15476 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3187 (insn, operands);

            case 1:
              if (!(
#line 15569 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15571 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3190 (insn, operands);

            case 2:
              if (!(
#line 15569 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15571 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3193 (insn, operands);

            case 3:
              if (!(
#line 15920 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15922 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3209 (insn, operands);

            case 4:
              if (!((
#line 15667 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15649 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)) && 
#line 15669 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3196 (insn, operands);

            case 5:
              if (!(
#line 15667 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15669 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3199 (insn, operands);

            case 6:
              if (!(
#line 16183 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()) && 
#line 16185 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3216 (insn, operands);

            case 7:
              if (!(
#line 15829 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15831 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3203 (insn, operands);

            case 8:
              if (!(
#line 15829 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15831 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3206 (insn, operands);

            case 9:
              if (!(
#line 16070 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 16072 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3213 (insn, operands);

            default:
              return NULL;
            }

        case US_TRUNCATE:
          switch (pattern720 (x2))
            {
            case 0:
              if (!(
#line 15474 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15476 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3188 (insn, operands);

            case 1:
              if (!(
#line 15569 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15571 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3191 (insn, operands);

            case 2:
              if (!(
#line 15569 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15571 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3194 (insn, operands);

            case 3:
              if (!(
#line 15920 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15922 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3210 (insn, operands);

            case 4:
              if (!((
#line 15667 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15649 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)) && 
#line 15669 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3197 (insn, operands);

            case 5:
              if (!(
#line 15667 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15669 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3200 (insn, operands);

            case 6:
              if (!(
#line 16183 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()) && 
#line 16185 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3217 (insn, operands);

            case 7:
              if (!(
#line 15829 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15831 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3204 (insn, operands);

            case 8:
              if (!(
#line 15829 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15831 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3207 (insn, operands);

            case 9:
              if (!(
#line 16070 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 16072 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3214 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_60 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode)
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DFmode:
          if (!register_operand (operands[1], E_V8DFmode)
              || !(
#line 12533 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ
   && reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1]))) && 
#line 727 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return NULL;
          return gen_split_1559 (insn, operands);

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !
#line 12951 "../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed))
            return NULL;
          return gen_split_1568 (insn, operands);

        default:
          return NULL;
        }

    case E_V2DImode:
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode)
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DImode:
          if (!register_operand (operands[1], E_V8DImode)
              || !(
#line 12533 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ
   && reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1]))) && 
#line 727 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return NULL;
          return gen_split_1560 (insn, operands);

        case E_V4DImode:
          if (!nonimmediate_operand (operands[1], E_V4DImode)
              || !
#line 12951 "../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed))
            return NULL;
          return gen_split_1567 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_62 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (pattern829 (x3) != 0)
    return NULL;
  x4 = XVECEXP (x3, 0, 4);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return NULL;
  x5 = XVECEXP (x3, 0, 5);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return NULL;
  x6 = XVECEXP (x3, 0, 6);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return NULL;
  x7 = XVECEXP (x3, 0, 7);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return NULL;
  switch (pattern1512 (x2))
    {
    case 0:
      if (!(
#line 12903 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1]))) && 
#line 731 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return NULL;
      return gen_split_1565 (insn, operands);

    case 1:
      if (!(
#line 12903 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1]))) && 
#line 731 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return NULL;
      return gen_split_1566 (insn, operands);

    case 2:
      if (!(
#line 13143 "../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13145 "../../gcc/config/i386/sse.md"
( reload_completed)))
        return NULL;
      return gen_split_1574 (insn, operands);

    case 3:
      if (!(
#line 13143 "../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13145 "../../gcc/config/i386/sse.md"
( reload_completed)))
        return NULL;
      return gen_split_1575 (insn, operands);

    case 4:
      if (!(
#line 13143 "../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13145 "../../gcc/config/i386/sse.md"
( reload_completed)))
        return NULL;
      return gen_split_1576 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_64 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern529 (x2))
        {
        case 0:
          if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1677 (insn, operands);

        case 1:
          if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1704 (insn, operands);

        case 2:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1731 (insn, operands);

        case 3:
          if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1758 (insn, operands);

        case 4:
          if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1785 (insn, operands);

        case 5:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1812 (insn, operands);

        case 6:
          if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1839 (insn, operands);

        case 7:
          if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1866 (insn, operands);

        case 8:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1893 (insn, operands);

        case 9:
          if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1920 (insn, operands);

        case 10:
          if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1947 (insn, operands);

        case 11:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1974 (insn, operands);

        case 12:
          if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1680 (insn, operands);

        case 13:
          if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1707 (insn, operands);

        case 14:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1734 (insn, operands);

        case 15:
          if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1761 (insn, operands);

        case 16:
          if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1788 (insn, operands);

        case 17:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1815 (insn, operands);

        case 18:
          if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1842 (insn, operands);

        case 19:
          if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1869 (insn, operands);

        case 20:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1896 (insn, operands);

        case 21:
          if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1923 (insn, operands);

        case 22:
          if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1950 (insn, operands);

        case 23:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1977 (insn, operands);

        case 24:
          if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1683 (insn, operands);

        case 25:
          if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1710 (insn, operands);

        case 26:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1737 (insn, operands);

        case 27:
          if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1764 (insn, operands);

        case 28:
          if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1791 (insn, operands);

        case 29:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1818 (insn, operands);

        case 30:
          if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1845 (insn, operands);

        case 31:
          if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1872 (insn, operands);

        case 32:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1899 (insn, operands);

        case 33:
          if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1926 (insn, operands);

        case 34:
          if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1953 (insn, operands);

        case 35:
          if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1980 (insn, operands);

        case 36:
          if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2961 (insn, operands);

        case 37:
          if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2970 (insn, operands);

        case 38:
          if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2979 (insn, operands);

        case 39:
          if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2988 (insn, operands);

        case 40:
          if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2997 (insn, operands);

        case 41:
          if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3006 (insn, operands);

        case 42:
          if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3015 (insn, operands);

        case 43:
          if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3024 (insn, operands);

        case 44:
          if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3033 (insn, operands);

        case 45:
          if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3042 (insn, operands);

        case 46:
          if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3051 (insn, operands);

        case 47:
          if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3060 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern531 (x2))
        {
        case 0:
          if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2325 (insn, operands);

        case 1:
          if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2352 (insn, operands);

        case 2:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2379 (insn, operands);

        case 3:
          if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2406 (insn, operands);

        case 4:
          if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2433 (insn, operands);

        case 5:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2460 (insn, operands);

        case 6:
          if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2487 (insn, operands);

        case 7:
          if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2514 (insn, operands);

        case 8:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2541 (insn, operands);

        case 9:
          if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2568 (insn, operands);

        case 10:
          if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2595 (insn, operands);

        case 11:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2622 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern531 (x2))
        {
        case 0:
          if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2328 (insn, operands);

        case 1:
          if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2355 (insn, operands);

        case 2:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2382 (insn, operands);

        case 3:
          if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2409 (insn, operands);

        case 4:
          if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2436 (insn, operands);

        case 5:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2463 (insn, operands);

        case 6:
          if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2490 (insn, operands);

        case 7:
          if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2517 (insn, operands);

        case 8:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2544 (insn, operands);

        case 9:
          if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2571 (insn, operands);

        case 10:
          if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2598 (insn, operands);

        case 11:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2625 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern531 (x2))
        {
        case 0:
          if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2331 (insn, operands);

        case 1:
          if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2358 (insn, operands);

        case 2:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2385 (insn, operands);

        case 3:
          if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2412 (insn, operands);

        case 4:
          if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2439 (insn, operands);

        case 5:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2466 (insn, operands);

        case 6:
          if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2493 (insn, operands);

        case 7:
          if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2520 (insn, operands);

        case 8:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2547 (insn, operands);

        case 9:
          if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2574 (insn, operands);

        case 10:
          if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2601 (insn, operands);

        case 11:
          if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2628 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_74 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      return split_72 (x1, insn);

    case IOR:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern533 (x2))
            {
            case 0:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1994 (insn, operands);

            case 1:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2021 (insn, operands);

            case 2:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2048 (insn, operands);

            case 3:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2075 (insn, operands);

            case 4:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2102 (insn, operands);

            case 5:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2129 (insn, operands);

            case 6:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2156 (insn, operands);

            case 7:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2183 (insn, operands);

            case 8:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2210 (insn, operands);

            case 9:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2237 (insn, operands);

            case 10:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2264 (insn, operands);

            case 11:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2291 (insn, operands);

            case 12:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1997 (insn, operands);

            case 13:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2024 (insn, operands);

            case 14:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2051 (insn, operands);

            case 15:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2078 (insn, operands);

            case 16:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2105 (insn, operands);

            case 17:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2132 (insn, operands);

            case 18:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2159 (insn, operands);

            case 19:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2186 (insn, operands);

            case 20:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2213 (insn, operands);

            case 21:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2240 (insn, operands);

            case 22:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2267 (insn, operands);

            case 23:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2294 (insn, operands);

            case 24:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2000 (insn, operands);

            case 25:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2027 (insn, operands);

            case 26:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2054 (insn, operands);

            case 27:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2081 (insn, operands);

            case 28:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2108 (insn, operands);

            case 29:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2135 (insn, operands);

            case 30:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2162 (insn, operands);

            case 31:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2189 (insn, operands);

            case 32:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2216 (insn, operands);

            case 33:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2243 (insn, operands);

            case 34:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2270 (insn, operands);

            case 35:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2297 (insn, operands);

            case 36:
              if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3068 (insn, operands);

            case 37:
              if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3077 (insn, operands);

            case 38:
              if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3086 (insn, operands);

            case 39:
              if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3095 (insn, operands);

            case 40:
              if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3104 (insn, operands);

            case 41:
              if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3113 (insn, operands);

            case 42:
              if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3122 (insn, operands);

            case 43:
              if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3131 (insn, operands);

            case 44:
              if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3140 (insn, operands);

            case 45:
              if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3149 (insn, operands);

            case 46:
              if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3158 (insn, operands);

            case 47:
              if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3167 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern534 (x2))
            {
            case 0:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2642 (insn, operands);

            case 1:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2669 (insn, operands);

            case 2:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2696 (insn, operands);

            case 3:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2723 (insn, operands);

            case 4:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2750 (insn, operands);

            case 5:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2777 (insn, operands);

            case 6:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2804 (insn, operands);

            case 7:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2831 (insn, operands);

            case 8:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2858 (insn, operands);

            case 9:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2885 (insn, operands);

            case 10:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2912 (insn, operands);

            case 11:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2939 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern534 (x2))
            {
            case 0:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2645 (insn, operands);

            case 1:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2672 (insn, operands);

            case 2:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2699 (insn, operands);

            case 3:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2726 (insn, operands);

            case 4:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2753 (insn, operands);

            case 5:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2780 (insn, operands);

            case 6:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2807 (insn, operands);

            case 7:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2834 (insn, operands);

            case 8:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2861 (insn, operands);

            case 9:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2888 (insn, operands);

            case 10:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2915 (insn, operands);

            case 11:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2942 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern534 (x2))
            {
            case 0:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2648 (insn, operands);

            case 1:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2675 (insn, operands);

            case 2:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2702 (insn, operands);

            case 3:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2729 (insn, operands);

            case 4:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2756 (insn, operands);

            case 5:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2783 (insn, operands);

            case 6:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2810 (insn, operands);

            case 7:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2837 (insn, operands);

            case 8:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2864 (insn, operands);

            case 9:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2891 (insn, operands);

            case 10:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2918 (insn, operands);

            case 11:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2945 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case XOR:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern533 (x2))
            {
            case 0:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2003 (insn, operands);

            case 1:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2030 (insn, operands);

            case 2:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2057 (insn, operands);

            case 3:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2084 (insn, operands);

            case 4:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2111 (insn, operands);

            case 5:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2138 (insn, operands);

            case 6:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2165 (insn, operands);

            case 7:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2192 (insn, operands);

            case 8:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2219 (insn, operands);

            case 9:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2246 (insn, operands);

            case 10:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2273 (insn, operands);

            case 11:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2300 (insn, operands);

            case 12:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2006 (insn, operands);

            case 13:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2033 (insn, operands);

            case 14:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2060 (insn, operands);

            case 15:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2087 (insn, operands);

            case 16:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2114 (insn, operands);

            case 17:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2141 (insn, operands);

            case 18:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2168 (insn, operands);

            case 19:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2195 (insn, operands);

            case 20:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2222 (insn, operands);

            case 21:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2249 (insn, operands);

            case 22:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2276 (insn, operands);

            case 23:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2303 (insn, operands);

            case 24:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2009 (insn, operands);

            case 25:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2036 (insn, operands);

            case 26:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2063 (insn, operands);

            case 27:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2090 (insn, operands);

            case 28:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2117 (insn, operands);

            case 29:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2144 (insn, operands);

            case 30:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2171 (insn, operands);

            case 31:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2198 (insn, operands);

            case 32:
              if (!(
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2225 (insn, operands);

            case 33:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2252 (insn, operands);

            case 34:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2279 (insn, operands);

            case 35:
              if (!((
#line 13839 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13851 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2306 (insn, operands);

            case 36:
              if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3071 (insn, operands);

            case 37:
              if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3080 (insn, operands);

            case 38:
              if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3089 (insn, operands);

            case 39:
              if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3098 (insn, operands);

            case 40:
              if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3107 (insn, operands);

            case 41:
              if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3116 (insn, operands);

            case 42:
              if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3125 (insn, operands);

            case 43:
              if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3134 (insn, operands);

            case 44:
              if (!(
#line 14008 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3143 (insn, operands);

            case 45:
              if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3152 (insn, operands);

            case 46:
              if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3161 (insn, operands);

            case 47:
              if (!((
#line 14008 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 14012 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3170 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern534 (x2))
            {
            case 0:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2651 (insn, operands);

            case 1:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2678 (insn, operands);

            case 2:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2705 (insn, operands);

            case 3:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2732 (insn, operands);

            case 4:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2759 (insn, operands);

            case 5:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2786 (insn, operands);

            case 6:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2813 (insn, operands);

            case 7:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2840 (insn, operands);

            case 8:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2867 (insn, operands);

            case 9:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2894 (insn, operands);

            case 10:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2921 (insn, operands);

            case 11:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2948 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern534 (x2))
            {
            case 0:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2654 (insn, operands);

            case 1:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2681 (insn, operands);

            case 2:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2708 (insn, operands);

            case 3:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2735 (insn, operands);

            case 4:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2762 (insn, operands);

            case 5:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2789 (insn, operands);

            case 6:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2816 (insn, operands);

            case 7:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2843 (insn, operands);

            case 8:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2870 (insn, operands);

            case 9:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2897 (insn, operands);

            case 10:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2924 (insn, operands);

            case 11:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2951 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern534 (x2))
            {
            case 0:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2657 (insn, operands);

            case 1:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2684 (insn, operands);

            case 2:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2711 (insn, operands);

            case 3:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2738 (insn, operands);

            case 4:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2765 (insn, operands);

            case 5:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2792 (insn, operands);

            case 6:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2819 (insn, operands);

            case 7:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2846 (insn, operands);

            case 8:
              if (!(
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2873 (insn, operands);

            case 9:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2900 (insn, operands);

            case 10:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2927 (insn, operands);

            case 11:
              if (!((
#line 13924 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2954 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
